# coding: utf-8

"""
    ############################################################################################
    ## This class subject to change without prior notice, Please dont use this class directly.##
    ############################################################################################
"""


from __future__ import absolute_import

# python 2 and python 3 compatibility library
import six

from orbipay_paymentsapi_client.api_client import ApiClient
from orbipay_paymentsapi_client.rest import ApiException
from orbipay_paymentsapi_client.configuration import Configuration


class CustomerAccountApi(object):

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def get_customer_account(self, channel, client_key, product, timestamp, idempotent_request_key, requestor_type, id_customer_account, id_customer, x_opay_headers, **kwargs):  # noqa: E501
        """Get Customer Account  # noqa: E501

        The Get Customer Account API is used to retrieve the details of a customer account based on the id.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> configuration = Configuration()
        >>> # configuration.secret = secret
        >>> # configuration.host = host
        >>> api_client = ApiClient(configuration=configuration)
        >>> api = CustomerAccountApi(api_client=api_client)
        >>> thread = api.get_customer_account(channel, client_key, product, timestamp, idempotent_request_key, requestor_type, id_customer_account, id_customer, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str channel: The channel through which the API is invoked. (required)
        :param str client_key: The unique identifier assigned by EBPP to the client. (required)
        :param str product: The product identifier corresponding to the API. (required)
        :param str timestamp: The timestamp for the moment when the API request is created. (required)
        :param str idempotent_request_key: The unique token that clients can generate and maintain in order to identify an API request. (required)
        :param str requestor_type: Type of the requestor of the API. (required)
        :param str id_customer_account: The unique identifier assigned by EBPP to the Customer Account. (required)
        :param str id_customer: The unique identifier assigned by EBPP to the customer. (required)
        :param str requestor: The identifier for the requestor of the API.
        :param str x_opay_headers: Intended for the future use.
        :param str trace_id: The unique reference that can be used for tracing and debugging an API call.
        :return: CustomerAccountResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_customer_account_with_http_info(channel, client_key, product, timestamp, idempotent_request_key, requestor_type, id_customer_account, id_customer, x_opay_headers, **kwargs)  # noqa: E501
        else:
            (data) = self.get_customer_account_with_http_info(channel, client_key, product, timestamp, idempotent_request_key, requestor_type, id_customer_account, id_customer, x_opay_headers, **kwargs)  # noqa: E501
            return data

    def get_customer_account_with_http_info(self, channel, client_key, product, timestamp, idempotent_request_key, requestor_type, id_customer_account, id_customer, x_opay_headers, **kwargs):  # noqa: E501
        """Get Customer Account  # noqa: E501

        The Get Customer Account API is used to retrieve the details of a customer account based on the id.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> configuration = Configuration()
        >>> # configuration.secret = secret
        >>> # configuration.host = host
        >>> api_client = ApiClient(configuration=configuration)
        >>> api = CustomerAccountApi(api_client=api_client)
        >>> thread = api.get_customer_account_with_http_info(channel, client_key, product, timestamp, idempotent_request_key, requestor_type, id_customer_account, id_customer, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str channel: The channel through which the API is invoked. (required)
        :param str client_key: The unique identifier assigned by EBPP to the client. (required)
        :param str product: The product identifier corresponding to the API. (required)
        :param str timestamp: The timestamp for the moment when the API request is created. (required)
        :param str idempotent_request_key: The unique token that clients can generate and maintain in order to identify an API request. (required)
        :param str requestor_type: Type of the requestor of the API. (required)
        :param str id_customer_account: The unique identifier assigned by EBPP to the Customer Account. (required)
        :param str id_customer: The unique identifier assigned by EBPP to the customer. (required)
        :param str requestor: The identifier for the requestor of the API.
        :param str x_opay_headers: Intended for the future use.
        :param str trace_id: The unique reference that can be used for tracing and debugging an API call.
        :return: CustomerAccountResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['channel', 'client_key', 'product', 'timestamp', 'idempotent_request_key', 'requestor_type', 'id_customer_account', 'id_customer', 'requestor', 'x_opay_headers', 'trace_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_customer_account" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}
        
        if 'id_customer_account' in params:
            path_params['ID_CUSTOMER_ACCOUNT'] = params['id_customer_account']  # noqa: E501
        if path_params['ID_CUSTOMER_ACCOUNT'] is None or path_params['ID_CUSTOMER_ACCOUNT'] == "":
            raise ApiException(status="0", reason="ID_CUSTOMER_ACCOUNT missing")

        if 'id_customer' in params:
            path_params['ID_CUSTOMER'] = params['id_customer']  # noqa: E501
        if path_params['ID_CUSTOMER'] is None or path_params['ID_CUSTOMER'] == "":
            raise ApiException(status="0", reason="ID_CUSTOMER missing")

        query_params = []

        header_params = {}
        if 'channel' in params:
            header_params['channel'] = params['channel']  # noqa: E501
        if 'client_key' in params:
            header_params['client_key'] = params['client_key']  # noqa: E501
        if 'product' in params:
            header_params['product'] = params['product']  # noqa: E501
        if 'timestamp' in params:
            header_params['timestamp'] = params['timestamp']  # noqa: E501
        if 'idempotent_request_key' in params:
            header_params['idempotent_request_key'] = params['idempotent_request_key']  # noqa: E501
        if 'requestor_type' in params:
            header_params['requestor_type'] = params['requestor_type']  # noqa: E501
        if 'requestor' in params:
            header_params['requestor'] = params['requestor']  # noqa: E501
        if 'x_opay_headers' in params:
            header_params['X-OPAY-Headers'] = params['x_opay_headers']  # noqa: E501
        if 'trace_id' in params:
            header_params['trace_id'] = params['trace_id']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = ApiClient.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/customers/{ID_CUSTOMER}/customeraccounts/{ID_CUSTOMER_ACCOUNT}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='CustomerAccountResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def renew_customer_account(self, channel, client_key, product, timestamp, idempotent_request_key, requestor_type, id_customer_account, id_customer, renew_customer_account_request, x_opay_headers, **kwargs):  # noqa: E501
        """Renew Customer Account  # noqa: E501

        This API is used to renew a customer account. The API migrates all the pending payments and active payment setups from the original customer account to the new one.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> configuration = Configuration()
        >>> # configuration.secret = secret
        >>> # configuration.host = host
        >>> api_client = ApiClient(configuration=configuration)
        >>> api = CustomerAccountApi(api_client=api_client)
        >>> thread = api.renew_customer_account(channel, client_key, product, timestamp, idempotent_request_key, requestor_type, id_customer_account, id_customer, renew_customer_account_request, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str channel: The channel through which the API is invoked. (required)
        :param str client_key: The unique identifier assigned by EBPP to the client. (required)
        :param str product: The product identifier corresponding to the API. (required)
        :param str timestamp: The timestamp for the moment when the API request is created. (required)
        :param str idempotent_request_key: The unique token that clients can generate and maintain in order to identify an API request. (required)
        :param str requestor_type: Type of the requestor of the API. (required)
        :param str id_customer_account: The unique identifier assigned by EBPP to the Customer Account. (required)
        :param str id_customer: The unique identifier assigned by EBPP to the customer. (required)
        :param RenewCustomerAccountRequest renew_customer_account_request: JSON containing all the attributes of the Customer account to be renewed. (required)
        :param str requestor: The identifier for the requestor of the API.
        :param str x_opay_headers: Intended for the future use.
        :param str trace_id: The unique reference that can be used for tracing and debugging an API call.
        :return: CustomerAccountResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.renew_customer_account_with_http_info(channel, client_key, product, timestamp, idempotent_request_key, requestor_type, id_customer_account, id_customer, renew_customer_account_request, x_opay_headers, **kwargs)  # noqa: E501
        else:
            (data) = self.renew_customer_account_with_http_info(channel, client_key, product, timestamp, idempotent_request_key, requestor_type, id_customer_account, id_customer, renew_customer_account_request, x_opay_headers, **kwargs)  # noqa: E501
            return data

    def renew_customer_account_with_http_info(self, channel, client_key, product, timestamp, idempotent_request_key, requestor_type, id_customer_account, id_customer, renew_customer_account_request, x_opay_headers, **kwargs):  # noqa: E501
        """Renew Customer Account  # noqa: E501

        This API is used to renew a customer account. The API migrates all the pending payments and active payment setups from the original customer account to the new one.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> configuration = Configuration()
        >>> # configuration.secret = secret
        >>> # configuration.host = host
        >>> api_client = ApiClient(configuration=configuration)
        >>> api = CustomerAccountApi(api_client=api_client)
        >>> thread = api.renew_customer_account_with_http_info(channel, client_key, product, timestamp, idempotent_request_key, requestor_type, id_customer_account, id_customer, renew_customer_account_request, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str channel: The channel through which the API is invoked. (required)
        :param str client_key: The unique identifier assigned by EBPP to the client. (required)
        :param str product: The product identifier corresponding to the API. (required)
        :param str timestamp: The timestamp for the moment when the API request is created. (required)
        :param str idempotent_request_key: The unique token that clients can generate and maintain in order to identify an API request. (required)
        :param str requestor_type: Type of the requestor of the API. (required)
        :param str id_customer_account: The unique identifier assigned by EBPP to the Customer Account. (required)
        :param str id_customer: The unique identifier assigned by EBPP to the customer. (required)
        :param RenewCustomerAccountRequest renew_customer_account_request: JSON containing all the attributes of the Customer account to be renewed. (required)
        :param str requestor: The identifier for the requestor of the API.
        :param str x_opay_headers: Intended for the future use.
        :param str trace_id: The unique reference that can be used for tracing and debugging an API call.
        :return: CustomerAccountResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['channel', 'client_key', 'product', 'timestamp', 'idempotent_request_key', 'requestor_type', 'id_customer_account', 'id_customer', 'renew_customer_account_request', 'requestor', 'x_opay_headers', 'trace_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method renew_customer_account" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}
        
        if 'id_customer_account' in params:
            path_params['ID_CUSTOMER_ACCOUNT'] = params['id_customer_account']  # noqa: E501
        if path_params['ID_CUSTOMER_ACCOUNT'] is None or path_params['ID_CUSTOMER_ACCOUNT'] == "":
            raise ApiException(status="0", reason="ID_CUSTOMER_ACCOUNT missing")

        if 'id_customer' in params:
            path_params['ID_CUSTOMER'] = params['id_customer']  # noqa: E501
        if path_params['ID_CUSTOMER'] is None or path_params['ID_CUSTOMER'] == "":
            raise ApiException(status="0", reason="ID_CUSTOMER missing")

        query_params = []

        header_params = {}
        if 'channel' in params:
            header_params['channel'] = params['channel']  # noqa: E501
        if 'client_key' in params:
            header_params['client_key'] = params['client_key']  # noqa: E501
        if 'product' in params:
            header_params['product'] = params['product']  # noqa: E501
        if 'timestamp' in params:
            header_params['timestamp'] = params['timestamp']  # noqa: E501
        if 'idempotent_request_key' in params:
            header_params['idempotent_request_key'] = params['idempotent_request_key']  # noqa: E501
        if 'requestor_type' in params:
            header_params['requestor_type'] = params['requestor_type']  # noqa: E501
        if 'requestor' in params:
            header_params['requestor'] = params['requestor']  # noqa: E501
        if 'x_opay_headers' in params:
            header_params['X-OPAY-Headers'] = params['x_opay_headers']  # noqa: E501
        if 'trace_id' in params:
            header_params['trace_id'] = params['trace_id']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'renew_customer_account_request' in params:
            body_params = params['renew_customer_account_request']
        # HTTP header `Accept`
        header_params['Accept'] = ApiClient.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = ApiClient.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/customers/{ID_CUSTOMER}/customeraccounts/{ID_CUSTOMER_ACCOUNT}/renew', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='CustomerAccountResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def retrieve_customer_accounts(self, channel, client_key, product, timestamp, idempotent_request_key, requestor_type, id_customer, x_opay_headers, **kwargs):  # noqa: E501
        """Retrieve Customer Accounts  # noqa: E501

        The API is used to retrieve all the customer accounts associated with a customer. The accounts can be filtered using the account number, status. The API responds with the first page of the list of customerAccounts matching the criteria. The results are sorted in descending order of the last_modified_time.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> configuration = Configuration()
        >>> # configuration.secret = secret
        >>> # configuration.host = host
        >>> api_client = ApiClient(configuration=configuration)
        >>> api = CustomerAccountApi(api_client=api_client)
        >>> thread = api.retrieve_customer_accounts(channel, client_key, product, timestamp, idempotent_request_key, requestor_type, id_customer, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str channel: The channel through which the API is invoked. (required)
        :param str client_key: The unique identifier assigned by EBPP to the client. (required)
        :param str product: The product identifier corresponding to the API. (required)
        :param str timestamp: The timestamp for the moment when the API request is created. (required)
        :param str idempotent_request_key: The unique token that clients can generate and maintain in order to identify an API request. (required)
        :param str requestor_type: Type of the requestor of the API. (required)
        :param str id_customer: The unique identifier assigned by EBPP to the customer. (required)
        :param str requestor: The identifier for the requestor of the API.
        :param str x_opay_headers: Intended for the future use.
        :param str trace_id: The unique reference that can be used for tracing and debugging an API call.
        :param str page_size: The maximum number of objects returned in the query.
        :param str account_number: The Account Number to get details of.
        :param list[str] status: The status of the customer's account in EBPP. This can take multiple values in the format key=value1&key=value2.... 
        :return: CustomerAccountsResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.retrieve_customer_accounts_with_http_info(channel, client_key, product, timestamp, idempotent_request_key, requestor_type, id_customer, x_opay_headers, **kwargs)  # noqa: E501
        else:
            (data) = self.retrieve_customer_accounts_with_http_info(channel, client_key, product, timestamp, idempotent_request_key, requestor_type, id_customer, x_opay_headers, **kwargs)  # noqa: E501
            return data

    def retrieve_customer_accounts_with_http_info(self, channel, client_key, product, timestamp, idempotent_request_key, requestor_type, id_customer, x_opay_headers, **kwargs):  # noqa: E501
        """Retrieve Customer Accounts  # noqa: E501

        The API is used to retrieve all the customer accounts associated with a customer. The accounts can be filtered using the account number, status. The API responds with the first page of the list of customerAccounts matching the criteria. The results are sorted in descending order of the last_modified_time.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> configuration = Configuration()
        >>> # configuration.secret = secret
        >>> # configuration.host = host
        >>> api_client = ApiClient(configuration=configuration)
        >>> api = CustomerAccountApi(api_client=api_client)
        >>> thread = api.retrieve_customer_accounts_with_http_info(channel, client_key, product, timestamp, idempotent_request_key, requestor_type, id_customer, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str channel: The channel through which the API is invoked. (required)
        :param str client_key: The unique identifier assigned by EBPP to the client. (required)
        :param str product: The product identifier corresponding to the API. (required)
        :param str timestamp: The timestamp for the moment when the API request is created. (required)
        :param str idempotent_request_key: The unique token that clients can generate and maintain in order to identify an API request. (required)
        :param str requestor_type: Type of the requestor of the API. (required)
        :param str id_customer: The unique identifier assigned by EBPP to the customer. (required)
        :param str requestor: The identifier for the requestor of the API.
        :param str x_opay_headers: Intended for the future use.
        :param str trace_id: The unique reference that can be used for tracing and debugging an API call.
        :param str page_size: The maximum number of objects returned in the query.
        :param str account_number: The Account Number to get details of.
        :param list[str] status: The status of the customer's account in EBPP. This can take multiple values in the format key=value1&key=value2.... 
        :return: CustomerAccountsResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['channel', 'client_key', 'product', 'timestamp', 'idempotent_request_key', 'requestor_type', 'id_customer', 'requestor', 'x_opay_headers', 'trace_id', 'page_size', 'account_number', 'status']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method retrieve_customer_accounts" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}
        
        if 'id_customer' in params:
            path_params['ID_CUSTOMER'] = params['id_customer']  # noqa: E501
        if path_params['ID_CUSTOMER'] is None or path_params['ID_CUSTOMER'] == "":
            raise ApiException(status="0", reason="ID_CUSTOMER missing")

        query_params = []
        if 'page_size' in params:
            query_params.append(('page_size', params['page_size']))  # noqa: E501

        header_params = {}
        if 'channel' in params:
            header_params['channel'] = params['channel']  # noqa: E501
        if 'client_key' in params:
            header_params['client_key'] = params['client_key']  # noqa: E501
        if 'product' in params:
            header_params['product'] = params['product']  # noqa: E501
        if 'timestamp' in params:
            header_params['timestamp'] = params['timestamp']  # noqa: E501
        if 'idempotent_request_key' in params:
            header_params['idempotent_request_key'] = params['idempotent_request_key']  # noqa: E501
        if 'requestor_type' in params:
            header_params['requestor_type'] = params['requestor_type']  # noqa: E501
        if 'requestor' in params:
            header_params['requestor'] = params['requestor']  # noqa: E501
        if 'x_opay_headers' in params:
            header_params['X-OPAY-Headers'] = params['x_opay_headers']  # noqa: E501
        if 'trace_id' in params:
            header_params['trace_id'] = params['trace_id']  # noqa: E501

        form_params = []
        local_var_files = {}
        if 'account_number' in params:
            form_params.append(('account_number', params['account_number']))  # noqa: E501
        if 'status' in params:
            form_params.append(('status', params['status']))  # noqa: E501
            collection_formats['status'] = 'multi'  # noqa: E501

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = ApiClient.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = ApiClient.select_header_content_type(  # noqa: E501
            ['application/x-www-form-urlencoded'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/customers/{ID_CUSTOMER}/customeraccounts/lists', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='CustomerAccountsResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def retrieve_customer_accounts_page(self, channel, client_key, product, timestamp, idempotent_request_key, requestor_type, id_customer, query_id, x_opay_headers, **kwargs):  # noqa: E501
        """Retrieve Customer Accounts Pagination  # noqa: E501

        This API is used to paginate through the list of customer Accounts returned in the Retrieve Customer Accounts API.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> configuration = Configuration()
        >>> # configuration.secret = secret
        >>> # configuration.host = host
        >>> api_client = ApiClient(configuration=configuration)
        >>> api = CustomerAccountApi(api_client=api_client)
        >>> thread = api.retrieve_customer_accounts_page(channel, client_key, product, timestamp, idempotent_request_key, requestor_type, id_customer, query_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str channel: The channel through which the API is invoked. (required)
        :param str client_key: The unique identifier assigned by EBPP to the client. (required)
        :param str product: The product identifier corresponding to the API. (required)
        :param str timestamp: The timestamp for the moment when the API request is created. (required)
        :param str idempotent_request_key: The unique token that clients can generate and maintain in order to identify an API request. (required)
        :param str requestor_type: Type of the requestor of the API. (required)
        :param str id_customer: The unique identifier assigned by EBPP to the customer. (required)
        :param str query_id: query id of the Retrieve/Search Accounts lookup. (required)
        :param str requestor: The identifier for the requestor of the API.
        :param str x_opay_headers: Intended for the future use.
        :param str trace_id: The unique reference that can be used for tracing and debugging an API call.
        :param str page_size: The maximum number of objects returned in the query.
        :param str from_index: To fetch the next set of objects that start after this object
        :param str to_index: To fetch the previous set of objects that end at this object
        :return: CustomerAccountsResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.retrieve_customer_accounts_page_with_http_info(channel, client_key, product, timestamp, idempotent_request_key, requestor_type, id_customer, query_id, x_opay_headers, **kwargs)  # noqa: E501
        else:
            (data) = self.retrieve_customer_accounts_page_with_http_info(channel, client_key, product, timestamp, idempotent_request_key, requestor_type, id_customer, query_id, x_opay_headers, **kwargs)  # noqa: E501
            return data

    def retrieve_customer_accounts_page_with_http_info(self, channel, client_key, product, timestamp, idempotent_request_key, requestor_type, id_customer, query_id, x_opay_headers, **kwargs):  # noqa: E501
        """Retrieve Customer Accounts Pagination  # noqa: E501

        This API is used to paginate through the list of customer Accounts returned in the Retrieve Customer Accounts API.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> configuration = Configuration()
        >>> # configuration.secret = secret
        >>> # configuration.host = host
        >>> api_client = ApiClient(configuration=configuration)
        >>> api = CustomerAccountApi(api_client=api_client)
        >>> thread = api.retrieve_customer_accounts_page_with_http_info(channel, client_key, product, timestamp, idempotent_request_key, requestor_type, id_customer, query_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str channel: The channel through which the API is invoked. (required)
        :param str client_key: The unique identifier assigned by EBPP to the client. (required)
        :param str product: The product identifier corresponding to the API. (required)
        :param str timestamp: The timestamp for the moment when the API request is created. (required)
        :param str idempotent_request_key: The unique token that clients can generate and maintain in order to identify an API request. (required)
        :param str requestor_type: Type of the requestor of the API. (required)
        :param str id_customer: The unique identifier assigned by EBPP to the customer. (required)
        :param str query_id: query id of the Retrieve/Search Accounts lookup. (required)
        :param str requestor: The identifier for the requestor of the API.
        :param str x_opay_headers: Intended for the future use.
        :param str trace_id: The unique reference that can be used for tracing and debugging an API call.
        :param str page_size: The maximum number of objects returned in the query.
        :param str from_index: To fetch the next set of objects that start after this object
        :param str to_index: To fetch the previous set of objects that end at this object
        :return: CustomerAccountsResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['channel', 'client_key', 'product', 'timestamp', 'idempotent_request_key', 'requestor_type', 'id_customer', 'query_id', 'requestor', 'x_opay_headers', 'trace_id', 'page_size', 'from_index', 'to_index']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method retrieve_customer_accounts_page" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}
        
        if 'id_customer' in params:
            path_params['ID_CUSTOMER'] = params['id_customer']  # noqa: E501
        if path_params['ID_CUSTOMER'] is None or path_params['ID_CUSTOMER'] == "":
            raise ApiException(status="0", reason="ID_CUSTOMER missing")

        query_params = []
        if 'page_size' in params:
            query_params.append(('page_size', params['page_size']))  # noqa: E501
        if 'query_id' in params:
            query_params.append(('query_id', params['query_id']))  # noqa: E501
        if 'from_index' in params:
            query_params.append(('from_index', params['from_index']))  # noqa: E501
        if 'to_index' in params:
            query_params.append(('to_index', params['to_index']))  # noqa: E501

        header_params = {}
        if 'channel' in params:
            header_params['channel'] = params['channel']  # noqa: E501
        if 'client_key' in params:
            header_params['client_key'] = params['client_key']  # noqa: E501
        if 'product' in params:
            header_params['product'] = params['product']  # noqa: E501
        if 'timestamp' in params:
            header_params['timestamp'] = params['timestamp']  # noqa: E501
        if 'idempotent_request_key' in params:
            header_params['idempotent_request_key'] = params['idempotent_request_key']  # noqa: E501
        if 'requestor_type' in params:
            header_params['requestor_type'] = params['requestor_type']  # noqa: E501
        if 'requestor' in params:
            header_params['requestor'] = params['requestor']  # noqa: E501
        if 'x_opay_headers' in params:
            header_params['X-OPAY-Headers'] = params['x_opay_headers']  # noqa: E501
        if 'trace_id' in params:
            header_params['trace_id'] = params['trace_id']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = ApiClient.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/customers/{ID_CUSTOMER}/customeraccounts/lists', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='CustomerAccountsResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
