# coding: utf-8

"""
    ############################################################################################
    ## This class subject to change without prior notice, Please dont use this class directly.##
    ############################################################################################
"""


from __future__ import absolute_import

# python 2 and python 3 compatibility library
import six

from orbipay_paymentsapi_client.api_client import ApiClient
from orbipay_paymentsapi_client.rest import ApiException
from orbipay_paymentsapi_client.configuration import Configuration


class FundingAccountApi(object):

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def add_funding_account(self, channel, client_key, product, timestamp, idempotent_request_key, requestor_type, id_customer, add_funding_account_request, x_opay_headers, **kwargs):  # noqa: E501
        """Add Funding Account  # noqa: E501

        This API is used to add a funding account for the customer. The funding account is available for servicing all the customer accounts the customer holds. An exhaustive set of account types are supported as funding accounts as indicated in the field account_subtype. ABA routing number and account sub-type are mandatory for bank accounts. Expiry date, address fields and Card CVV are required for card accounts.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> configuration = Configuration()
        >>> # configuration.secret = secret
        >>> # configuration.host = host
        >>> api_client = ApiClient(configuration=configuration)
        >>> api = FundingAccountApi(api_client=api_client)
        >>> thread = api.add_funding_account(channel, client_key, product, timestamp, idempotent_request_key, requestor_type, id_customer, add_funding_account_request, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str channel: The channel through which the API is invoked. (required)
        :param str client_key: The unique identifier assigned by EBPP to the client. (required)
        :param str product: The product identifier corresponding to the API. (required)
        :param str timestamp: The timestamp for the moment when the API request is created. (required)
        :param str idempotent_request_key: The unique token that clients can generate and maintain in order to identify an API request. (required)
        :param str requestor_type: Type of the requestor of the API. (required)
        :param str id_customer: The unique identifier assigned by EBPP to the customer. (required)
        :param AddFundingAccountRequest add_funding_account_request: JSON containing all the attributes of the Funding account to be added to customer. (required)
        :param str requestor: The identifier for the requestor of the API.
        :param str x_opay_headers: Intended for the future use.
        :param str trace_id: The unique reference that can be used for tracing and debugging an API call.
        :return: FundingAccountResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.add_funding_account_with_http_info(channel, client_key, product, timestamp, idempotent_request_key, requestor_type, id_customer, add_funding_account_request, x_opay_headers, **kwargs)  # noqa: E501
        else:
            (data) = self.add_funding_account_with_http_info(channel, client_key, product, timestamp, idempotent_request_key, requestor_type, id_customer, add_funding_account_request, x_opay_headers, **kwargs)  # noqa: E501
            return data

    def add_funding_account_with_http_info(self, channel, client_key, product, timestamp, idempotent_request_key, requestor_type, id_customer, add_funding_account_request, x_opay_headers, **kwargs):  # noqa: E501
        """Add Funding Account  # noqa: E501

        This API is used to add a funding account for the customer. The funding account is available for servicing all the customer accounts the customer holds. An exhaustive set of account types are supported as funding accounts as indicated in the field account_subtype. ABA routing number and account sub-type are mandatory for bank accounts. Expiry date, address fields and Card CVV are required for card accounts.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> configuration = Configuration()
        >>> # configuration.secret = secret
        >>> # configuration.host = host
        >>> api_client = ApiClient(configuration=configuration)
        >>> api = FundingAccountApi(api_client=api_client)
        >>> thread = api.add_funding_account_with_http_info(channel, client_key, product, timestamp, idempotent_request_key, requestor_type, id_customer, add_funding_account_request, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str channel: The channel through which the API is invoked. (required)
        :param str client_key: The unique identifier assigned by EBPP to the client. (required)
        :param str product: The product identifier corresponding to the API. (required)
        :param str timestamp: The timestamp for the moment when the API request is created. (required)
        :param str idempotent_request_key: The unique token that clients can generate and maintain in order to identify an API request. (required)
        :param str requestor_type: Type of the requestor of the API. (required)
        :param str id_customer: The unique identifier assigned by EBPP to the customer. (required)
        :param AddFundingAccountRequest add_funding_account_request: JSON containing all the attributes of the Funding account to be added to customer. (required)
        :param str requestor: The identifier for the requestor of the API.
        :param str x_opay_headers: Intended for the future use.
        :param str trace_id: The unique reference that can be used for tracing and debugging an API call.
        :return: FundingAccountResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['channel', 'client_key', 'product', 'timestamp', 'idempotent_request_key', 'requestor_type', 'id_customer', 'add_funding_account_request', 'requestor', 'x_opay_headers', 'trace_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method add_funding_account" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}
        
        if 'id_customer' in params:
            path_params['ID_CUSTOMER'] = params['id_customer']  # noqa: E501
        if path_params['ID_CUSTOMER'] is None or path_params['ID_CUSTOMER'] == "":
            raise ApiException(status="0", reason="ID_CUSTOMER missing")

        query_params = []

        header_params = {}
        if 'channel' in params:
            header_params['channel'] = params['channel']  # noqa: E501
        if 'client_key' in params:
            header_params['client_key'] = params['client_key']  # noqa: E501
        if 'product' in params:
            header_params['product'] = params['product']  # noqa: E501
        if 'timestamp' in params:
            header_params['timestamp'] = params['timestamp']  # noqa: E501
        if 'idempotent_request_key' in params:
            header_params['idempotent_request_key'] = params['idempotent_request_key']  # noqa: E501
        if 'requestor_type' in params:
            header_params['requestor_type'] = params['requestor_type']  # noqa: E501
        if 'requestor' in params:
            header_params['requestor'] = params['requestor']  # noqa: E501
        if 'x_opay_headers' in params:
            header_params['X-OPAY-Headers'] = params['x_opay_headers']  # noqa: E501
        if 'trace_id' in params:
            header_params['trace_id'] = params['trace_id']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'add_funding_account_request' in params:
            body_params = params['add_funding_account_request']
        # HTTP header `Accept`
        header_params['Accept'] = ApiClient.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = ApiClient.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/customers/{ID_CUSTOMER}/fundingaccounts', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='FundingAccountResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def delete_funding_account(self, channel, client_key, product, timestamp, idempotent_request_key, requestor_type, id_funding_account, id_customer, delete_funding_account_request, x_opay_headers, **kwargs):  # noqa: E501
        """Delete Funding Account  # noqa: E501

        The Delete Funding Account API is used to delete the funding account of a customer. All pending payments made with that account are cancelled upon deletion of the funding account.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> configuration = Configuration()
        >>> # configuration.secret = secret
        >>> # configuration.host = host
        >>> api_client = ApiClient(configuration=configuration)
        >>> api = FundingAccountApi(api_client=api_client)
        >>> thread = api.delete_funding_account(channel, client_key, product, timestamp, idempotent_request_key, requestor_type, id_funding_account, id_customer, delete_funding_account_request, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str channel: The channel through which the API is invoked. (required)
        :param str client_key: The unique identifier assigned by EBPP to the client. (required)
        :param str product: The product identifier corresponding to the API. (required)
        :param str timestamp: The timestamp for the moment when the API request is created. (required)
        :param str idempotent_request_key: The unique token that clients can generate and maintain in order to identify an API request. (required)
        :param str requestor_type: Type of the requestor of the API. (required)
        :param str id_funding_account: The unique identifier assigned by EBPP to the Funding Account. (required)
        :param str id_customer: The unique identifier assigned by EBPP to the customer. (required)
        :param DeleteFundingAccountRequest delete_funding_account_request: Details of account to be deleted. (required)
        :param str requestor: The identifier for the requestor of the API.
        :param str x_opay_headers: Intended for the future use.
        :param str trace_id: The unique reference that can be used for tracing and debugging an API call.
        :return: DeleteResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.delete_funding_account_with_http_info(channel, client_key, product, timestamp, idempotent_request_key, requestor_type, id_funding_account, id_customer, delete_funding_account_request, x_opay_headers, **kwargs)  # noqa: E501
        else:
            (data) = self.delete_funding_account_with_http_info(channel, client_key, product, timestamp, idempotent_request_key, requestor_type, id_funding_account, id_customer, delete_funding_account_request, x_opay_headers, **kwargs)  # noqa: E501
            return data

    def delete_funding_account_with_http_info(self, channel, client_key, product, timestamp, idempotent_request_key, requestor_type, id_funding_account, id_customer, delete_funding_account_request, x_opay_headers, **kwargs):  # noqa: E501
        """Delete Funding Account  # noqa: E501

        The Delete Funding Account API is used to delete the funding account of a customer. All pending payments made with that account are cancelled upon deletion of the funding account.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> configuration = Configuration()
        >>> # configuration.secret = secret
        >>> # configuration.host = host
        >>> api_client = ApiClient(configuration=configuration)
        >>> api = FundingAccountApi(api_client=api_client)
        >>> thread = api.delete_funding_account_with_http_info(channel, client_key, product, timestamp, idempotent_request_key, requestor_type, id_funding_account, id_customer, delete_funding_account_request, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str channel: The channel through which the API is invoked. (required)
        :param str client_key: The unique identifier assigned by EBPP to the client. (required)
        :param str product: The product identifier corresponding to the API. (required)
        :param str timestamp: The timestamp for the moment when the API request is created. (required)
        :param str idempotent_request_key: The unique token that clients can generate and maintain in order to identify an API request. (required)
        :param str requestor_type: Type of the requestor of the API. (required)
        :param str id_funding_account: The unique identifier assigned by EBPP to the Funding Account. (required)
        :param str id_customer: The unique identifier assigned by EBPP to the customer. (required)
        :param DeleteFundingAccountRequest delete_funding_account_request: Details of account to be deleted. (required)
        :param str requestor: The identifier for the requestor of the API.
        :param str x_opay_headers: Intended for the future use.
        :param str trace_id: The unique reference that can be used for tracing and debugging an API call.
        :return: DeleteResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['channel', 'client_key', 'product', 'timestamp', 'idempotent_request_key', 'requestor_type', 'id_funding_account', 'id_customer', 'delete_funding_account_request', 'requestor', 'x_opay_headers', 'trace_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_funding_account" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}
        
        if 'id_funding_account' in params:
            path_params['ID_FUNDING_ACCOUNT'] = params['id_funding_account']  # noqa: E501
        if path_params['ID_FUNDING_ACCOUNT'] is None or path_params['ID_FUNDING_ACCOUNT'] == "":
            raise ApiException(status="0", reason="ID_FUNDING_ACCOUNT missing")

        if 'id_customer' in params:
            path_params['ID_CUSTOMER'] = params['id_customer']  # noqa: E501
        if path_params['ID_CUSTOMER'] is None or path_params['ID_CUSTOMER'] == "":
            raise ApiException(status="0", reason="ID_CUSTOMER missing")

        query_params = []

        header_params = {}
        if 'channel' in params:
            header_params['channel'] = params['channel']  # noqa: E501
        if 'client_key' in params:
            header_params['client_key'] = params['client_key']  # noqa: E501
        if 'product' in params:
            header_params['product'] = params['product']  # noqa: E501
        if 'timestamp' in params:
            header_params['timestamp'] = params['timestamp']  # noqa: E501
        if 'idempotent_request_key' in params:
            header_params['idempotent_request_key'] = params['idempotent_request_key']  # noqa: E501
        if 'requestor_type' in params:
            header_params['requestor_type'] = params['requestor_type']  # noqa: E501
        if 'requestor' in params:
            header_params['requestor'] = params['requestor']  # noqa: E501
        if 'x_opay_headers' in params:
            header_params['X-OPAY-Headers'] = params['x_opay_headers']  # noqa: E501
        if 'trace_id' in params:
            header_params['trace_id'] = params['trace_id']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'delete_funding_account_request' in params:
            body_params = params['delete_funding_account_request']
        # HTTP header `Accept`
        header_params['Accept'] = ApiClient.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = ApiClient.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/customers/{ID_CUSTOMER}/fundingaccounts/{ID_FUNDING_ACCOUNT}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='DeleteResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_funding_account(self, channel, client_key, product, timestamp, idempotent_request_key, requestor_type, id_funding_account, id_customer, x_opay_headers, **kwargs):  # noqa: E501
        """Get Funding Account  # noqa: E501

        The Get Funding Account API is used to retrieve the details of the funding account based on the id.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> configuration = Configuration()
        >>> # configuration.secret = secret
        >>> # configuration.host = host
        >>> api_client = ApiClient(configuration=configuration)
        >>> api = FundingAccountApi(api_client=api_client)
        >>> thread = api.get_funding_account(channel, client_key, product, timestamp, idempotent_request_key, requestor_type, id_funding_account, id_customer, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str channel: The channel through which the API is invoked. (required)
        :param str client_key: The unique identifier assigned by EBPP to the client. (required)
        :param str product: The product identifier corresponding to the API. (required)
        :param str timestamp: The timestamp for the moment when the API request is created. (required)
        :param str idempotent_request_key: The unique token that clients can generate and maintain in order to identify an API request. (required)
        :param str requestor_type: Type of the requestor of the API. (required)
        :param str id_funding_account: The unique identifier assigned by EBPP to the Funding Account. (required)
        :param str id_customer: The unique identifier assigned by EBPP to the customer. (required)
        :param str requestor: The identifier for the requestor of the API.
        :param str x_opay_headers: Intended for the future use.
        :param str trace_id: The unique reference that can be used for tracing and debugging an API call.
        :return: FundingAccountResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_funding_account_with_http_info(channel, client_key, product, timestamp, idempotent_request_key, requestor_type, id_funding_account, id_customer, x_opay_headers, **kwargs)  # noqa: E501
        else:
            (data) = self.get_funding_account_with_http_info(channel, client_key, product, timestamp, idempotent_request_key, requestor_type, id_funding_account, id_customer, x_opay_headers, **kwargs)  # noqa: E501
            return data

    def get_funding_account_with_http_info(self, channel, client_key, product, timestamp, idempotent_request_key, requestor_type, id_funding_account, id_customer, x_opay_headers, **kwargs):  # noqa: E501
        """Get Funding Account  # noqa: E501

        The Get Funding Account API is used to retrieve the details of the funding account based on the id.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> configuration = Configuration()
        >>> # configuration.secret = secret
        >>> # configuration.host = host
        >>> api_client = ApiClient(configuration=configuration)
        >>> api = FundingAccountApi(api_client=api_client)
        >>> thread = api.get_funding_account_with_http_info(channel, client_key, product, timestamp, idempotent_request_key, requestor_type, id_funding_account, id_customer, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str channel: The channel through which the API is invoked. (required)
        :param str client_key: The unique identifier assigned by EBPP to the client. (required)
        :param str product: The product identifier corresponding to the API. (required)
        :param str timestamp: The timestamp for the moment when the API request is created. (required)
        :param str idempotent_request_key: The unique token that clients can generate and maintain in order to identify an API request. (required)
        :param str requestor_type: Type of the requestor of the API. (required)
        :param str id_funding_account: The unique identifier assigned by EBPP to the Funding Account. (required)
        :param str id_customer: The unique identifier assigned by EBPP to the customer. (required)
        :param str requestor: The identifier for the requestor of the API.
        :param str x_opay_headers: Intended for the future use.
        :param str trace_id: The unique reference that can be used for tracing and debugging an API call.
        :return: FundingAccountResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['channel', 'client_key', 'product', 'timestamp', 'idempotent_request_key', 'requestor_type', 'id_funding_account', 'id_customer', 'requestor', 'x_opay_headers', 'trace_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_funding_account" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}
        
        if 'id_funding_account' in params:
            path_params['ID_FUNDING_ACCOUNT'] = params['id_funding_account']  # noqa: E501
        if path_params['ID_FUNDING_ACCOUNT'] is None or path_params['ID_FUNDING_ACCOUNT'] == "":
            raise ApiException(status="0", reason="ID_FUNDING_ACCOUNT missing")

        if 'id_customer' in params:
            path_params['ID_CUSTOMER'] = params['id_customer']  # noqa: E501
        if path_params['ID_CUSTOMER'] is None or path_params['ID_CUSTOMER'] == "":
            raise ApiException(status="0", reason="ID_CUSTOMER missing")

        query_params = []

        header_params = {}
        if 'channel' in params:
            header_params['channel'] = params['channel']  # noqa: E501
        if 'client_key' in params:
            header_params['client_key'] = params['client_key']  # noqa: E501
        if 'product' in params:
            header_params['product'] = params['product']  # noqa: E501
        if 'timestamp' in params:
            header_params['timestamp'] = params['timestamp']  # noqa: E501
        if 'idempotent_request_key' in params:
            header_params['idempotent_request_key'] = params['idempotent_request_key']  # noqa: E501
        if 'requestor_type' in params:
            header_params['requestor_type'] = params['requestor_type']  # noqa: E501
        if 'requestor' in params:
            header_params['requestor'] = params['requestor']  # noqa: E501
        if 'x_opay_headers' in params:
            header_params['X-OPAY-Headers'] = params['x_opay_headers']  # noqa: E501
        if 'trace_id' in params:
            header_params['trace_id'] = params['trace_id']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = ApiClient.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/customers/{ID_CUSTOMER}/fundingaccounts/{ID_FUNDING_ACCOUNT}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='FundingAccountResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def replace_funding_account(self, channel, client_key, product, timestamp, idempotent_request_key, requestor_type, id_funding_account, id_customer, replace_funding_account_request, x_opay_headers, **kwargs):  # noqa: E501
        """Replace Funding Account  # noqa: E501

        The API is used to replace the funding account details. The type of the funding account cannot be replaced. In other words, a card account cannot be replaced to a bank account and vice versa. CVV is mandatory to make any change to a card account.Replacing a funding account updates the account information on all pending payments made using that account but does not change the details on payments that have been completed.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> configuration = Configuration()
        >>> # configuration.secret = secret
        >>> # configuration.host = host
        >>> api_client = ApiClient(configuration=configuration)
        >>> api = FundingAccountApi(api_client=api_client)
        >>> thread = api.replace_funding_account(channel, client_key, product, timestamp, idempotent_request_key, requestor_type, id_funding_account, id_customer, replace_funding_account_request, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str channel: The channel through which the API is invoked. (required)
        :param str client_key: The unique identifier assigned by EBPP to the client. (required)
        :param str product: The product identifier corresponding to the API. (required)
        :param str timestamp: The timestamp for the moment when the API request is created. (required)
        :param str idempotent_request_key: The unique token that clients can generate and maintain in order to identify an API request. (required)
        :param str requestor_type: Type of the requestor of the API. (required)
        :param str id_funding_account: The unique identifier assigned by EBPP to the Funding Account. (required)
        :param str id_customer: The unique identifier assigned by EBPP to the customer. (required)
        :param ReplaceFundingAccountRequest replace_funding_account_request: JSON containing all the attributes of the Funding account to be replaced. (required)
        :param str requestor: The identifier for the requestor of the API.
        :param str x_opay_headers: Intended for the future use.
        :param str trace_id: The unique reference that can be used for tracing and debugging an API call.
        :return: FundingAccountResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.replace_funding_account_with_http_info(channel, client_key, product, timestamp, idempotent_request_key, requestor_type, id_funding_account, id_customer, replace_funding_account_request, x_opay_headers, **kwargs)  # noqa: E501
        else:
            (data) = self.replace_funding_account_with_http_info(channel, client_key, product, timestamp, idempotent_request_key, requestor_type, id_funding_account, id_customer, replace_funding_account_request, x_opay_headers, **kwargs)  # noqa: E501
            return data

    def replace_funding_account_with_http_info(self, channel, client_key, product, timestamp, idempotent_request_key, requestor_type, id_funding_account, id_customer, replace_funding_account_request, x_opay_headers, **kwargs):  # noqa: E501
        """Replace Funding Account  # noqa: E501

        The API is used to replace the funding account details. The type of the funding account cannot be replaced. In other words, a card account cannot be replaced to a bank account and vice versa. CVV is mandatory to make any change to a card account.Replacing a funding account updates the account information on all pending payments made using that account but does not change the details on payments that have been completed.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> configuration = Configuration()
        >>> # configuration.secret = secret
        >>> # configuration.host = host
        >>> api_client = ApiClient(configuration=configuration)
        >>> api = FundingAccountApi(api_client=api_client)
        >>> thread = api.replace_funding_account_with_http_info(channel, client_key, product, timestamp, idempotent_request_key, requestor_type, id_funding_account, id_customer, replace_funding_account_request, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str channel: The channel through which the API is invoked. (required)
        :param str client_key: The unique identifier assigned by EBPP to the client. (required)
        :param str product: The product identifier corresponding to the API. (required)
        :param str timestamp: The timestamp for the moment when the API request is created. (required)
        :param str idempotent_request_key: The unique token that clients can generate and maintain in order to identify an API request. (required)
        :param str requestor_type: Type of the requestor of the API. (required)
        :param str id_funding_account: The unique identifier assigned by EBPP to the Funding Account. (required)
        :param str id_customer: The unique identifier assigned by EBPP to the customer. (required)
        :param ReplaceFundingAccountRequest replace_funding_account_request: JSON containing all the attributes of the Funding account to be replaced. (required)
        :param str requestor: The identifier for the requestor of the API.
        :param str x_opay_headers: Intended for the future use.
        :param str trace_id: The unique reference that can be used for tracing and debugging an API call.
        :return: FundingAccountResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['channel', 'client_key', 'product', 'timestamp', 'idempotent_request_key', 'requestor_type', 'id_funding_account', 'id_customer', 'replace_funding_account_request', 'requestor', 'x_opay_headers', 'trace_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method replace_funding_account" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}
        
        if 'id_funding_account' in params:
            path_params['ID_FUNDING_ACCOUNT'] = params['id_funding_account']  # noqa: E501
        if path_params['ID_FUNDING_ACCOUNT'] is None or path_params['ID_FUNDING_ACCOUNT'] == "":
            raise ApiException(status="0", reason="ID_FUNDING_ACCOUNT missing")

        if 'id_customer' in params:
            path_params['ID_CUSTOMER'] = params['id_customer']  # noqa: E501
        if path_params['ID_CUSTOMER'] is None or path_params['ID_CUSTOMER'] == "":
            raise ApiException(status="0", reason="ID_CUSTOMER missing")

        query_params = []

        header_params = {}
        if 'channel' in params:
            header_params['channel'] = params['channel']  # noqa: E501
        if 'client_key' in params:
            header_params['client_key'] = params['client_key']  # noqa: E501
        if 'product' in params:
            header_params['product'] = params['product']  # noqa: E501
        if 'timestamp' in params:
            header_params['timestamp'] = params['timestamp']  # noqa: E501
        if 'idempotent_request_key' in params:
            header_params['idempotent_request_key'] = params['idempotent_request_key']  # noqa: E501
        if 'requestor_type' in params:
            header_params['requestor_type'] = params['requestor_type']  # noqa: E501
        if 'requestor' in params:
            header_params['requestor'] = params['requestor']  # noqa: E501
        if 'x_opay_headers' in params:
            header_params['X-OPAY-Headers'] = params['x_opay_headers']  # noqa: E501
        if 'trace_id' in params:
            header_params['trace_id'] = params['trace_id']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'replace_funding_account_request' in params:
            body_params = params['replace_funding_account_request']
        # HTTP header `Accept`
        header_params['Accept'] = ApiClient.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = ApiClient.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/customers/{ID_CUSTOMER}/fundingaccounts/{ID_FUNDING_ACCOUNT}/replacement', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='FundingAccountResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def retrieve_funding_accounts(self, channel, client_key, product, timestamp, idempotent_request_key, requestor_type, id_customer, x_opay_headers, **kwargs):  # noqa: E501
        """Retrieve Funding Accounts  # noqa: E501

        This API is used to retrieve all the funding accounts associated with a customer. Accounts can be filtered using the account number, the ABA routing number (for bank accounts), the account status, account type, account sub-type and others mentioned below. The results are sorted based on their last_modified_time in descending order. The API responds with the first page of the list of funding accounts matching the criteria.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> configuration = Configuration()
        >>> # configuration.secret = secret
        >>> # configuration.host = host
        >>> api_client = ApiClient(configuration=configuration)
        >>> api = FundingAccountApi(api_client=api_client)
        >>> thread = api.retrieve_funding_accounts(channel, client_key, product, timestamp, idempotent_request_key, requestor_type, id_customer, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str channel: The channel through which the API is invoked. (required)
        :param str client_key: The unique identifier assigned by EBPP to the client. (required)
        :param str product: The product identifier corresponding to the API. (required)
        :param str timestamp: The timestamp for the moment when the API request is created. (required)
        :param str idempotent_request_key: The unique token that clients can generate and maintain in order to identify an API request. (required)
        :param str requestor_type: Type of the requestor of the API. (required)
        :param str id_customer: The unique identifier assigned by EBPP to the customer. (required)
        :param str requestor: The identifier for the requestor of the API.
        :param str x_opay_headers: Intended for the future use.
        :param str trace_id: The unique reference that can be used for tracing and debugging an API call.
        :param str page_size: The maximum number of objects returned in the query.
        :param str account_number: The Account Number to get details of.
        :param list[str] status: The status of the funding account in EBPP. This can take multiple values in the format key=value1&key=value2....
        :param str aba_routing_number: The ABA/Routing number for the bank account.
        :param list[str] account_type: The type of the funding account. This can take multiple values in the format key=value1&key=value2....
        :param str account_subtype: The sub type of the funding account. This is derived by EBPP in the case of card funding accounts.
        :return: FundingAccountsResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.retrieve_funding_accounts_with_http_info(channel, client_key, product, timestamp, idempotent_request_key, requestor_type, id_customer, x_opay_headers, **kwargs)  # noqa: E501
        else:
            (data) = self.retrieve_funding_accounts_with_http_info(channel, client_key, product, timestamp, idempotent_request_key, requestor_type, id_customer, x_opay_headers, **kwargs)  # noqa: E501
            return data

    def retrieve_funding_accounts_with_http_info(self, channel, client_key, product, timestamp, idempotent_request_key, requestor_type, id_customer, x_opay_headers, **kwargs):  # noqa: E501
        """Retrieve Funding Accounts  # noqa: E501

        This API is used to retrieve all the funding accounts associated with a customer. Accounts can be filtered using the account number, the ABA routing number (for bank accounts), the account status, account type, account sub-type and others mentioned below. The results are sorted based on their last_modified_time in descending order. The API responds with the first page of the list of funding accounts matching the criteria.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> configuration = Configuration()
        >>> # configuration.secret = secret
        >>> # configuration.host = host
        >>> api_client = ApiClient(configuration=configuration)
        >>> api = FundingAccountApi(api_client=api_client)
        >>> thread = api.retrieve_funding_accounts_with_http_info(channel, client_key, product, timestamp, idempotent_request_key, requestor_type, id_customer, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str channel: The channel through which the API is invoked. (required)
        :param str client_key: The unique identifier assigned by EBPP to the client. (required)
        :param str product: The product identifier corresponding to the API. (required)
        :param str timestamp: The timestamp for the moment when the API request is created. (required)
        :param str idempotent_request_key: The unique token that clients can generate and maintain in order to identify an API request. (required)
        :param str requestor_type: Type of the requestor of the API. (required)
        :param str id_customer: The unique identifier assigned by EBPP to the customer. (required)
        :param str requestor: The identifier for the requestor of the API.
        :param str x_opay_headers: Intended for the future use.
        :param str trace_id: The unique reference that can be used for tracing and debugging an API call.
        :param str page_size: The maximum number of objects returned in the query.
        :param str account_number: The Account Number to get details of.
        :param list[str] status: The status of the funding account in EBPP. This can take multiple values in the format key=value1&key=value2....
        :param str aba_routing_number: The ABA/Routing number for the bank account.
        :param list[str] account_type: The type of the funding account. This can take multiple values in the format key=value1&key=value2....
        :param str account_subtype: The sub type of the funding account. This is derived by EBPP in the case of card funding accounts.
        :return: FundingAccountsResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['channel', 'client_key', 'product', 'timestamp', 'idempotent_request_key', 'requestor_type', 'id_customer', 'requestor', 'x_opay_headers', 'trace_id', 'page_size', 'account_number', 'status', 'aba_routing_number', 'account_type', 'account_subtype']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method retrieve_funding_accounts" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}
        
        if 'id_customer' in params:
            path_params['ID_CUSTOMER'] = params['id_customer']  # noqa: E501
        if path_params['ID_CUSTOMER'] is None or path_params['ID_CUSTOMER'] == "":
            raise ApiException(status="0", reason="ID_CUSTOMER missing")

        query_params = []
        if 'page_size' in params:
            query_params.append(('page_size', params['page_size']))  # noqa: E501

        header_params = {}
        if 'channel' in params:
            header_params['channel'] = params['channel']  # noqa: E501
        if 'client_key' in params:
            header_params['client_key'] = params['client_key']  # noqa: E501
        if 'product' in params:
            header_params['product'] = params['product']  # noqa: E501
        if 'timestamp' in params:
            header_params['timestamp'] = params['timestamp']  # noqa: E501
        if 'idempotent_request_key' in params:
            header_params['idempotent_request_key'] = params['idempotent_request_key']  # noqa: E501
        if 'requestor_type' in params:
            header_params['requestor_type'] = params['requestor_type']  # noqa: E501
        if 'requestor' in params:
            header_params['requestor'] = params['requestor']  # noqa: E501
        if 'x_opay_headers' in params:
            header_params['X-OPAY-Headers'] = params['x_opay_headers']  # noqa: E501
        if 'trace_id' in params:
            header_params['trace_id'] = params['trace_id']  # noqa: E501

        form_params = []
        local_var_files = {}
        if 'account_number' in params:
            form_params.append(('account_number', params['account_number']))  # noqa: E501
        if 'status' in params:
            form_params.append(('status', params['status']))  # noqa: E501
            collection_formats['status'] = 'multi'  # noqa: E501
        if 'aba_routing_number' in params:
            form_params.append(('aba_routing_number', params['aba_routing_number']))  # noqa: E501
        if 'account_type' in params:
            form_params.append(('account_type', params['account_type']))  # noqa: E501
            collection_formats['account_type'] = 'multi'  # noqa: E501
        if 'account_subtype' in params:
            form_params.append(('account_subtype', params['account_subtype']))  # noqa: E501

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = ApiClient.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = ApiClient.select_header_content_type(  # noqa: E501
            ['application/x-www-form-urlencoded'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/customers/{ID_CUSTOMER}/fundingaccounts/lists', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='FundingAccountsResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def retrieve_funding_accounts_page(self, channel, client_key, product, timestamp, idempotent_request_key, requestor_type, id_customer, query_id, x_opay_headers, **kwargs):  # noqa: E501
        """Retrieve Funding Accounts Pagination  # noqa: E501

        This API is used to paginate through the list of funding accounts returned in the Retrieve Funding Accounts API.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> configuration = Configuration()
        >>> # configuration.secret = secret
        >>> # configuration.host = host
        >>> api_client = ApiClient(configuration=configuration)
        >>> api = FundingAccountApi(api_client=api_client)
        >>> thread = api.retrieve_funding_accounts_page(channel, client_key, product, timestamp, idempotent_request_key, requestor_type, id_customer, query_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str channel: The channel through which the API is invoked. (required)
        :param str client_key: The unique identifier assigned by EBPP to the client. (required)
        :param str product: The product identifier corresponding to the API. (required)
        :param str timestamp: The timestamp for the moment when the API request is created. (required)
        :param str idempotent_request_key: The unique token that clients can generate and maintain in order to identify an API request. (required)
        :param str requestor_type: Type of the requestor of the API. (required)
        :param str id_customer: The unique identifier assigned by EBPP to the customer. (required)
        :param str query_id: query id of the Retrieve/Search Accounts lookup. (required)
        :param str requestor: The identifier for the requestor of the API.
        :param str x_opay_headers: Intended for the future use.
        :param str trace_id: The unique reference that can be used for tracing and debugging an API call.
        :param str page_size: The maximum number of objects returned in the query.
        :param str from_index: To fetch the next set of objects that start after this object
        :param str to_index: To fetch the previous set of objects that end at this object
        :return: FundingAccountsResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.retrieve_funding_accounts_page_with_http_info(channel, client_key, product, timestamp, idempotent_request_key, requestor_type, id_customer, query_id, x_opay_headers, **kwargs)  # noqa: E501
        else:
            (data) = self.retrieve_funding_accounts_page_with_http_info(channel, client_key, product, timestamp, idempotent_request_key, requestor_type, id_customer, query_id, x_opay_headers, **kwargs)  # noqa: E501
            return data

    def retrieve_funding_accounts_page_with_http_info(self, channel, client_key, product, timestamp, idempotent_request_key, requestor_type, id_customer, query_id, x_opay_headers, **kwargs):  # noqa: E501
        """Retrieve Funding Accounts Pagination  # noqa: E501

        This API is used to paginate through the list of funding accounts returned in the Retrieve Funding Accounts API.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> configuration = Configuration()
        >>> # configuration.secret = secret
        >>> # configuration.host = host
        >>> api_client = ApiClient(configuration=configuration)
        >>> api = FundingAccountApi(api_client=api_client)
        >>> thread = api.retrieve_funding_accounts_page_with_http_info(channel, client_key, product, timestamp, idempotent_request_key, requestor_type, id_customer, query_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str channel: The channel through which the API is invoked. (required)
        :param str client_key: The unique identifier assigned by EBPP to the client. (required)
        :param str product: The product identifier corresponding to the API. (required)
        :param str timestamp: The timestamp for the moment when the API request is created. (required)
        :param str idempotent_request_key: The unique token that clients can generate and maintain in order to identify an API request. (required)
        :param str requestor_type: Type of the requestor of the API. (required)
        :param str id_customer: The unique identifier assigned by EBPP to the customer. (required)
        :param str query_id: query id of the Retrieve/Search Accounts lookup. (required)
        :param str requestor: The identifier for the requestor of the API.
        :param str x_opay_headers: Intended for the future use.
        :param str trace_id: The unique reference that can be used for tracing and debugging an API call.
        :param str page_size: The maximum number of objects returned in the query.
        :param str from_index: To fetch the next set of objects that start after this object
        :param str to_index: To fetch the previous set of objects that end at this object
        :return: FundingAccountsResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['channel', 'client_key', 'product', 'timestamp', 'idempotent_request_key', 'requestor_type', 'id_customer', 'query_id', 'requestor', 'x_opay_headers', 'trace_id', 'page_size', 'from_index', 'to_index']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method retrieve_funding_accounts_page" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}
        
        if 'id_customer' in params:
            path_params['ID_CUSTOMER'] = params['id_customer']  # noqa: E501
        if path_params['ID_CUSTOMER'] is None or path_params['ID_CUSTOMER'] == "":
            raise ApiException(status="0", reason="ID_CUSTOMER missing")

        query_params = []
        if 'page_size' in params:
            query_params.append(('page_size', params['page_size']))  # noqa: E501
        if 'query_id' in params:
            query_params.append(('query_id', params['query_id']))  # noqa: E501
        if 'from_index' in params:
            query_params.append(('from_index', params['from_index']))  # noqa: E501
        if 'to_index' in params:
            query_params.append(('to_index', params['to_index']))  # noqa: E501

        header_params = {}
        if 'channel' in params:
            header_params['channel'] = params['channel']  # noqa: E501
        if 'client_key' in params:
            header_params['client_key'] = params['client_key']  # noqa: E501
        if 'product' in params:
            header_params['product'] = params['product']  # noqa: E501
        if 'timestamp' in params:
            header_params['timestamp'] = params['timestamp']  # noqa: E501
        if 'idempotent_request_key' in params:
            header_params['idempotent_request_key'] = params['idempotent_request_key']  # noqa: E501
        if 'requestor_type' in params:
            header_params['requestor_type'] = params['requestor_type']  # noqa: E501
        if 'requestor' in params:
            header_params['requestor'] = params['requestor']  # noqa: E501
        if 'x_opay_headers' in params:
            header_params['X-OPAY-Headers'] = params['x_opay_headers']  # noqa: E501
        if 'trace_id' in params:
            header_params['trace_id'] = params['trace_id']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = ApiClient.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/customers/{ID_CUSTOMER}/fundingaccounts/lists', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='FundingAccountsResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def update_funding_account(self, channel, client_key, product, timestamp, idempotent_request_key, requestor_type, id_funding_account, id_customer, update_funding_account_request, x_opay_headers, **kwargs):  # noqa: E501
        """Update Funding Account  # noqa: E501

        The API is used to edit the funding account details. The type of the funding account cannot be changed. In other words, a card account cannot be changed to a bank account and vice versa. The sub-type of a bank account can be changed. For e.g., a saving account can be updated to a money market account. However, the sub-type cannot be updated for a card account. CVV is mandatory to make any change to a card account. The Id of the funding account gets updated to a new value if the account number is updated. Editing a funding account updates the account information on all pending payments made using that account but does not change the details on payments that have been completed. <br><br> Below are the possible funding account state transformation.  | from_status | to_status | allowed requestor_type | | ------------ | ------------ | ------------ | | active | deleted| <ul> <li>external_user</li> <li> client_agent</li> <li> system</li> <li> customer</li></ul> | | active | frozen | <ul> <li>external_user </li> <li>  client_agent </li> <li>  system</li></ul> | | active | inactive | <ul> <li>external_user </li> <li>  client_agent </li> <li>  system</li></ul> | | active | unverified | <ul> <li>system</li></ul> | | frozen | active | <ul> <li>external_user </li> <li>  client_agent</li></ul> | | inactive | active | <ul> <li>external_user </li> <li>  client_agent </li> <li>  system</li></ul> |   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> configuration = Configuration()
        >>> # configuration.secret = secret
        >>> # configuration.host = host
        >>> api_client = ApiClient(configuration=configuration)
        >>> api = FundingAccountApi(api_client=api_client)
        >>> thread = api.update_funding_account(channel, client_key, product, timestamp, idempotent_request_key, requestor_type, id_funding_account, id_customer, update_funding_account_request, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str channel: The channel through which the API is invoked. (required)
        :param str client_key: The unique identifier assigned by EBPP to the client. (required)
        :param str product: The product identifier corresponding to the API. (required)
        :param str timestamp: The timestamp for the moment when the API request is created. (required)
        :param str idempotent_request_key: The unique token that clients can generate and maintain in order to identify an API request. (required)
        :param str requestor_type: Type of the requestor of the API. (required)
        :param str id_funding_account: The unique identifier assigned by EBPP to the Funding Account. (required)
        :param str id_customer: The unique identifier assigned by EBPP to the customer. (required)
        :param UpdateFundingAccountRequest update_funding_account_request: JSON containing all the attributes of the Funding account to be updated. (required)
        :param str requestor: The identifier for the requestor of the API.
        :param str x_opay_headers: Intended for the future use.
        :param str trace_id: The unique reference that can be used for tracing and debugging an API call.
        :return: FundingAccountResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.update_funding_account_with_http_info(channel, client_key, product, timestamp, idempotent_request_key, requestor_type, id_funding_account, id_customer, update_funding_account_request, x_opay_headers, **kwargs)  # noqa: E501
        else:
            (data) = self.update_funding_account_with_http_info(channel, client_key, product, timestamp, idempotent_request_key, requestor_type, id_funding_account, id_customer, update_funding_account_request, x_opay_headers, **kwargs)  # noqa: E501
            return data

    def update_funding_account_with_http_info(self, channel, client_key, product, timestamp, idempotent_request_key, requestor_type, id_funding_account, id_customer, update_funding_account_request, x_opay_headers, **kwargs):  # noqa: E501
        """Update Funding Account  # noqa: E501

        The API is used to edit the funding account details. The type of the funding account cannot be changed. In other words, a card account cannot be changed to a bank account and vice versa. The sub-type of a bank account can be changed. For e.g., a saving account can be updated to a money market account. However, the sub-type cannot be updated for a card account. CVV is mandatory to make any change to a card account. The Id of the funding account gets updated to a new value if the account number is updated. Editing a funding account updates the account information on all pending payments made using that account but does not change the details on payments that have been completed. <br><br> Below are the possible funding account state transformation.  | from_status | to_status | allowed requestor_type | | ------------ | ------------ | ------------ | | active | deleted| <ul> <li>external_user</li> <li> client_agent</li> <li> system</li> <li> customer</li></ul> | | active | frozen | <ul> <li>external_user </li> <li>  client_agent </li> <li>  system</li></ul> | | active | inactive | <ul> <li>external_user </li> <li>  client_agent </li> <li>  system</li></ul> | | active | unverified | <ul> <li>system</li></ul> | | frozen | active | <ul> <li>external_user </li> <li>  client_agent</li></ul> | | inactive | active | <ul> <li>external_user </li> <li>  client_agent </li> <li>  system</li></ul> |   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> configuration = Configuration()
        >>> # configuration.secret = secret
        >>> # configuration.host = host
        >>> api_client = ApiClient(configuration=configuration)
        >>> api = FundingAccountApi(api_client=api_client)
        >>> thread = api.update_funding_account_with_http_info(channel, client_key, product, timestamp, idempotent_request_key, requestor_type, id_funding_account, id_customer, update_funding_account_request, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str channel: The channel through which the API is invoked. (required)
        :param str client_key: The unique identifier assigned by EBPP to the client. (required)
        :param str product: The product identifier corresponding to the API. (required)
        :param str timestamp: The timestamp for the moment when the API request is created. (required)
        :param str idempotent_request_key: The unique token that clients can generate and maintain in order to identify an API request. (required)
        :param str requestor_type: Type of the requestor of the API. (required)
        :param str id_funding_account: The unique identifier assigned by EBPP to the Funding Account. (required)
        :param str id_customer: The unique identifier assigned by EBPP to the customer. (required)
        :param UpdateFundingAccountRequest update_funding_account_request: JSON containing all the attributes of the Funding account to be updated. (required)
        :param str requestor: The identifier for the requestor of the API.
        :param str x_opay_headers: Intended for the future use.
        :param str trace_id: The unique reference that can be used for tracing and debugging an API call.
        :return: FundingAccountResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['channel', 'client_key', 'product', 'timestamp', 'idempotent_request_key', 'requestor_type', 'id_funding_account', 'id_customer', 'update_funding_account_request', 'requestor', 'x_opay_headers', 'trace_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method update_funding_account" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}
        
        if 'id_funding_account' in params:
            path_params['ID_FUNDING_ACCOUNT'] = params['id_funding_account']  # noqa: E501
        if path_params['ID_FUNDING_ACCOUNT'] is None or path_params['ID_FUNDING_ACCOUNT'] == "":
            raise ApiException(status="0", reason="ID_FUNDING_ACCOUNT missing")

        if 'id_customer' in params:
            path_params['ID_CUSTOMER'] = params['id_customer']  # noqa: E501
        if path_params['ID_CUSTOMER'] is None or path_params['ID_CUSTOMER'] == "":
            raise ApiException(status="0", reason="ID_CUSTOMER missing")

        query_params = []

        header_params = {}
        if 'channel' in params:
            header_params['channel'] = params['channel']  # noqa: E501
        if 'client_key' in params:
            header_params['client_key'] = params['client_key']  # noqa: E501
        if 'product' in params:
            header_params['product'] = params['product']  # noqa: E501
        if 'timestamp' in params:
            header_params['timestamp'] = params['timestamp']  # noqa: E501
        if 'idempotent_request_key' in params:
            header_params['idempotent_request_key'] = params['idempotent_request_key']  # noqa: E501
        if 'requestor_type' in params:
            header_params['requestor_type'] = params['requestor_type']  # noqa: E501
        if 'requestor' in params:
            header_params['requestor'] = params['requestor']  # noqa: E501
        if 'x_opay_headers' in params:
            header_params['X-OPAY-Headers'] = params['x_opay_headers']  # noqa: E501
        if 'trace_id' in params:
            header_params['trace_id'] = params['trace_id']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'update_funding_account_request' in params:
            body_params = params['update_funding_account_request']
        # HTTP header `Accept`
        header_params['Accept'] = ApiClient.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = ApiClient.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/customers/{ID_CUSTOMER}/fundingaccounts/{ID_FUNDING_ACCOUNT}', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='FundingAccountResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
