# coding: utf-8

"""
    ############################################################################################
    ## This class subject to change without prior notice, Please dont use this class directly.##
    ############################################################################################
"""


import pprint
import re  # noqa: F401

import six

from orbipay_paymentsapi_client.models.payment_auth_customer_account_request import PaymentAuthCustomerAccountRequest  # noqa: F401,E501
from orbipay_paymentsapi_client.models.payment_auth_customer_request import PaymentAuthCustomerRequest  # noqa: F401,E501
from orbipay_paymentsapi_client.models.payment_auth_funding_account_request import PaymentAuthFundingAccountRequest  # noqa: F401,E501


class CreatePaymentAuthorizationRequest(object):
    """NOTE: 
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'payment_auth_reference': 'str',
        'auth_amount': 'str',
        'card_cvv_number': 'str',
        'customer': 'PaymentAuthCustomerRequest',
        'funding_account': 'PaymentAuthFundingAccountRequest',
        'customer_account': 'PaymentAuthCustomerAccountRequest',
        'comments': 'str',
        'custom_fields': 'dict(str, str)'
    }

    attribute_map = {
        'payment_auth_reference': 'payment_auth_reference',
        'auth_amount': 'auth_amount',
        'card_cvv_number': 'card_cvv_number',
        'customer': 'customer',
        'funding_account': 'funding_account',
        'customer_account': 'customer_account',
        'comments': 'comments',
        'custom_fields': 'custom_fields'
    }

    def __init__(self, payment_auth_reference=None, auth_amount=None, card_cvv_number=None, customer=None, funding_account=None, customer_account=None, comments=None, custom_fields=None):  # noqa: E501
        """CreatePaymentAuthorizationRequest - a model defined in Swagger"""  # noqa: E501

        self._payment_auth_reference = None
        self._auth_amount = None
        self._card_cvv_number = None
        self._customer = None
        self._funding_account = None
        self._customer_account = None
        self._comments = None
        self._custom_fields = None
        self.discriminator = None

        if payment_auth_reference is not None:
            self.payment_auth_reference = payment_auth_reference
        self.auth_amount = auth_amount
        if card_cvv_number is not None:
            self.card_cvv_number = card_cvv_number
        self.customer = customer
        self.funding_account = funding_account
        self.customer_account = customer_account
        if comments is not None:
            self.comments = comments
        if custom_fields is not None:
            self.custom_fields = custom_fields

    def __getitem__(self,key):
        return getattr(self,key)

    @property
    def payment_auth_reference(self):
        """Gets the payment_auth_reference of this CreatePaymentAuthorizationRequest.  # noqa: E501

        The unique identifier in the client system for the payment authorization. This is mandatory in case of voyager fleet card payment.  # noqa: E501

        :return: The payment_auth_reference of this CreatePaymentAuthorizationRequest.  # noqa: E501
        :rtype: str
        """
        return self._payment_auth_reference

    @payment_auth_reference.setter
    def payment_auth_reference(self, payment_auth_reference):
        """Sets the payment_auth_reference of this CreatePaymentAuthorizationRequest.

        The unique identifier in the client system for the payment authorization. This is mandatory in case of voyager fleet card payment.  # noqa: E501

        :param payment_auth_reference: The payment_auth_reference of this CreatePaymentAuthorizationRequest.  # noqa: E501
        :type: str
        """
        self._payment_auth_reference = payment_auth_reference

    @property
    def auth_amount(self):
        """Gets the auth_amount of this CreatePaymentAuthorizationRequest.  # noqa: E501

        The amount being authorized.  # noqa: E501

        :return: The auth_amount of this CreatePaymentAuthorizationRequest.  # noqa: E501
        :rtype: str
        """
        return self._auth_amount

    @auth_amount.setter
    def auth_amount(self, auth_amount):
        """Sets the auth_amount of this CreatePaymentAuthorizationRequest.

        The amount being authorized.  # noqa: E501

        :param auth_amount: The auth_amount of this CreatePaymentAuthorizationRequest.  # noqa: E501
        :type: str
        """
        self._auth_amount = auth_amount

    @property
    def card_cvv_number(self):
        """Gets the card_cvv_number of this CreatePaymentAuthorizationRequest.  # noqa: E501


        :return: The card_cvv_number of this CreatePaymentAuthorizationRequest.  # noqa: E501
        :rtype: str
        """
        return self._card_cvv_number

    @card_cvv_number.setter
    def card_cvv_number(self, card_cvv_number):
        """Sets the card_cvv_number of this CreatePaymentAuthorizationRequest.


        :param card_cvv_number: The card_cvv_number of this CreatePaymentAuthorizationRequest.  # noqa: E501
        :type: str
        """
        self._card_cvv_number = card_cvv_number

    @property
    def customer(self):
        """Gets the customer of this CreatePaymentAuthorizationRequest.  # noqa: E501


        :return: The customer of this CreatePaymentAuthorizationRequest.  # noqa: E501
        :rtype: PaymentAuthCustomerRequest
        """
        return self._customer

    @customer.setter
    def customer(self, customer):
        """Sets the customer of this CreatePaymentAuthorizationRequest.


        :param customer: The customer of this CreatePaymentAuthorizationRequest.  # noqa: E501
        :type: PaymentAuthCustomerRequest
        """
        self._customer = customer

    @property
    def funding_account(self):
        """Gets the funding_account of this CreatePaymentAuthorizationRequest.  # noqa: E501


        :return: The funding_account of this CreatePaymentAuthorizationRequest.  # noqa: E501
        :rtype: PaymentAuthFundingAccountRequest
        """
        return self._funding_account

    @funding_account.setter
    def funding_account(self, funding_account):
        """Sets the funding_account of this CreatePaymentAuthorizationRequest.


        :param funding_account: The funding_account of this CreatePaymentAuthorizationRequest.  # noqa: E501
        :type: PaymentAuthFundingAccountRequest
        """
        self._funding_account = funding_account

    @property
    def customer_account(self):
        """Gets the customer_account of this CreatePaymentAuthorizationRequest.  # noqa: E501


        :return: The customer_account of this CreatePaymentAuthorizationRequest.  # noqa: E501
        :rtype: PaymentAuthCustomerAccountRequest
        """
        return self._customer_account

    @customer_account.setter
    def customer_account(self, customer_account):
        """Sets the customer_account of this CreatePaymentAuthorizationRequest.


        :param customer_account: The customer_account of this CreatePaymentAuthorizationRequest.  # noqa: E501
        :type: PaymentAuthCustomerAccountRequest
        """
        self._customer_account = customer_account

    @property
    def comments(self):
        """Gets the comments of this CreatePaymentAuthorizationRequest.  # noqa: E501

        Comments that can be used to recollect the operation performed on the resource object.  # noqa: E501

        :return: The comments of this CreatePaymentAuthorizationRequest.  # noqa: E501
        :rtype: str
        """
        return self._comments

    @comments.setter
    def comments(self, comments):
        """Sets the comments of this CreatePaymentAuthorizationRequest.

        Comments that can be used to recollect the operation performed on the resource object.  # noqa: E501

        :param comments: The comments of this CreatePaymentAuthorizationRequest.  # noqa: E501
        :type: str
        """
        self._comments = comments

    @property
    def custom_fields(self):
        """Gets the custom_fields of this CreatePaymentAuthorizationRequest.  # noqa: E501

        The additional information or meta-information that EBPP can accept, maintain and transmit back to the client.   # noqa: E501

        :return: The custom_fields of this CreatePaymentAuthorizationRequest.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._custom_fields

    @custom_fields.setter
    def custom_fields(self, custom_fields):
        """Sets the custom_fields of this CreatePaymentAuthorizationRequest.

        The additional information or meta-information that EBPP can accept, maintain and transmit back to the client.   # noqa: E501

        :param custom_fields: The custom_fields of this CreatePaymentAuthorizationRequest.  # noqa: E501
        :type: dict(str, str)
        """
        self._custom_fields = custom_fields

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CreatePaymentAuthorizationRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CreatePaymentAuthorizationRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
