# coding: utf-8

"""
    ############################################################################################
    ## This class subject to change without prior notice, Please dont use this class directly.##
    ############################################################################################
"""


import pprint
import re  # noqa: F401

import six

from orbipay_paymentsapi_client.models.customer_account_minimal_request import CustomerAccountMinimalRequest  # noqa: F401,E501
from orbipay_paymentsapi_client.models.customer_minimal_request import CustomerMinimalRequest  # noqa: F401,E501
from orbipay_paymentsapi_client.models.funding_account_minimal_request import FundingAccountMinimalRequest  # noqa: F401,E501
from orbipay_paymentsapi_client.models.payment_schedule_vo import PaymentScheduleVo  # noqa: F401,E501
from orbipay_paymentsapi_client.models.payment_setup_fee_request import PaymentSetupFeeRequest  # noqa: F401,E501


class CreatePaymentSetupRequest(object):
    """NOTE: 
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'payment_setup_reference': 'str',
        'payment_setup_schedule_type': 'str',
        'amount': 'str',
        'card_cvv_number': 'str',
        'fee': 'PaymentSetupFeeRequest',
        'customer': 'CustomerMinimalRequest',
        'funding_account': 'FundingAccountMinimalRequest',
        'customer_account': 'CustomerAccountMinimalRequest',
        'payment_schedule': 'PaymentScheduleVo',
        'custom_fields': 'dict(str, str)',
        'comments': 'str'
    }

    attribute_map = {
        'payment_setup_reference': 'payment_setup_reference',
        'payment_setup_schedule_type': 'payment_setup_schedule_type',
        'amount': 'amount',
        'card_cvv_number': 'card_cvv_number',
        'fee': 'fee',
        'customer': 'customer',
        'funding_account': 'funding_account',
        'customer_account': 'customer_account',
        'payment_schedule': 'payment_schedule',
        'custom_fields': 'custom_fields',
        'comments': 'comments'
    }

    def __init__(self, payment_setup_reference=None, payment_setup_schedule_type=None, amount=None, card_cvv_number=None, fee=None, customer=None, funding_account=None, customer_account=None, payment_schedule=None, custom_fields=None, comments=None):  # noqa: E501
        """CreatePaymentSetupRequest - a model defined in Swagger"""  # noqa: E501

        self._payment_setup_reference = None
        self._payment_setup_schedule_type = None
        self._amount = None
        self._card_cvv_number = None
        self._fee = None
        self._customer = None
        self._funding_account = None
        self._customer_account = None
        self._payment_schedule = None
        self._custom_fields = None
        self._comments = None
        self.discriminator = None

        if payment_setup_reference is not None:
            self.payment_setup_reference = payment_setup_reference
        self.payment_setup_schedule_type = payment_setup_schedule_type
        if amount is not None:
            self.amount = amount
        if card_cvv_number is not None:
            self.card_cvv_number = card_cvv_number
        if fee is not None:
            self.fee = fee
        self.customer = customer
        self.funding_account = funding_account
        self.customer_account = customer_account
        self.payment_schedule = payment_schedule
        if custom_fields is not None:
            self.custom_fields = custom_fields
        if comments is not None:
            self.comments = comments

    def __getitem__(self,key):
        return getattr(self,key)

    @property
    def payment_setup_reference(self):
        """Gets the payment_setup_reference of this CreatePaymentSetupRequest.  # noqa: E501

        The unique identifier in the client system for the paymentSetup.  # noqa: E501

        :return: The payment_setup_reference of this CreatePaymentSetupRequest.  # noqa: E501
        :rtype: str
        """
        return self._payment_setup_reference

    @payment_setup_reference.setter
    def payment_setup_reference(self, payment_setup_reference):
        """Sets the payment_setup_reference of this CreatePaymentSetupRequest.

        The unique identifier in the client system for the paymentSetup.  # noqa: E501

        :param payment_setup_reference: The payment_setup_reference of this CreatePaymentSetupRequest.  # noqa: E501
        :type: str
        """
        self._payment_setup_reference = payment_setup_reference

    @property
    def payment_setup_schedule_type(self):
        """Gets the payment_setup_schedule_type of this CreatePaymentSetupRequest.  # noqa: E501

        The schedule type for the payment setup.  # noqa: E501

        :return: The payment_setup_schedule_type of this CreatePaymentSetupRequest.  # noqa: E501
        :rtype: str
        """
        return self._payment_setup_schedule_type

    @payment_setup_schedule_type.setter
    def payment_setup_schedule_type(self, payment_setup_schedule_type):
        """Sets the payment_setup_schedule_type of this CreatePaymentSetupRequest.

        The schedule type for the payment setup.  # noqa: E501

        :param payment_setup_schedule_type: The payment_setup_schedule_type of this CreatePaymentSetupRequest.  # noqa: E501
        :type: str
        """
        self._payment_setup_schedule_type = payment_setup_schedule_type

    @property
    def amount(self):
        """Gets the amount of this CreatePaymentSetupRequest.  # noqa: E501

        The amount being paid.   # noqa: E501

        :return: The amount of this CreatePaymentSetupRequest.  # noqa: E501
        :rtype: str
        """
        return self._amount

    @amount.setter
    def amount(self, amount):
        """Sets the amount of this CreatePaymentSetupRequest.

        The amount being paid.   # noqa: E501

        :param amount: The amount of this CreatePaymentSetupRequest.  # noqa: E501
        :type: str
        """
        self._amount = amount

    @property
    def card_cvv_number(self):
        """Gets the card_cvv_number of this CreatePaymentSetupRequest.  # noqa: E501


        :return: The card_cvv_number of this CreatePaymentSetupRequest.  # noqa: E501
        :rtype: str
        """
        return self._card_cvv_number

    @card_cvv_number.setter
    def card_cvv_number(self, card_cvv_number):
        """Sets the card_cvv_number of this CreatePaymentSetupRequest.


        :param card_cvv_number: The card_cvv_number of this CreatePaymentSetupRequest.  # noqa: E501
        :type: str
        """
        self._card_cvv_number = card_cvv_number

    @property
    def fee(self):
        """Gets the fee of this CreatePaymentSetupRequest.  # noqa: E501


        :return: The fee of this CreatePaymentSetupRequest.  # noqa: E501
        :rtype: PaymentSetupFeeRequest
        """
        return self._fee

    @fee.setter
    def fee(self, fee):
        """Sets the fee of this CreatePaymentSetupRequest.


        :param fee: The fee of this CreatePaymentSetupRequest.  # noqa: E501
        :type: PaymentSetupFeeRequest
        """
        self._fee = fee

    @property
    def customer(self):
        """Gets the customer of this CreatePaymentSetupRequest.  # noqa: E501


        :return: The customer of this CreatePaymentSetupRequest.  # noqa: E501
        :rtype: CustomerMinimalRequest
        """
        return self._customer

    @customer.setter
    def customer(self, customer):
        """Sets the customer of this CreatePaymentSetupRequest.


        :param customer: The customer of this CreatePaymentSetupRequest.  # noqa: E501
        :type: CustomerMinimalRequest
        """
        self._customer = customer

    @property
    def funding_account(self):
        """Gets the funding_account of this CreatePaymentSetupRequest.  # noqa: E501


        :return: The funding_account of this CreatePaymentSetupRequest.  # noqa: E501
        :rtype: FundingAccountMinimalRequest
        """
        return self._funding_account

    @funding_account.setter
    def funding_account(self, funding_account):
        """Sets the funding_account of this CreatePaymentSetupRequest.


        :param funding_account: The funding_account of this CreatePaymentSetupRequest.  # noqa: E501
        :type: FundingAccountMinimalRequest
        """
        self._funding_account = funding_account

    @property
    def customer_account(self):
        """Gets the customer_account of this CreatePaymentSetupRequest.  # noqa: E501


        :return: The customer_account of this CreatePaymentSetupRequest.  # noqa: E501
        :rtype: CustomerAccountMinimalRequest
        """
        return self._customer_account

    @customer_account.setter
    def customer_account(self, customer_account):
        """Sets the customer_account of this CreatePaymentSetupRequest.


        :param customer_account: The customer_account of this CreatePaymentSetupRequest.  # noqa: E501
        :type: CustomerAccountMinimalRequest
        """
        self._customer_account = customer_account

    @property
    def payment_schedule(self):
        """Gets the payment_schedule of this CreatePaymentSetupRequest.  # noqa: E501


        :return: The payment_schedule of this CreatePaymentSetupRequest.  # noqa: E501
        :rtype: PaymentScheduleVo
        """
        return self._payment_schedule

    @payment_schedule.setter
    def payment_schedule(self, payment_schedule):
        """Sets the payment_schedule of this CreatePaymentSetupRequest.


        :param payment_schedule: The payment_schedule of this CreatePaymentSetupRequest.  # noqa: E501
        :type: PaymentScheduleVo
        """
        self._payment_schedule = payment_schedule

    @property
    def custom_fields(self):
        """Gets the custom_fields of this CreatePaymentSetupRequest.  # noqa: E501

        The additional information or meta-information that EBPP can accept, maintain and transmit back to the client.  # noqa: E501

        :return: The custom_fields of this CreatePaymentSetupRequest.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._custom_fields

    @custom_fields.setter
    def custom_fields(self, custom_fields):
        """Sets the custom_fields of this CreatePaymentSetupRequest.

        The additional information or meta-information that EBPP can accept, maintain and transmit back to the client.  # noqa: E501

        :param custom_fields: The custom_fields of this CreatePaymentSetupRequest.  # noqa: E501
        :type: dict(str, str)
        """
        self._custom_fields = custom_fields

    @property
    def comments(self):
        """Gets the comments of this CreatePaymentSetupRequest.  # noqa: E501

        Comments that can be used to recollect the operation performed on the resource object.  # noqa: E501

        :return: The comments of this CreatePaymentSetupRequest.  # noqa: E501
        :rtype: str
        """
        return self._comments

    @comments.setter
    def comments(self, comments):
        """Sets the comments of this CreatePaymentSetupRequest.

        Comments that can be used to recollect the operation performed on the resource object.  # noqa: E501

        :param comments: The comments of this CreatePaymentSetupRequest.  # noqa: E501
        :type: str
        """
        self._comments = comments

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CreatePaymentSetupRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CreatePaymentSetupRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
