# coding: utf-8

"""
    ############################################################################################
    ## This class subject to change without prior notice, Please dont use this class directly.##
    ############################################################################################
"""


import pprint
import re  # noqa: F401

import six

from orbipay_paymentsapi_client.models.fee_refund_request import FeeRefundRequest  # noqa: F401,E501


class CreateRefundRequest(object):
    """NOTE: 
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'refund_reference': 'str',
        'refund_amount': 'str',
        'fee_refund': 'FeeRefundRequest',
        'comments': 'str',
        'custom_fields': 'dict(str, str)'
    }

    attribute_map = {
        'refund_reference': 'refund_reference',
        'refund_amount': 'refund_amount',
        'fee_refund': 'fee_refund',
        'comments': 'comments',
        'custom_fields': 'custom_fields'
    }

    def __init__(self, refund_reference=None, refund_amount=None, fee_refund=None, comments=None, custom_fields=None):  # noqa: E501
        """CreateRefundRequest - a model defined in Swagger"""  # noqa: E501

        self._refund_reference = None
        self._refund_amount = None
        self._fee_refund = None
        self._comments = None
        self._custom_fields = None
        self.discriminator = None

        if refund_reference is not None:
            self.refund_reference = refund_reference
        if refund_amount is not None:
            self.refund_amount = refund_amount
        if fee_refund is not None:
            self.fee_refund = fee_refund
        if comments is not None:
            self.comments = comments
        if custom_fields is not None:
            self.custom_fields = custom_fields

    def __getitem__(self,key):
        return getattr(self,key)

    @property
    def refund_reference(self):
        """Gets the refund_reference of this CreateRefundRequest.  # noqa: E501

        The unique identifier in the client system for the refund.  # noqa: E501

        :return: The refund_reference of this CreateRefundRequest.  # noqa: E501
        :rtype: str
        """
        return self._refund_reference

    @refund_reference.setter
    def refund_reference(self, refund_reference):
        """Sets the refund_reference of this CreateRefundRequest.

        The unique identifier in the client system for the refund.  # noqa: E501

        :param refund_reference: The refund_reference of this CreateRefundRequest.  # noqa: E501
        :type: str
        """
        self._refund_reference = refund_reference

    @property
    def refund_amount(self):
        """Gets the refund_amount of this CreateRefundRequest.  # noqa: E501

        The refund amount upto 2 decimal places.  # noqa: E501

        :return: The refund_amount of this CreateRefundRequest.  # noqa: E501
        :rtype: str
        """
        return self._refund_amount

    @refund_amount.setter
    def refund_amount(self, refund_amount):
        """Sets the refund_amount of this CreateRefundRequest.

        The refund amount upto 2 decimal places.  # noqa: E501

        :param refund_amount: The refund_amount of this CreateRefundRequest.  # noqa: E501
        :type: str
        """
        self._refund_amount = refund_amount

    @property
    def fee_refund(self):
        """Gets the fee_refund of this CreateRefundRequest.  # noqa: E501


        :return: The fee_refund of this CreateRefundRequest.  # noqa: E501
        :rtype: FeeRefundRequest
        """
        return self._fee_refund

    @fee_refund.setter
    def fee_refund(self, fee_refund):
        """Sets the fee_refund of this CreateRefundRequest.


        :param fee_refund: The fee_refund of this CreateRefundRequest.  # noqa: E501
        :type: FeeRefundRequest
        """
        self._fee_refund = fee_refund

    @property
    def comments(self):
        """Gets the comments of this CreateRefundRequest.  # noqa: E501

        Comments that can be used to recollect the operation performed on the resource object.  # noqa: E501

        :return: The comments of this CreateRefundRequest.  # noqa: E501
        :rtype: str
        """
        return self._comments

    @comments.setter
    def comments(self, comments):
        """Sets the comments of this CreateRefundRequest.

        Comments that can be used to recollect the operation performed on the resource object.  # noqa: E501

        :param comments: The comments of this CreateRefundRequest.  # noqa: E501
        :type: str
        """
        self._comments = comments

    @property
    def custom_fields(self):
        """Gets the custom_fields of this CreateRefundRequest.  # noqa: E501

        The additional information or meta-information that EBPP can accept, maintain and transmit back to the client.  # noqa: E501

        :return: The custom_fields of this CreateRefundRequest.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._custom_fields

    @custom_fields.setter
    def custom_fields(self, custom_fields):
        """Sets the custom_fields of this CreateRefundRequest.

        The additional information or meta-information that EBPP can accept, maintain and transmit back to the client.  # noqa: E501

        :param custom_fields: The custom_fields of this CreateRefundRequest.  # noqa: E501
        :type: dict(str, str)
        """
        self._custom_fields = custom_fields

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CreateRefundRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CreateRefundRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
