# coding: utf-8

"""
    ############################################################################################
    ## This class subject to change without prior notice, Please dont use this class directly.##
    ############################################################################################
"""


import pprint
import re  # noqa: F401

import six


class CustomerAccountSnapshotResponse(object):
    """NOTE: 
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'account_number': 'str',
        'id': 'str',
        'url': 'str'
    }

    attribute_map = {
        'account_number': 'account_number',
        'id': 'id',
        'url': 'url'
    }

    def __init__(self, account_number=None, id=None, url=None):  # noqa: E501
        """CustomerAccountSnapshotResponse - a model defined in Swagger"""  # noqa: E501

        self._account_number = None
        self._id = None
        self._url = None
        self.discriminator = None

        if account_number is not None:
            self.account_number = account_number
        if id is not None:
            self.id = id
        if url is not None:
            self.url = url

    def __getitem__(self,key):
        return getattr(self,key)

    @property
    def account_number(self):
        """Gets the account_number of this CustomerAccountSnapshotResponse.  # noqa: E501

        The number or reference that a customer uses to identify the customer's account.  # noqa: E501

        :return: The account_number of this CustomerAccountSnapshotResponse.  # noqa: E501
        :rtype: str
        """
        return self._account_number

    @account_number.setter
    def account_number(self, account_number):
        """Sets the account_number of this CustomerAccountSnapshotResponse.

        The number or reference that a customer uses to identify the customer's account.  # noqa: E501

        :param account_number: The account_number of this CustomerAccountSnapshotResponse.  # noqa: E501
        :type: str
        """
        self._account_number = account_number

    @property
    def id(self):
        """Gets the id of this CustomerAccountSnapshotResponse.  # noqa: E501

        Id is a unique identifier assigned to the account in EBPP.  # noqa: E501

        :return: The id of this CustomerAccountSnapshotResponse.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this CustomerAccountSnapshotResponse.

        Id is a unique identifier assigned to the account in EBPP.  # noqa: E501

        :param id: The id of this CustomerAccountSnapshotResponse.  # noqa: E501
        :type: str
        """
        self._id = id

    @property
    def url(self):
        """Gets the url of this CustomerAccountSnapshotResponse.  # noqa: E501

        This URL fetches the customer account details.  # noqa: E501

        :return: The url of this CustomerAccountSnapshotResponse.  # noqa: E501
        :rtype: str
        """
        return self._url

    @url.setter
    def url(self, url):
        """Sets the url of this CustomerAccountSnapshotResponse.

        This URL fetches the customer account details.  # noqa: E501

        :param url: The url of this CustomerAccountSnapshotResponse.  # noqa: E501
        :type: str
        """
        self._url = url

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CustomerAccountSnapshotResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CustomerAccountSnapshotResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
