# coding: utf-8

"""
    ############################################################################################
    ## This class subject to change without prior notice, Please dont use this class directly.##
    ############################################################################################
"""


import pprint
import re  # noqa: F401

import six

from orbipay_paymentsapi_client.models.address_vo import AddressVo  # noqa: F401,E501
from orbipay_paymentsapi_client.models.audit_info_vo import AuditInfoVo  # noqa: F401,E501
from orbipay_paymentsapi_client.models.customers_customer_accounts_response import CustomersCustomerAccountsResponse  # noqa: F401,E501
from orbipay_paymentsapi_client.models.customers_funding_accounts_response import CustomersFundingAccountsResponse  # noqa: F401,E501
from orbipay_paymentsapi_client.models.customers_payment_setups_response import CustomersPaymentSetupsResponse  # noqa: F401,E501
from orbipay_paymentsapi_client.models.customers_payments_response import CustomersPaymentsResponse  # noqa: F401,E501


class CustomerResponse(object):
    """NOTE: 
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'first_name': 'str',
        'last_name': 'str',
        'middle_name': 'str',
        'gender': 'str',
        'date_of_birth': 'str',
        'ssn': 'str',
        'locale': 'str',
        'email': 'str',
        'registered_email': 'str',
        'home_phone': 'str',
        'work_phone': 'str',
        'mobile_phone': 'str',
        'address': 'AddressVo',
        'custom_fields': 'dict(str, str)',
        'customer_reference': 'str',
        'id': 'str',
        'status': 'str',
        'url': 'str',
        'comments': 'str',
        'customer_accounts': 'CustomersCustomerAccountsResponse',
        'funding_accounts': 'CustomersFundingAccountsResponse',
        'payments': 'CustomersPaymentsResponse',
        'payment_setups': 'CustomersPaymentSetupsResponse',
        'audit_info': 'AuditInfoVo'
    }

    attribute_map = {
        'first_name': 'first_name',
        'last_name': 'last_name',
        'middle_name': 'middle_name',
        'gender': 'gender',
        'date_of_birth': 'date_of_birth',
        'ssn': 'ssn',
        'locale': 'locale',
        'email': 'email',
        'registered_email': 'registered_email',
        'home_phone': 'home_phone',
        'work_phone': 'work_phone',
        'mobile_phone': 'mobile_phone',
        'address': 'address',
        'custom_fields': 'custom_fields',
        'customer_reference': 'customer_reference',
        'id': 'id',
        'status': 'status',
        'url': 'url',
        'comments': 'comments',
        'customer_accounts': 'customer_accounts',
        'funding_accounts': 'funding_accounts',
        'payments': 'payments',
        'payment_setups': 'payment_setups',
        'audit_info': 'audit_info'
    }

    def __init__(self, first_name=None, last_name=None, middle_name=None, gender=None, date_of_birth=None, ssn=None, locale=None, email=None, registered_email=None, home_phone=None, work_phone=None, mobile_phone=None, address=None, custom_fields=None, customer_reference=None, id=None, status=None, url=None, comments=None, customer_accounts=None, funding_accounts=None, payments=None, payment_setups=None, audit_info=None):  # noqa: E501
        """CustomerResponse - a model defined in Swagger"""  # noqa: E501

        self._first_name = None
        self._last_name = None
        self._middle_name = None
        self._gender = None
        self._date_of_birth = None
        self._ssn = None
        self._locale = None
        self._email = None
        self._registered_email = None
        self._home_phone = None
        self._work_phone = None
        self._mobile_phone = None
        self._address = None
        self._custom_fields = None
        self._customer_reference = None
        self._id = None
        self._status = None
        self._url = None
        self._comments = None
        self._customer_accounts = None
        self._funding_accounts = None
        self._payments = None
        self._payment_setups = None
        self._audit_info = None
        self.discriminator = None

        if first_name is not None:
            self.first_name = first_name
        if last_name is not None:
            self.last_name = last_name
        if middle_name is not None:
            self.middle_name = middle_name
        if gender is not None:
            self.gender = gender
        if date_of_birth is not None:
            self.date_of_birth = date_of_birth
        if ssn is not None:
            self.ssn = ssn
        if locale is not None:
            self.locale = locale
        if email is not None:
            self.email = email
        if registered_email is not None:
            self.registered_email = registered_email
        if home_phone is not None:
            self.home_phone = home_phone
        if work_phone is not None:
            self.work_phone = work_phone
        if mobile_phone is not None:
            self.mobile_phone = mobile_phone
        if address is not None:
            self.address = address
        if custom_fields is not None:
            self.custom_fields = custom_fields
        if customer_reference is not None:
            self.customer_reference = customer_reference
        self.id = id
        self.status = status
        if url is not None:
            self.url = url
        if comments is not None:
            self.comments = comments
        if customer_accounts is not None:
            self.customer_accounts = customer_accounts
        if funding_accounts is not None:
            self.funding_accounts = funding_accounts
        if payments is not None:
            self.payments = payments
        if payment_setups is not None:
            self.payment_setups = payment_setups
        if audit_info is not None:
            self.audit_info = audit_info

    def __getitem__(self,key):
        return getattr(self,key)

    @property
    def first_name(self):
        """Gets the first_name of this CustomerResponse.  # noqa: E501

        The first name of the customer. Either first_name or last_name is required to create a customer.  # noqa: E501

        :return: The first_name of this CustomerResponse.  # noqa: E501
        :rtype: str
        """
        return self._first_name

    @first_name.setter
    def first_name(self, first_name):
        """Sets the first_name of this CustomerResponse.

        The first name of the customer. Either first_name or last_name is required to create a customer.  # noqa: E501

        :param first_name: The first_name of this CustomerResponse.  # noqa: E501
        :type: str
        """
        self._first_name = first_name

    @property
    def last_name(self):
        """Gets the last_name of this CustomerResponse.  # noqa: E501

        The last name of the customer. Either first_name or last_name is required to create a customer.  # noqa: E501

        :return: The last_name of this CustomerResponse.  # noqa: E501
        :rtype: str
        """
        return self._last_name

    @last_name.setter
    def last_name(self, last_name):
        """Sets the last_name of this CustomerResponse.

        The last name of the customer. Either first_name or last_name is required to create a customer.  # noqa: E501

        :param last_name: The last_name of this CustomerResponse.  # noqa: E501
        :type: str
        """
        self._last_name = last_name

    @property
    def middle_name(self):
        """Gets the middle_name of this CustomerResponse.  # noqa: E501

        The middle name of the customer.  # noqa: E501

        :return: The middle_name of this CustomerResponse.  # noqa: E501
        :rtype: str
        """
        return self._middle_name

    @middle_name.setter
    def middle_name(self, middle_name):
        """Sets the middle_name of this CustomerResponse.

        The middle name of the customer.  # noqa: E501

        :param middle_name: The middle_name of this CustomerResponse.  # noqa: E501
        :type: str
        """
        self._middle_name = middle_name

    @property
    def gender(self):
        """Gets the gender of this CustomerResponse.  # noqa: E501

        The gender of the customer.  # noqa: E501

        :return: The gender of this CustomerResponse.  # noqa: E501
        :rtype: str
        """
        return self._gender

    @gender.setter
    def gender(self, gender):
        """Sets the gender of this CustomerResponse.

        The gender of the customer.  # noqa: E501

        :param gender: The gender of this CustomerResponse.  # noqa: E501
        :type: str
        """
        self._gender = gender

    @property
    def date_of_birth(self):
        """Gets the date_of_birth of this CustomerResponse.  # noqa: E501

        The date of birth of the customer. It should be in the full-date format as per ISO8601, namely, YYYY-MM-DD.  # noqa: E501

        :return: The date_of_birth of this CustomerResponse.  # noqa: E501
        :rtype: str
        """
        return self._date_of_birth

    @date_of_birth.setter
    def date_of_birth(self, date_of_birth):
        """Sets the date_of_birth of this CustomerResponse.

        The date of birth of the customer. It should be in the full-date format as per ISO8601, namely, YYYY-MM-DD.  # noqa: E501

        :param date_of_birth: The date_of_birth of this CustomerResponse.  # noqa: E501
        :type: str
        """
        self._date_of_birth = date_of_birth

    @property
    def ssn(self):
        """Gets the ssn of this CustomerResponse.  # noqa: E501

        The SSN of the customer if the account holder is an individual or the tax ID, if the customer is a business.  # noqa: E501

        :return: The ssn of this CustomerResponse.  # noqa: E501
        :rtype: str
        """
        return self._ssn

    @ssn.setter
    def ssn(self, ssn):
        """Sets the ssn of this CustomerResponse.

        The SSN of the customer if the account holder is an individual or the tax ID, if the customer is a business.  # noqa: E501

        :param ssn: The ssn of this CustomerResponse.  # noqa: E501
        :type: str
        """
        self._ssn = ssn

    @property
    def locale(self):
        """Gets the locale of this CustomerResponse.  # noqa: E501

        The language in which the customer wants the alerts and notifications from EBPP. This is to be specified in the format,<br><i>< <b>ISO-639-1 language code</b>  >_< <b>ISO ALPHA-2 Country Code</b> ></i>.<br> For e.g., <b>en_US</b> indicates the language preference as US English, which is also the default value.  # noqa: E501

        :return: The locale of this CustomerResponse.  # noqa: E501
        :rtype: str
        """
        return self._locale

    @locale.setter
    def locale(self, locale):
        """Sets the locale of this CustomerResponse.

        The language in which the customer wants the alerts and notifications from EBPP. This is to be specified in the format,<br><i>< <b>ISO-639-1 language code</b>  >_< <b>ISO ALPHA-2 Country Code</b> ></i>.<br> For e.g., <b>en_US</b> indicates the language preference as US English, which is also the default value.  # noqa: E501

        :param locale: The locale of this CustomerResponse.  # noqa: E501
        :type: str
        """
        self._locale = locale

    @property
    def email(self):
        """Gets the email of this CustomerResponse.  # noqa: E501

        The email address of the customer to which notifications from EBPP will be sent. This will default to the registered_email while creating a customer.  # noqa: E501

        :return: The email of this CustomerResponse.  # noqa: E501
        :rtype: str
        """
        return self._email

    @email.setter
    def email(self, email):
        """Sets the email of this CustomerResponse.

        The email address of the customer to which notifications from EBPP will be sent. This will default to the registered_email while creating a customer.  # noqa: E501

        :param email: The email of this CustomerResponse.  # noqa: E501
        :type: str
        """
        self._email = email

    @property
    def registered_email(self):
        """Gets the registered_email of this CustomerResponse.  # noqa: E501

        The email address of the customer registered with the client. This may be used to uniquely identify the customer if the client is set up accordingly in EBPP.  # noqa: E501

        :return: The registered_email of this CustomerResponse.  # noqa: E501
        :rtype: str
        """
        return self._registered_email

    @registered_email.setter
    def registered_email(self, registered_email):
        """Sets the registered_email of this CustomerResponse.

        The email address of the customer registered with the client. This may be used to uniquely identify the customer if the client is set up accordingly in EBPP.  # noqa: E501

        :param registered_email: The registered_email of this CustomerResponse.  # noqa: E501
        :type: str
        """
        self._registered_email = registered_email

    @property
    def home_phone(self):
        """Gets the home_phone of this CustomerResponse.  # noqa: E501

        The home phone number of the customer.  # noqa: E501

        :return: The home_phone of this CustomerResponse.  # noqa: E501
        :rtype: str
        """
        return self._home_phone

    @home_phone.setter
    def home_phone(self, home_phone):
        """Sets the home_phone of this CustomerResponse.

        The home phone number of the customer.  # noqa: E501

        :param home_phone: The home_phone of this CustomerResponse.  # noqa: E501
        :type: str
        """
        self._home_phone = home_phone

    @property
    def work_phone(self):
        """Gets the work_phone of this CustomerResponse.  # noqa: E501

        The work phone number of the customer.  # noqa: E501

        :return: The work_phone of this CustomerResponse.  # noqa: E501
        :rtype: str
        """
        return self._work_phone

    @work_phone.setter
    def work_phone(self, work_phone):
        """Sets the work_phone of this CustomerResponse.

        The work phone number of the customer.  # noqa: E501

        :param work_phone: The work_phone of this CustomerResponse.  # noqa: E501
        :type: str
        """
        self._work_phone = work_phone

    @property
    def mobile_phone(self):
        """Gets the mobile_phone of this CustomerResponse.  # noqa: E501

        The mobile phone number of the customer.  # noqa: E501

        :return: The mobile_phone of this CustomerResponse.  # noqa: E501
        :rtype: str
        """
        return self._mobile_phone

    @mobile_phone.setter
    def mobile_phone(self, mobile_phone):
        """Sets the mobile_phone of this CustomerResponse.

        The mobile phone number of the customer.  # noqa: E501

        :param mobile_phone: The mobile_phone of this CustomerResponse.  # noqa: E501
        :type: str
        """
        self._mobile_phone = mobile_phone

    @property
    def address(self):
        """Gets the address of this CustomerResponse.  # noqa: E501


        :return: The address of this CustomerResponse.  # noqa: E501
        :rtype: AddressVo
        """
        return self._address

    @address.setter
    def address(self, address):
        """Sets the address of this CustomerResponse.


        :param address: The address of this CustomerResponse.  # noqa: E501
        :type: AddressVo
        """
        self._address = address

    @property
    def custom_fields(self):
        """Gets the custom_fields of this CustomerResponse.  # noqa: E501

        The additional information or meta-information that EBPP can accept, maintain and transmit back to the client. The custom fields need to be configured with EBPP before they can be accepted. EBPP would reject custom fields that are not pre-configured. Please contact <a href = \"mailto: support@billerpayments.com\">support@billerpayments.com</a> for more information on configuring and using custom fields. Only the custom fields enabled for the client, in EBPP, would be accepted in the requests.  # noqa: E501

        :return: The custom_fields of this CustomerResponse.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._custom_fields

    @custom_fields.setter
    def custom_fields(self, custom_fields):
        """Sets the custom_fields of this CustomerResponse.

        The additional information or meta-information that EBPP can accept, maintain and transmit back to the client. The custom fields need to be configured with EBPP before they can be accepted. EBPP would reject custom fields that are not pre-configured. Please contact <a href = \"mailto: support@billerpayments.com\">support@billerpayments.com</a> for more information on configuring and using custom fields. Only the custom fields enabled for the client, in EBPP, would be accepted in the requests.  # noqa: E501

        :param custom_fields: The custom_fields of this CustomerResponse.  # noqa: E501
        :type: dict(str, str)
        """
        self._custom_fields = custom_fields

    @property
    def customer_reference(self):
        """Gets the customer_reference of this CustomerResponse.  # noqa: E501

        The unique identifier in the client system for the customer.  # noqa: E501

        :return: The customer_reference of this CustomerResponse.  # noqa: E501
        :rtype: str
        """
        return self._customer_reference

    @customer_reference.setter
    def customer_reference(self, customer_reference):
        """Sets the customer_reference of this CustomerResponse.

        The unique identifier in the client system for the customer.  # noqa: E501

        :param customer_reference: The customer_reference of this CustomerResponse.  # noqa: E501
        :type: str
        """
        self._customer_reference = customer_reference

    @property
    def id(self):
        """Gets the id of this CustomerResponse.  # noqa: E501

        The unique identifier assigned by EBPP to the customer.  # noqa: E501

        :return: The id of this CustomerResponse.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this CustomerResponse.

        The unique identifier assigned by EBPP to the customer.  # noqa: E501

        :param id: The id of this CustomerResponse.  # noqa: E501
        :type: str
        """
        self._id = id

    @property
    def status(self):
        """Gets the status of this CustomerResponse.  # noqa: E501

        The status of the customer in EBPP.   # noqa: E501

        :return: The status of this CustomerResponse.  # noqa: E501
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this CustomerResponse.

        The status of the customer in EBPP.   # noqa: E501

        :param status: The status of this CustomerResponse.  # noqa: E501
        :type: str
        """
        self._status = status

    @property
    def url(self):
        """Gets the url of this CustomerResponse.  # noqa: E501

        This URL fetches the Customer details.  # noqa: E501

        :return: The url of this CustomerResponse.  # noqa: E501
        :rtype: str
        """
        return self._url

    @url.setter
    def url(self, url):
        """Sets the url of this CustomerResponse.

        This URL fetches the Customer details.  # noqa: E501

        :param url: The url of this CustomerResponse.  # noqa: E501
        :type: str
        """
        self._url = url

    @property
    def comments(self):
        """Gets the comments of this CustomerResponse.  # noqa: E501

        Comments that can be used to recollect the operation performed on the resource object. API clients need to ensure that no sensitive information is passed in the memo. Alacriti (EBPP) is not responsible for the security of any sensitive information that may be passed as part of the memo.  # noqa: E501

        :return: The comments of this CustomerResponse.  # noqa: E501
        :rtype: str
        """
        return self._comments

    @comments.setter
    def comments(self, comments):
        """Sets the comments of this CustomerResponse.

        Comments that can be used to recollect the operation performed on the resource object. API clients need to ensure that no sensitive information is passed in the memo. Alacriti (EBPP) is not responsible for the security of any sensitive information that may be passed as part of the memo.  # noqa: E501

        :param comments: The comments of this CustomerResponse.  # noqa: E501
        :type: str
        """
        self._comments = comments

    @property
    def customer_accounts(self):
        """Gets the customer_accounts of this CustomerResponse.  # noqa: E501


        :return: The customer_accounts of this CustomerResponse.  # noqa: E501
        :rtype: CustomersCustomerAccountsResponse
        """
        return self._customer_accounts

    @customer_accounts.setter
    def customer_accounts(self, customer_accounts):
        """Sets the customer_accounts of this CustomerResponse.


        :param customer_accounts: The customer_accounts of this CustomerResponse.  # noqa: E501
        :type: CustomersCustomerAccountsResponse
        """
        self._customer_accounts = customer_accounts

    @property
    def funding_accounts(self):
        """Gets the funding_accounts of this CustomerResponse.  # noqa: E501


        :return: The funding_accounts of this CustomerResponse.  # noqa: E501
        :rtype: CustomersFundingAccountsResponse
        """
        return self._funding_accounts

    @funding_accounts.setter
    def funding_accounts(self, funding_accounts):
        """Sets the funding_accounts of this CustomerResponse.


        :param funding_accounts: The funding_accounts of this CustomerResponse.  # noqa: E501
        :type: CustomersFundingAccountsResponse
        """
        self._funding_accounts = funding_accounts

    @property
    def payments(self):
        """Gets the payments of this CustomerResponse.  # noqa: E501


        :return: The payments of this CustomerResponse.  # noqa: E501
        :rtype: CustomersPaymentsResponse
        """
        return self._payments

    @payments.setter
    def payments(self, payments):
        """Sets the payments of this CustomerResponse.


        :param payments: The payments of this CustomerResponse.  # noqa: E501
        :type: CustomersPaymentsResponse
        """
        self._payments = payments

    @property
    def payment_setups(self):
        """Gets the payment_setups of this CustomerResponse.  # noqa: E501


        :return: The payment_setups of this CustomerResponse.  # noqa: E501
        :rtype: CustomersPaymentSetupsResponse
        """
        return self._payment_setups

    @payment_setups.setter
    def payment_setups(self, payment_setups):
        """Sets the payment_setups of this CustomerResponse.


        :param payment_setups: The payment_setups of this CustomerResponse.  # noqa: E501
        :type: CustomersPaymentSetupsResponse
        """
        self._payment_setups = payment_setups

    @property
    def audit_info(self):
        """Gets the audit_info of this CustomerResponse.  # noqa: E501


        :return: The audit_info of this CustomerResponse.  # noqa: E501
        :rtype: AuditInfoVo
        """
        return self._audit_info

    @audit_info.setter
    def audit_info(self, audit_info):
        """Sets the audit_info of this CustomerResponse.


        :param audit_info: The audit_info of this CustomerResponse.  # noqa: E501
        :type: AuditInfoVo
        """
        self._audit_info = audit_info

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CustomerResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CustomerResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
