# coding: utf-8

"""
    ############################################################################################
    ## This class subject to change without prior notice, Please dont use this class directly.##
    ############################################################################################
"""


import pprint
import re  # noqa: F401

import six

from orbipay_paymentsapi_client.models.address_vo import AddressVo  # noqa: F401,E501


class CustomerSnapshotResponse(object):
    """NOTE: 
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'url': 'str',
        'customer_reference': 'str',
        'first_name': 'str',
        'last_name': 'str',
        'middle_name': 'str',
        'email': 'str',
        'home_phone': 'str',
        'address': 'AddressVo'
    }

    attribute_map = {
        'id': 'id',
        'url': 'url',
        'customer_reference': 'customer_reference',
        'first_name': 'first_name',
        'last_name': 'last_name',
        'middle_name': 'middle_name',
        'email': 'email',
        'home_phone': 'home_phone',
        'address': 'address'
    }

    def __init__(self, id=None, url=None, customer_reference=None, first_name=None, last_name=None, middle_name=None, email=None, home_phone=None, address=None):  # noqa: E501
        """CustomerSnapshotResponse - a model defined in Swagger"""  # noqa: E501

        self._id = None
        self._url = None
        self._customer_reference = None
        self._first_name = None
        self._last_name = None
        self._middle_name = None
        self._email = None
        self._home_phone = None
        self._address = None
        self.discriminator = None

        if id is not None:
            self.id = id
        if url is not None:
            self.url = url
        if customer_reference is not None:
            self.customer_reference = customer_reference
        if first_name is not None:
            self.first_name = first_name
        if last_name is not None:
            self.last_name = last_name
        if middle_name is not None:
            self.middle_name = middle_name
        if email is not None:
            self.email = email
        if home_phone is not None:
            self.home_phone = home_phone
        if address is not None:
            self.address = address

    def __getitem__(self,key):
        return getattr(self,key)

    @property
    def id(self):
        """Gets the id of this CustomerSnapshotResponse.  # noqa: E501

        The unique identifier assigned by EBPP to the customer.  # noqa: E501

        :return: The id of this CustomerSnapshotResponse.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this CustomerSnapshotResponse.

        The unique identifier assigned by EBPP to the customer.  # noqa: E501

        :param id: The id of this CustomerSnapshotResponse.  # noqa: E501
        :type: str
        """
        self._id = id

    @property
    def url(self):
        """Gets the url of this CustomerSnapshotResponse.  # noqa: E501

        The URL that can be used to fetch the details of the customer.  # noqa: E501

        :return: The url of this CustomerSnapshotResponse.  # noqa: E501
        :rtype: str
        """
        return self._url

    @url.setter
    def url(self, url):
        """Sets the url of this CustomerSnapshotResponse.

        The URL that can be used to fetch the details of the customer.  # noqa: E501

        :param url: The url of this CustomerSnapshotResponse.  # noqa: E501
        :type: str
        """
        self._url = url

    @property
    def customer_reference(self):
        """Gets the customer_reference of this CustomerSnapshotResponse.  # noqa: E501

        The unique identifier in the client system for the customer.  # noqa: E501

        :return: The customer_reference of this CustomerSnapshotResponse.  # noqa: E501
        :rtype: str
        """
        return self._customer_reference

    @customer_reference.setter
    def customer_reference(self, customer_reference):
        """Sets the customer_reference of this CustomerSnapshotResponse.

        The unique identifier in the client system for the customer.  # noqa: E501

        :param customer_reference: The customer_reference of this CustomerSnapshotResponse.  # noqa: E501
        :type: str
        """
        self._customer_reference = customer_reference

    @property
    def first_name(self):
        """Gets the first_name of this CustomerSnapshotResponse.  # noqa: E501

        The first name of the customer.  # noqa: E501

        :return: The first_name of this CustomerSnapshotResponse.  # noqa: E501
        :rtype: str
        """
        return self._first_name

    @first_name.setter
    def first_name(self, first_name):
        """Sets the first_name of this CustomerSnapshotResponse.

        The first name of the customer.  # noqa: E501

        :param first_name: The first_name of this CustomerSnapshotResponse.  # noqa: E501
        :type: str
        """
        self._first_name = first_name

    @property
    def last_name(self):
        """Gets the last_name of this CustomerSnapshotResponse.  # noqa: E501

        The last name of the customer.  # noqa: E501

        :return: The last_name of this CustomerSnapshotResponse.  # noqa: E501
        :rtype: str
        """
        return self._last_name

    @last_name.setter
    def last_name(self, last_name):
        """Sets the last_name of this CustomerSnapshotResponse.

        The last name of the customer.  # noqa: E501

        :param last_name: The last_name of this CustomerSnapshotResponse.  # noqa: E501
        :type: str
        """
        self._last_name = last_name

    @property
    def middle_name(self):
        """Gets the middle_name of this CustomerSnapshotResponse.  # noqa: E501

        The middle initial of the customer.  # noqa: E501

        :return: The middle_name of this CustomerSnapshotResponse.  # noqa: E501
        :rtype: str
        """
        return self._middle_name

    @middle_name.setter
    def middle_name(self, middle_name):
        """Sets the middle_name of this CustomerSnapshotResponse.

        The middle initial of the customer.  # noqa: E501

        :param middle_name: The middle_name of this CustomerSnapshotResponse.  # noqa: E501
        :type: str
        """
        self._middle_name = middle_name

    @property
    def email(self):
        """Gets the email of this CustomerSnapshotResponse.  # noqa: E501

        The email address of the customer to which notifications from EBPP will be sent. This will default to the registered_email while creating a customer.  # noqa: E501

        :return: The email of this CustomerSnapshotResponse.  # noqa: E501
        :rtype: str
        """
        return self._email

    @email.setter
    def email(self, email):
        """Sets the email of this CustomerSnapshotResponse.

        The email address of the customer to which notifications from EBPP will be sent. This will default to the registered_email while creating a customer.  # noqa: E501

        :param email: The email of this CustomerSnapshotResponse.  # noqa: E501
        :type: str
        """
        self._email = email

    @property
    def home_phone(self):
        """Gets the home_phone of this CustomerSnapshotResponse.  # noqa: E501

        The home phone number of the customer.  # noqa: E501

        :return: The home_phone of this CustomerSnapshotResponse.  # noqa: E501
        :rtype: str
        """
        return self._home_phone

    @home_phone.setter
    def home_phone(self, home_phone):
        """Sets the home_phone of this CustomerSnapshotResponse.

        The home phone number of the customer.  # noqa: E501

        :param home_phone: The home_phone of this CustomerSnapshotResponse.  # noqa: E501
        :type: str
        """
        self._home_phone = home_phone

    @property
    def address(self):
        """Gets the address of this CustomerSnapshotResponse.  # noqa: E501


        :return: The address of this CustomerSnapshotResponse.  # noqa: E501
        :rtype: AddressVo
        """
        return self._address

    @address.setter
    def address(self, address):
        """Sets the address of this CustomerSnapshotResponse.


        :param address: The address of this CustomerSnapshotResponse.  # noqa: E501
        :type: AddressVo
        """
        self._address = address

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CustomerSnapshotResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CustomerSnapshotResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
