# coding: utf-8

"""
    ############################################################################################
    ## This class subject to change without prior notice, Please dont use this class directly.##
    ############################################################################################
"""


import pprint
import re  # noqa: F401

import six


class ErrorVo(object):
    """NOTE: 
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'code': 'str',
        'message': 'str',
        'field': 'str'
    }

    attribute_map = {
        'code': 'code',
        'message': 'message',
        'field': 'field'
    }

    def __init__(self, code=None, message=None, field=None):  # noqa: E501
        """ErrorVo - a model defined in Swagger"""  # noqa: E501

        self._code = None
        self._message = None
        self._field = None
        self.discriminator = None

        self.code = code
        self.message = message
        if field is not None:
            self.field = field

    def __getitem__(self,key):
        return getattr(self,key)

    @property
    def code(self):
        """Gets the code of this ErrorVo.  # noqa: E501

        A string indicating error  # noqa: E501

        :return: The code of this ErrorVo.  # noqa: E501
        :rtype: str
        """
        return self._code

    @code.setter
    def code(self, code):
        """Sets the code of this ErrorVo.

        A string indicating error  # noqa: E501

        :param code: The code of this ErrorVo.  # noqa: E501
        :type: str
        """
        self._code = code

    @property
    def message(self):
        """Gets the message of this ErrorVo.  # noqa: E501

        A human-readable message providing more details about the error.  # noqa: E501

        :return: The message of this ErrorVo.  # noqa: E501
        :rtype: str
        """
        return self._message

    @message.setter
    def message(self, message):
        """Sets the message of this ErrorVo.

        A human-readable message providing more details about the error.  # noqa: E501

        :param message: The message of this ErrorVo.  # noqa: E501
        :type: str
        """
        self._message = message

    @property
    def field(self):
        """Gets the field of this ErrorVo.  # noqa: E501

        Refers to the field in the request, if the error is specific to it.  # noqa: E501

        :return: The field of this ErrorVo.  # noqa: E501
        :rtype: str
        """
        return self._field

    @field.setter
    def field(self, field):
        """Sets the field of this ErrorVo.

        Refers to the field in the request, if the error is specific to it.  # noqa: E501

        :param field: The field of this ErrorVo.  # noqa: E501
        :type: str
        """
        self._field = field

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ErrorVo, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ErrorVo):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
