# coding: utf-8

"""
    ############################################################################################
    ## This class subject to change without prior notice, Please dont use this class directly.##
    ############################################################################################
"""


import pprint
import re  # noqa: F401

import six


class FeeResponse(object):
    """NOTE: 
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'fee_type': 'str',
        'fee_amount': 'str',
        'id': 'str',
        'url': 'str'
    }

    attribute_map = {
        'fee_type': 'fee_type',
        'fee_amount': 'fee_amount',
        'id': 'id',
        'url': 'url'
    }

    def __init__(self, fee_type=None, fee_amount=None, id=None, url=None):  # noqa: E501
        """FeeResponse - a model defined in Swagger"""  # noqa: E501

        self._fee_type = None
        self._fee_amount = None
        self._id = None
        self._url = None
        self.discriminator = None

        if fee_type is not None:
            self.fee_type = fee_type
        if fee_amount is not None:
            self.fee_amount = fee_amount
        if id is not None:
            self.id = id
        if url is not None:
            self.url = url

    def __getitem__(self,key):
        return getattr(self,key)

    @property
    def fee_type(self):
        """Gets the fee_type of this FeeResponse.  # noqa: E501

        The way the fee is being charged to the customer. Fee could be added to the amount being paid, or, it could be charged separately by the biller. The fee_type would default to add_to_principal if the fee is not configured for the client in EBPP.  # noqa: E501

        :return: The fee_type of this FeeResponse.  # noqa: E501
        :rtype: str
        """
        return self._fee_type

    @fee_type.setter
    def fee_type(self, fee_type):
        """Sets the fee_type of this FeeResponse.

        The way the fee is being charged to the customer. Fee could be added to the amount being paid, or, it could be charged separately by the biller. The fee_type would default to add_to_principal if the fee is not configured for the client in EBPP.  # noqa: E501

        :param fee_type: The fee_type of this FeeResponse.  # noqa: E501
        :type: str
        """
        self._fee_type = fee_type

    @property
    def fee_amount(self):
        """Gets the fee_amount of this FeeResponse.  # noqa: E501

        The fee amount upto 2 decimal places.  # noqa: E501

        :return: The fee_amount of this FeeResponse.  # noqa: E501
        :rtype: str
        """
        return self._fee_amount

    @fee_amount.setter
    def fee_amount(self, fee_amount):
        """Sets the fee_amount of this FeeResponse.

        The fee amount upto 2 decimal places.  # noqa: E501

        :param fee_amount: The fee_amount of this FeeResponse.  # noqa: E501
        :type: str
        """
        self._fee_amount = fee_amount

    @property
    def id(self):
        """Gets the id of this FeeResponse.  # noqa: E501

        The unique identifier assigned by EBPP to the fee. In case of split fee.  # noqa: E501

        :return: The id of this FeeResponse.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this FeeResponse.

        The unique identifier assigned by EBPP to the fee. In case of split fee.  # noqa: E501

        :param id: The id of this FeeResponse.  # noqa: E501
        :type: str
        """
        self._id = id

    @property
    def url(self):
        """Gets the url of this FeeResponse.  # noqa: E501

        This URL fetches the details of fee as a payment resource. In case of split fee.  # noqa: E501

        :return: The url of this FeeResponse.  # noqa: E501
        :rtype: str
        """
        return self._url

    @url.setter
    def url(self, url):
        """Sets the url of this FeeResponse.

        This URL fetches the details of fee as a payment resource. In case of split fee.  # noqa: E501

        :param url: The url of this FeeResponse.  # noqa: E501
        :type: str
        """
        self._url = url

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(FeeResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, FeeResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
