# coding: utf-8

"""
    ############################################################################################
    ## This class subject to change without prior notice, Please dont use this class directly.##
    ############################################################################################
"""


import pprint
import re  # noqa: F401

import six

from orbipay_paymentsapi_client.models.audit_info_vo import AuditInfoVo  # noqa: F401,E501
from orbipay_paymentsapi_client.models.funding_account_address import FundingAccountAddress  # noqa: F401,E501


class FundingAccountResponse(object):
    """NOTE: 
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'account_holder_name': 'str',
        'nickname': 'str',
        'address': 'FundingAccountAddress',
        'account_number': 'str',
        'aba_routing_number': 'str',
        'issuer_name': 'str',
        'currency_code3d': 'str',
        'expiry_date': 'str',
        'account_holder_type': 'str',
        'custom_fields': 'dict(str, str)',
        'account_subtype': 'str',
        'id': 'str',
        'url': 'str',
        'ach_eligible_flag': 'str',
        'atm_eligible_flag': 'str',
        'card_cvv_number': 'str',
        'account_type': 'str',
        'status': 'str',
        'display_text': 'str',
        'comments': 'str',
        'audit_info': 'AuditInfoVo'
    }

    attribute_map = {
        'account_holder_name': 'account_holder_name',
        'nickname': 'nickname',
        'address': 'address',
        'account_number': 'account_number',
        'aba_routing_number': 'aba_routing_number',
        'issuer_name': 'issuer_name',
        'currency_code3d': 'currency_code3d',
        'expiry_date': 'expiry_date',
        'account_holder_type': 'account_holder_type',
        'custom_fields': 'custom_fields',
        'account_subtype': 'account_subtype',
        'id': 'id',
        'url': 'url',
        'ach_eligible_flag': 'ach_eligible_flag',
        'atm_eligible_flag': 'atm_eligible_flag',
        'card_cvv_number': 'card_cvv_number',
        'account_type': 'account_type',
        'status': 'status',
        'display_text': 'display_text',
        'comments': 'comments',
        'audit_info': 'audit_info'
    }

    def __init__(self, account_holder_name=None, nickname=None, address=None, account_number=None, aba_routing_number=None, issuer_name=None, currency_code3d=None, expiry_date=None, account_holder_type=None, custom_fields=None, account_subtype=None, id=None, url=None, ach_eligible_flag=None, atm_eligible_flag=None, card_cvv_number=None, account_type=None, status=None, display_text=None, comments=None, audit_info=None):  # noqa: E501
        """FundingAccountResponse - a model defined in Swagger"""  # noqa: E501

        self._account_holder_name = None
        self._nickname = None
        self._address = None
        self._account_number = None
        self._aba_routing_number = None
        self._issuer_name = None
        self._currency_code3d = None
        self._expiry_date = None
        self._account_holder_type = None
        self._custom_fields = None
        self._account_subtype = None
        self._id = None
        self._url = None
        self._ach_eligible_flag = None
        self._atm_eligible_flag = None
        self._card_cvv_number = None
        self._account_type = None
        self._status = None
        self._display_text = None
        self._comments = None
        self._audit_info = None
        self.discriminator = None

        if account_holder_name is not None:
            self.account_holder_name = account_holder_name
        if nickname is not None:
            self.nickname = nickname
        if address is not None:
            self.address = address
        if account_number is not None:
            self.account_number = account_number
        if aba_routing_number is not None:
            self.aba_routing_number = aba_routing_number
        if issuer_name is not None:
            self.issuer_name = issuer_name
        if currency_code3d is not None:
            self.currency_code3d = currency_code3d
        if expiry_date is not None:
            self.expiry_date = expiry_date
        if account_holder_type is not None:
            self.account_holder_type = account_holder_type
        if custom_fields is not None:
            self.custom_fields = custom_fields
        if account_subtype is not None:
            self.account_subtype = account_subtype
        if id is not None:
            self.id = id
        if url is not None:
            self.url = url
        if ach_eligible_flag is not None:
            self.ach_eligible_flag = ach_eligible_flag
        if atm_eligible_flag is not None:
            self.atm_eligible_flag = atm_eligible_flag
        if card_cvv_number is not None:
            self.card_cvv_number = card_cvv_number
        if account_type is not None:
            self.account_type = account_type
        if status is not None:
            self.status = status
        if display_text is not None:
            self.display_text = display_text
        if comments is not None:
            self.comments = comments
        if audit_info is not None:
            self.audit_info = audit_info

    def __getitem__(self,key):
        return getattr(self,key)

    @property
    def account_holder_name(self):
        """Gets the account_holder_name of this FundingAccountResponse.  # noqa: E501

        The name as specified on the account.  # noqa: E501

        :return: The account_holder_name of this FundingAccountResponse.  # noqa: E501
        :rtype: str
        """
        return self._account_holder_name

    @account_holder_name.setter
    def account_holder_name(self, account_holder_name):
        """Sets the account_holder_name of this FundingAccountResponse.

        The name as specified on the account.  # noqa: E501

        :param account_holder_name: The account_holder_name of this FundingAccountResponse.  # noqa: E501
        :type: str
        """
        self._account_holder_name = account_holder_name

    @property
    def nickname(self):
        """Gets the nickname of this FundingAccountResponse.  # noqa: E501

        The nickname by which a customer might want to identify the account.  # noqa: E501

        :return: The nickname of this FundingAccountResponse.  # noqa: E501
        :rtype: str
        """
        return self._nickname

    @nickname.setter
    def nickname(self, nickname):
        """Sets the nickname of this FundingAccountResponse.

        The nickname by which a customer might want to identify the account.  # noqa: E501

        :param nickname: The nickname of this FundingAccountResponse.  # noqa: E501
        :type: str
        """
        self._nickname = nickname

    @property
    def address(self):
        """Gets the address of this FundingAccountResponse.  # noqa: E501


        :return: The address of this FundingAccountResponse.  # noqa: E501
        :rtype: FundingAccountAddress
        """
        return self._address

    @address.setter
    def address(self, address):
        """Sets the address of this FundingAccountResponse.


        :param address: The address of this FundingAccountResponse.  # noqa: E501
        :type: FundingAccountAddress
        """
        self._address = address

    @property
    def account_number(self):
        """Gets the account_number of this FundingAccountResponse.  # noqa: E501

        The number or reference that a customer uses to identify the funding account. In case of Apple Pay, this is the device-specific account number of the card.  # noqa: E501

        :return: The account_number of this FundingAccountResponse.  # noqa: E501
        :rtype: str
        """
        return self._account_number

    @account_number.setter
    def account_number(self, account_number):
        """Sets the account_number of this FundingAccountResponse.

        The number or reference that a customer uses to identify the funding account. In case of Apple Pay, this is the device-specific account number of the card.  # noqa: E501

        :param account_number: The account_number of this FundingAccountResponse.  # noqa: E501
        :type: str
        """
        self._account_number = account_number

    @property
    def aba_routing_number(self):
        """Gets the aba_routing_number of this FundingAccountResponse.  # noqa: E501

        The ABA/Routing number for the bank account.  # noqa: E501

        :return: The aba_routing_number of this FundingAccountResponse.  # noqa: E501
        :rtype: str
        """
        return self._aba_routing_number

    @aba_routing_number.setter
    def aba_routing_number(self, aba_routing_number):
        """Sets the aba_routing_number of this FundingAccountResponse.

        The ABA/Routing number for the bank account.  # noqa: E501

        :param aba_routing_number: The aba_routing_number of this FundingAccountResponse.  # noqa: E501
        :type: str
        """
        self._aba_routing_number = aba_routing_number

    @property
    def issuer_name(self):
        """Gets the issuer_name of this FundingAccountResponse.  # noqa: E501

        The name of the authority that has issued the account. This is relevant only in the case of bank accounts.  # noqa: E501

        :return: The issuer_name of this FundingAccountResponse.  # noqa: E501
        :rtype: str
        """
        return self._issuer_name

    @issuer_name.setter
    def issuer_name(self, issuer_name):
        """Sets the issuer_name of this FundingAccountResponse.

        The name of the authority that has issued the account. This is relevant only in the case of bank accounts.  # noqa: E501

        :param issuer_name: The issuer_name of this FundingAccountResponse.  # noqa: E501
        :type: str
        """
        self._issuer_name = issuer_name

    @property
    def currency_code3d(self):
        """Gets the currency_code3d of this FundingAccountResponse.  # noqa: E501

        The three-letter currency code in the ISO4217 format, in uppercase, for the card account. It must be a currency supported by EBPP. This defaults to USD.  # noqa: E501

        :return: The currency_code3d of this FundingAccountResponse.  # noqa: E501
        :rtype: str
        """
        return self._currency_code3d

    @currency_code3d.setter
    def currency_code3d(self, currency_code3d):
        """Sets the currency_code3d of this FundingAccountResponse.

        The three-letter currency code in the ISO4217 format, in uppercase, for the card account. It must be a currency supported by EBPP. This defaults to USD.  # noqa: E501

        :param currency_code3d: The currency_code3d of this FundingAccountResponse.  # noqa: E501
        :type: str
        """
        self._currency_code3d = currency_code3d

    @property
    def expiry_date(self):
        """Gets the expiry_date of this FundingAccountResponse.  # noqa: E501

        The expiry date for the card. This is to be in the format MM/YY.  # noqa: E501

        :return: The expiry_date of this FundingAccountResponse.  # noqa: E501
        :rtype: str
        """
        return self._expiry_date

    @expiry_date.setter
    def expiry_date(self, expiry_date):
        """Sets the expiry_date of this FundingAccountResponse.

        The expiry date for the card. This is to be in the format MM/YY.  # noqa: E501

        :param expiry_date: The expiry_date of this FundingAccountResponse.  # noqa: E501
        :type: str
        """
        self._expiry_date = expiry_date

    @property
    def account_holder_type(self):
        """Gets the account_holder_type of this FundingAccountResponse.  # noqa: E501

        The type of ownership for the funding account. This is applicable only in the case of bank accounts and it is defaults to personal.   # noqa: E501

        :return: The account_holder_type of this FundingAccountResponse.  # noqa: E501
        :rtype: str
        """
        return self._account_holder_type

    @account_holder_type.setter
    def account_holder_type(self, account_holder_type):
        """Sets the account_holder_type of this FundingAccountResponse.

        The type of ownership for the funding account. This is applicable only in the case of bank accounts and it is defaults to personal.   # noqa: E501

        :param account_holder_type: The account_holder_type of this FundingAccountResponse.  # noqa: E501
        :type: str
        """
        self._account_holder_type = account_holder_type

    @property
    def custom_fields(self):
        """Gets the custom_fields of this FundingAccountResponse.  # noqa: E501

        The additional information or meta-information that EBPP can accept, maintain and transmit back to the client. The custom fields need to be configured with EBPP before they can be accepted. EBPP would reject custom fields that are not pre-configured. Please contact <a href = \"mailto: support@billerpayments.com\">support@billerpayments.com</a> for more information on configuring and using custom fields. Only the custom fields enabled for the client, in EBPP, would be accepted in the requests.  # noqa: E501

        :return: The custom_fields of this FundingAccountResponse.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._custom_fields

    @custom_fields.setter
    def custom_fields(self, custom_fields):
        """Sets the custom_fields of this FundingAccountResponse.

        The additional information or meta-information that EBPP can accept, maintain and transmit back to the client. The custom fields need to be configured with EBPP before they can be accepted. EBPP would reject custom fields that are not pre-configured. Please contact <a href = \"mailto: support@billerpayments.com\">support@billerpayments.com</a> for more information on configuring and using custom fields. Only the custom fields enabled for the client, in EBPP, would be accepted in the requests.  # noqa: E501

        :param custom_fields: The custom_fields of this FundingAccountResponse.  # noqa: E501
        :type: dict(str, str)
        """
        self._custom_fields = custom_fields

    @property
    def account_subtype(self):
        """Gets the account_subtype of this FundingAccountResponse.  # noqa: E501

        The sub type of the funding account. This is derived by EBPP in the case of card funding accounts. It needs to be passed when adding or editing a DDA/Bank/ApplePay/GooglePay/Voyager account.  # noqa: E501

        :return: The account_subtype of this FundingAccountResponse.  # noqa: E501
        :rtype: str
        """
        return self._account_subtype

    @account_subtype.setter
    def account_subtype(self, account_subtype):
        """Sets the account_subtype of this FundingAccountResponse.

        The sub type of the funding account. This is derived by EBPP in the case of card funding accounts. It needs to be passed when adding or editing a DDA/Bank/ApplePay/GooglePay/Voyager account.  # noqa: E501

        :param account_subtype: The account_subtype of this FundingAccountResponse.  # noqa: E501
        :type: str
        """
        self._account_subtype = account_subtype

    @property
    def id(self):
        """Gets the id of this FundingAccountResponse.  # noqa: E501

        Id is a unique identifier assigned to the funding account in EBPP. A new Id is generated for the funding account when the account number is updated.  # noqa: E501

        :return: The id of this FundingAccountResponse.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this FundingAccountResponse.

        Id is a unique identifier assigned to the funding account in EBPP. A new Id is generated for the funding account when the account number is updated.  # noqa: E501

        :param id: The id of this FundingAccountResponse.  # noqa: E501
        :type: str
        """
        self._id = id

    @property
    def url(self):
        """Gets the url of this FundingAccountResponse.  # noqa: E501

        This URL fetches the funding account details.  # noqa: E501

        :return: The url of this FundingAccountResponse.  # noqa: E501
        :rtype: str
        """
        return self._url

    @url.setter
    def url(self, url):
        """Sets the url of this FundingAccountResponse.

        This URL fetches the funding account details.  # noqa: E501

        :param url: The url of this FundingAccountResponse.  # noqa: E501
        :type: str
        """
        self._url = url

    @property
    def ach_eligible_flag(self):
        """Gets the ach_eligible_flag of this FundingAccountResponse.  # noqa: E501

        Indicates if the funding account can be debited vide ACH, in case the funding account is a Demand Deposit Account (DDA).  # noqa: E501

        :return: The ach_eligible_flag of this FundingAccountResponse.  # noqa: E501
        :rtype: str
        """
        return self._ach_eligible_flag

    @ach_eligible_flag.setter
    def ach_eligible_flag(self, ach_eligible_flag):
        """Sets the ach_eligible_flag of this FundingAccountResponse.

        Indicates if the funding account can be debited vide ACH, in case the funding account is a Demand Deposit Account (DDA).  # noqa: E501

        :param ach_eligible_flag: The ach_eligible_flag of this FundingAccountResponse.  # noqa: E501
        :type: str
        """
        self._ach_eligible_flag = ach_eligible_flag

    @property
    def atm_eligible_flag(self):
        """Gets the atm_eligible_flag of this FundingAccountResponse.  # noqa: E501

        Indicates if the funding account can be debited vide the ATM Rail network, in case the funding account is a Debit Card.  # noqa: E501

        :return: The atm_eligible_flag of this FundingAccountResponse.  # noqa: E501
        :rtype: str
        """
        return self._atm_eligible_flag

    @atm_eligible_flag.setter
    def atm_eligible_flag(self, atm_eligible_flag):
        """Sets the atm_eligible_flag of this FundingAccountResponse.

        Indicates if the funding account can be debited vide the ATM Rail network, in case the funding account is a Debit Card.  # noqa: E501

        :param atm_eligible_flag: The atm_eligible_flag of this FundingAccountResponse.  # noqa: E501
        :type: str
        """
        self._atm_eligible_flag = atm_eligible_flag

    @property
    def card_cvv_number(self):
        """Gets the card_cvv_number of this FundingAccountResponse.  # noqa: E501

        This is never returned by EBPP. This needs to be passed to EBPP when adding or editing a card funding account.  # noqa: E501

        :return: The card_cvv_number of this FundingAccountResponse.  # noqa: E501
        :rtype: str
        """
        return self._card_cvv_number

    @card_cvv_number.setter
    def card_cvv_number(self, card_cvv_number):
        """Sets the card_cvv_number of this FundingAccountResponse.

        This is never returned by EBPP. This needs to be passed to EBPP when adding or editing a card funding account.  # noqa: E501

        :param card_cvv_number: The card_cvv_number of this FundingAccountResponse.  # noqa: E501
        :type: str
        """
        self._card_cvv_number = card_cvv_number

    @property
    def account_type(self):
        """Gets the account_type of this FundingAccountResponse.  # noqa: E501

        The type of the funding account.  # noqa: E501

        :return: The account_type of this FundingAccountResponse.  # noqa: E501
        :rtype: str
        """
        return self._account_type

    @account_type.setter
    def account_type(self, account_type):
        """Sets the account_type of this FundingAccountResponse.

        The type of the funding account.  # noqa: E501

        :param account_type: The account_type of this FundingAccountResponse.  # noqa: E501
        :type: str
        """
        self._account_type = account_type

    @property
    def status(self):
        """Gets the status of this FundingAccountResponse.  # noqa: E501

        The status of the funding account in EBPP.   # noqa: E501

        :return: The status of this FundingAccountResponse.  # noqa: E501
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this FundingAccountResponse.

        The status of the funding account in EBPP.   # noqa: E501

        :param status: The status of this FundingAccountResponse.  # noqa: E501
        :type: str
        """
        self._status = status

    @property
    def display_text(self):
        """Gets the display_text of this FundingAccountResponse.  # noqa: E501

        UI representation of the account.  # noqa: E501

        :return: The display_text of this FundingAccountResponse.  # noqa: E501
        :rtype: str
        """
        return self._display_text

    @display_text.setter
    def display_text(self, display_text):
        """Sets the display_text of this FundingAccountResponse.

        UI representation of the account.  # noqa: E501

        :param display_text: The display_text of this FundingAccountResponse.  # noqa: E501
        :type: str
        """
        self._display_text = display_text

    @property
    def comments(self):
        """Gets the comments of this FundingAccountResponse.  # noqa: E501

        Comments that can be used to recollect the operation performed on the resource object. API clients need to ensure that no sensitive information is passed in the memo. Alacriti (EBPP) is not responsible for the security of any sensitive information that may be passed as part of the memo.  # noqa: E501

        :return: The comments of this FundingAccountResponse.  # noqa: E501
        :rtype: str
        """
        return self._comments

    @comments.setter
    def comments(self, comments):
        """Sets the comments of this FundingAccountResponse.

        Comments that can be used to recollect the operation performed on the resource object. API clients need to ensure that no sensitive information is passed in the memo. Alacriti (EBPP) is not responsible for the security of any sensitive information that may be passed as part of the memo.  # noqa: E501

        :param comments: The comments of this FundingAccountResponse.  # noqa: E501
        :type: str
        """
        self._comments = comments

    @property
    def audit_info(self):
        """Gets the audit_info of this FundingAccountResponse.  # noqa: E501


        :return: The audit_info of this FundingAccountResponse.  # noqa: E501
        :rtype: AuditInfoVo
        """
        return self._audit_info

    @audit_info.setter
    def audit_info(self, audit_info):
        """Sets the audit_info of this FundingAccountResponse.


        :param audit_info: The audit_info of this FundingAccountResponse.  # noqa: E501
        :type: AuditInfoVo
        """
        self._audit_info = audit_info

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(FundingAccountResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, FundingAccountResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
