# coding: utf-8

"""
    ############################################################################################
    ## This class subject to change without prior notice, Please dont use this class directly.##
    ############################################################################################
"""


import pprint
import re  # noqa: F401

import six


class FundingAccountSnapshotResponse(object):
    """NOTE: 
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'url': 'str',
        'account_number': 'str',
        'account_type': 'str',
        'account_subtype': 'str',
        'aba_routing_number': 'str',
        'issuer_name': 'str',
        'nickname': 'str',
        'display_text': 'str',
        'account_holder_name': 'str'
    }

    attribute_map = {
        'id': 'id',
        'url': 'url',
        'account_number': 'account_number',
        'account_type': 'account_type',
        'account_subtype': 'account_subtype',
        'aba_routing_number': 'aba_routing_number',
        'issuer_name': 'issuer_name',
        'nickname': 'nickname',
        'display_text': 'display_text',
        'account_holder_name': 'account_holder_name'
    }

    def __init__(self, id=None, url=None, account_number=None, account_type=None, account_subtype=None, aba_routing_number=None, issuer_name=None, nickname=None, display_text=None, account_holder_name=None):  # noqa: E501
        """FundingAccountSnapshotResponse - a model defined in Swagger"""  # noqa: E501

        self._id = None
        self._url = None
        self._account_number = None
        self._account_type = None
        self._account_subtype = None
        self._aba_routing_number = None
        self._issuer_name = None
        self._nickname = None
        self._display_text = None
        self._account_holder_name = None
        self.discriminator = None

        if id is not None:
            self.id = id
        if url is not None:
            self.url = url
        if account_number is not None:
            self.account_number = account_number
        if account_type is not None:
            self.account_type = account_type
        if account_subtype is not None:
            self.account_subtype = account_subtype
        if aba_routing_number is not None:
            self.aba_routing_number = aba_routing_number
        if issuer_name is not None:
            self.issuer_name = issuer_name
        if nickname is not None:
            self.nickname = nickname
        if display_text is not None:
            self.display_text = display_text
        if account_holder_name is not None:
            self.account_holder_name = account_holder_name

    def __getitem__(self,key):
        return getattr(self,key)

    @property
    def id(self):
        """Gets the id of this FundingAccountSnapshotResponse.  # noqa: E501

        Id is a unique identifier assigned to the account in EBPP.  # noqa: E501

        :return: The id of this FundingAccountSnapshotResponse.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this FundingAccountSnapshotResponse.

        Id is a unique identifier assigned to the account in EBPP.  # noqa: E501

        :param id: The id of this FundingAccountSnapshotResponse.  # noqa: E501
        :type: str
        """
        self._id = id

    @property
    def url(self):
        """Gets the url of this FundingAccountSnapshotResponse.  # noqa: E501

        This URL fetches the funding account details.  # noqa: E501

        :return: The url of this FundingAccountSnapshotResponse.  # noqa: E501
        :rtype: str
        """
        return self._url

    @url.setter
    def url(self, url):
        """Sets the url of this FundingAccountSnapshotResponse.

        This URL fetches the funding account details.  # noqa: E501

        :param url: The url of this FundingAccountSnapshotResponse.  # noqa: E501
        :type: str
        """
        self._url = url

    @property
    def account_number(self):
        """Gets the account_number of this FundingAccountSnapshotResponse.  # noqa: E501

        The number or reference that a customer uses to identify the funding account. In case of Apple Pay, this is the device-specific account number of the card.  # noqa: E501

        :return: The account_number of this FundingAccountSnapshotResponse.  # noqa: E501
        :rtype: str
        """
        return self._account_number

    @account_number.setter
    def account_number(self, account_number):
        """Sets the account_number of this FundingAccountSnapshotResponse.

        The number or reference that a customer uses to identify the funding account. In case of Apple Pay, this is the device-specific account number of the card.  # noqa: E501

        :param account_number: The account_number of this FundingAccountSnapshotResponse.  # noqa: E501
        :type: str
        """
        self._account_number = account_number

    @property
    def account_type(self):
        """Gets the account_type of this FundingAccountSnapshotResponse.  # noqa: E501

        The type of the funding account.  # noqa: E501

        :return: The account_type of this FundingAccountSnapshotResponse.  # noqa: E501
        :rtype: str
        """
        return self._account_type

    @account_type.setter
    def account_type(self, account_type):
        """Sets the account_type of this FundingAccountSnapshotResponse.

        The type of the funding account.  # noqa: E501

        :param account_type: The account_type of this FundingAccountSnapshotResponse.  # noqa: E501
        :type: str
        """
        self._account_type = account_type

    @property
    def account_subtype(self):
        """Gets the account_subtype of this FundingAccountSnapshotResponse.  # noqa: E501

        The sub type of the funding account. This is derived by EBPP in the case of card funding accounts. It needs to be passed when adding or editing a DDA/Bank/ApplePay account.  # noqa: E501

        :return: The account_subtype of this FundingAccountSnapshotResponse.  # noqa: E501
        :rtype: str
        """
        return self._account_subtype

    @account_subtype.setter
    def account_subtype(self, account_subtype):
        """Sets the account_subtype of this FundingAccountSnapshotResponse.

        The sub type of the funding account. This is derived by EBPP in the case of card funding accounts. It needs to be passed when adding or editing a DDA/Bank/ApplePay account.  # noqa: E501

        :param account_subtype: The account_subtype of this FundingAccountSnapshotResponse.  # noqa: E501
        :type: str
        """
        self._account_subtype = account_subtype

    @property
    def aba_routing_number(self):
        """Gets the aba_routing_number of this FundingAccountSnapshotResponse.  # noqa: E501

        The ABA/Routing number for the bank account.  # noqa: E501

        :return: The aba_routing_number of this FundingAccountSnapshotResponse.  # noqa: E501
        :rtype: str
        """
        return self._aba_routing_number

    @aba_routing_number.setter
    def aba_routing_number(self, aba_routing_number):
        """Sets the aba_routing_number of this FundingAccountSnapshotResponse.

        The ABA/Routing number for the bank account.  # noqa: E501

        :param aba_routing_number: The aba_routing_number of this FundingAccountSnapshotResponse.  # noqa: E501
        :type: str
        """
        self._aba_routing_number = aba_routing_number

    @property
    def issuer_name(self):
        """Gets the issuer_name of this FundingAccountSnapshotResponse.  # noqa: E501

        The name of the authority that has issued the account. This is relevant only in the case of bank accounts.  # noqa: E501

        :return: The issuer_name of this FundingAccountSnapshotResponse.  # noqa: E501
        :rtype: str
        """
        return self._issuer_name

    @issuer_name.setter
    def issuer_name(self, issuer_name):
        """Sets the issuer_name of this FundingAccountSnapshotResponse.

        The name of the authority that has issued the account. This is relevant only in the case of bank accounts.  # noqa: E501

        :param issuer_name: The issuer_name of this FundingAccountSnapshotResponse.  # noqa: E501
        :type: str
        """
        self._issuer_name = issuer_name

    @property
    def nickname(self):
        """Gets the nickname of this FundingAccountSnapshotResponse.  # noqa: E501

        The nickname by which a customer might want to identify the account.  # noqa: E501

        :return: The nickname of this FundingAccountSnapshotResponse.  # noqa: E501
        :rtype: str
        """
        return self._nickname

    @nickname.setter
    def nickname(self, nickname):
        """Sets the nickname of this FundingAccountSnapshotResponse.

        The nickname by which a customer might want to identify the account.  # noqa: E501

        :param nickname: The nickname of this FundingAccountSnapshotResponse.  # noqa: E501
        :type: str
        """
        self._nickname = nickname

    @property
    def display_text(self):
        """Gets the display_text of this FundingAccountSnapshotResponse.  # noqa: E501

        UI representation of the account.  # noqa: E501

        :return: The display_text of this FundingAccountSnapshotResponse.  # noqa: E501
        :rtype: str
        """
        return self._display_text

    @display_text.setter
    def display_text(self, display_text):
        """Sets the display_text of this FundingAccountSnapshotResponse.

        UI representation of the account.  # noqa: E501

        :param display_text: The display_text of this FundingAccountSnapshotResponse.  # noqa: E501
        :type: str
        """
        self._display_text = display_text

    @property
    def account_holder_name(self):
        """Gets the account_holder_name of this FundingAccountSnapshotResponse.  # noqa: E501

        The name as specified on the account.  # noqa: E501

        :return: The account_holder_name of this FundingAccountSnapshotResponse.  # noqa: E501
        :rtype: str
        """
        return self._account_holder_name

    @account_holder_name.setter
    def account_holder_name(self, account_holder_name):
        """Sets the account_holder_name of this FundingAccountSnapshotResponse.

        The name as specified on the account.  # noqa: E501

        :param account_holder_name: The account_holder_name of this FundingAccountSnapshotResponse.  # noqa: E501
        :type: str
        """
        self._account_holder_name = account_holder_name

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(FundingAccountSnapshotResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, FundingAccountSnapshotResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
