# coding: utf-8

"""
    ############################################################################################
    ## This class subject to change without prior notice, Please dont use this class directly.##
    ############################################################################################
"""


import pprint
import re  # noqa: F401

import six

from orbipay_paymentsapi_client.models.audit_info_vo import AuditInfoVo  # noqa: F401,E501
from orbipay_paymentsapi_client.models.payment_auth_customer_account_response import PaymentAuthCustomerAccountResponse  # noqa: F401,E501
from orbipay_paymentsapi_client.models.payment_auth_customer_response import PaymentAuthCustomerResponse  # noqa: F401,E501
from orbipay_paymentsapi_client.models.payment_auth_funding_account_response import PaymentAuthFundingAccountResponse  # noqa: F401,E501
from orbipay_paymentsapi_client.models.payment_network_response_vo import PaymentNetworkResponseVo  # noqa: F401,E501


class PaymentAuthorizationResponse(object):
    """NOTE: 
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'payment_auth_reference': 'str',
        'id': 'str',
        'url': 'str',
        'auth_amount': 'str',
        'status': 'str',
        'payment_method': 'str',
        'currency_code3d': 'str',
        'card_cvv_number': 'str',
        'entry_time': 'str',
        'captured_time': 'str',
        'comments': 'str',
        'custom_fields': 'dict(str, str)',
        'customer': 'PaymentAuthCustomerResponse',
        'funding_account': 'PaymentAuthFundingAccountResponse',
        'customer_account': 'PaymentAuthCustomerAccountResponse',
        'payment_network_response': 'PaymentNetworkResponseVo',
        'audit_info': 'AuditInfoVo'
    }

    attribute_map = {
        'payment_auth_reference': 'payment_auth_reference',
        'id': 'id',
        'url': 'url',
        'auth_amount': 'auth_amount',
        'status': 'status',
        'payment_method': 'payment_method',
        'currency_code3d': 'currency_code3d',
        'card_cvv_number': 'card_cvv_number',
        'entry_time': 'entry_time',
        'captured_time': 'captured_time',
        'comments': 'comments',
        'custom_fields': 'custom_fields',
        'customer': 'customer',
        'funding_account': 'funding_account',
        'customer_account': 'customer_account',
        'payment_network_response': 'payment_network_response',
        'audit_info': 'audit_info'
    }

    def __init__(self, payment_auth_reference=None, id=None, url=None, auth_amount=None, status=None, payment_method=None, currency_code3d=None, card_cvv_number=None, entry_time=None, captured_time=None, comments=None, custom_fields=None, customer=None, funding_account=None, customer_account=None, payment_network_response=None, audit_info=None):  # noqa: E501
        """PaymentAuthorizationResponse - a model defined in Swagger"""  # noqa: E501

        self._payment_auth_reference = None
        self._id = None
        self._url = None
        self._auth_amount = None
        self._status = None
        self._payment_method = None
        self._currency_code3d = None
        self._card_cvv_number = None
        self._entry_time = None
        self._captured_time = None
        self._comments = None
        self._custom_fields = None
        self._customer = None
        self._funding_account = None
        self._customer_account = None
        self._payment_network_response = None
        self._audit_info = None
        self.discriminator = None

        if payment_auth_reference is not None:
            self.payment_auth_reference = payment_auth_reference
        if id is not None:
            self.id = id
        if url is not None:
            self.url = url
        if auth_amount is not None:
            self.auth_amount = auth_amount
        if status is not None:
            self.status = status
        if payment_method is not None:
            self.payment_method = payment_method
        if currency_code3d is not None:
            self.currency_code3d = currency_code3d
        if card_cvv_number is not None:
            self.card_cvv_number = card_cvv_number
        if entry_time is not None:
            self.entry_time = entry_time
        if captured_time is not None:
            self.captured_time = captured_time
        if comments is not None:
            self.comments = comments
        if custom_fields is not None:
            self.custom_fields = custom_fields
        if customer is not None:
            self.customer = customer
        if funding_account is not None:
            self.funding_account = funding_account
        if customer_account is not None:
            self.customer_account = customer_account
        if payment_network_response is not None:
            self.payment_network_response = payment_network_response
        if audit_info is not None:
            self.audit_info = audit_info

    def __getitem__(self,key):
        return getattr(self,key)

    @property
    def payment_auth_reference(self):
        """Gets the payment_auth_reference of this PaymentAuthorizationResponse.  # noqa: E501

        The unique identifier in the client system for the payment.  # noqa: E501

        :return: The payment_auth_reference of this PaymentAuthorizationResponse.  # noqa: E501
        :rtype: str
        """
        return self._payment_auth_reference

    @payment_auth_reference.setter
    def payment_auth_reference(self, payment_auth_reference):
        """Sets the payment_auth_reference of this PaymentAuthorizationResponse.

        The unique identifier in the client system for the payment.  # noqa: E501

        :param payment_auth_reference: The payment_auth_reference of this PaymentAuthorizationResponse.  # noqa: E501
        :type: str
        """
        self._payment_auth_reference = payment_auth_reference

    @property
    def id(self):
        """Gets the id of this PaymentAuthorizationResponse.  # noqa: E501

        The unique identifier assigned by EBPP to the payment authorization.  # noqa: E501

        :return: The id of this PaymentAuthorizationResponse.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this PaymentAuthorizationResponse.

        The unique identifier assigned by EBPP to the payment authorization.  # noqa: E501

        :param id: The id of this PaymentAuthorizationResponse.  # noqa: E501
        :type: str
        """
        self._id = id

    @property
    def url(self):
        """Gets the url of this PaymentAuthorizationResponse.  # noqa: E501

        This URL fetches the details of payment authorization.  # noqa: E501

        :return: The url of this PaymentAuthorizationResponse.  # noqa: E501
        :rtype: str
        """
        return self._url

    @url.setter
    def url(self, url):
        """Sets the url of this PaymentAuthorizationResponse.

        This URL fetches the details of payment authorization.  # noqa: E501

        :param url: The url of this PaymentAuthorizationResponse.  # noqa: E501
        :type: str
        """
        self._url = url

    @property
    def auth_amount(self):
        """Gets the auth_amount of this PaymentAuthorizationResponse.  # noqa: E501

        The amount being authorized.  # noqa: E501

        :return: The auth_amount of this PaymentAuthorizationResponse.  # noqa: E501
        :rtype: str
        """
        return self._auth_amount

    @auth_amount.setter
    def auth_amount(self, auth_amount):
        """Sets the auth_amount of this PaymentAuthorizationResponse.

        The amount being authorized.  # noqa: E501

        :param auth_amount: The auth_amount of this PaymentAuthorizationResponse.  # noqa: E501
        :type: str
        """
        self._auth_amount = auth_amount

    @property
    def status(self):
        """Gets the status of this PaymentAuthorizationResponse.  # noqa: E501

        The status of the payment.  # noqa: E501

        :return: The status of this PaymentAuthorizationResponse.  # noqa: E501
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this PaymentAuthorizationResponse.

        The status of the payment.  # noqa: E501

        :param status: The status of this PaymentAuthorizationResponse.  # noqa: E501
        :type: str
        """
        self._status = status

    @property
    def payment_method(self):
        """Gets the payment_method of this PaymentAuthorizationResponse.  # noqa: E501

        The fulfillment method for the payment authorization.  # noqa: E501

        :return: The payment_method of this PaymentAuthorizationResponse.  # noqa: E501
        :rtype: str
        """
        return self._payment_method

    @payment_method.setter
    def payment_method(self, payment_method):
        """Sets the payment_method of this PaymentAuthorizationResponse.

        The fulfillment method for the payment authorization.  # noqa: E501

        :param payment_method: The payment_method of this PaymentAuthorizationResponse.  # noqa: E501
        :type: str
        """
        self._payment_method = payment_method

    @property
    def currency_code3d(self):
        """Gets the currency_code3d of this PaymentAuthorizationResponse.  # noqa: E501

        The three-letter currency code in the ISO4217 format, in uppercase, for the card account. It must be a currency supported by EBPP. This defaults to USD.  # noqa: E501

        :return: The currency_code3d of this PaymentAuthorizationResponse.  # noqa: E501
        :rtype: str
        """
        return self._currency_code3d

    @currency_code3d.setter
    def currency_code3d(self, currency_code3d):
        """Sets the currency_code3d of this PaymentAuthorizationResponse.

        The three-letter currency code in the ISO4217 format, in uppercase, for the card account. It must be a currency supported by EBPP. This defaults to USD.  # noqa: E501

        :param currency_code3d: The currency_code3d of this PaymentAuthorizationResponse.  # noqa: E501
        :type: str
        """
        self._currency_code3d = currency_code3d

    @property
    def card_cvv_number(self):
        """Gets the card_cvv_number of this PaymentAuthorizationResponse.  # noqa: E501

        This is never returned by EBPP. This needs to be passed to EBPP when making or editing a payment with a card funding account.  # noqa: E501

        :return: The card_cvv_number of this PaymentAuthorizationResponse.  # noqa: E501
        :rtype: str
        """
        return self._card_cvv_number

    @card_cvv_number.setter
    def card_cvv_number(self, card_cvv_number):
        """Sets the card_cvv_number of this PaymentAuthorizationResponse.

        This is never returned by EBPP. This needs to be passed to EBPP when making or editing a payment with a card funding account.  # noqa: E501

        :param card_cvv_number: The card_cvv_number of this PaymentAuthorizationResponse.  # noqa: E501
        :type: str
        """
        self._card_cvv_number = card_cvv_number

    @property
    def entry_time(self):
        """Gets the entry_time of this PaymentAuthorizationResponse.  # noqa: E501

        The date on which the payment authorization created in UTC timestamp, with ISO8601 format. For e.g., 2019-08-13T09:21:34.359+0000.  # noqa: E501

        :return: The entry_time of this PaymentAuthorizationResponse.  # noqa: E501
        :rtype: str
        """
        return self._entry_time

    @entry_time.setter
    def entry_time(self, entry_time):
        """Sets the entry_time of this PaymentAuthorizationResponse.

        The date on which the payment authorization created in UTC timestamp, with ISO8601 format. For e.g., 2019-08-13T09:21:34.359+0000.  # noqa: E501

        :param entry_time: The entry_time of this PaymentAuthorizationResponse.  # noqa: E501
        :type: str
        """
        self._entry_time = entry_time

    @property
    def captured_time(self):
        """Gets the captured_time of this PaymentAuthorizationResponse.  # noqa: E501

        The date on which the payment authorization is captured in UTC timestamp, with ISO8601 format. For e.g., 2019-08-13T09:21:34.359+0000..  # noqa: E501

        :return: The captured_time of this PaymentAuthorizationResponse.  # noqa: E501
        :rtype: str
        """
        return self._captured_time

    @captured_time.setter
    def captured_time(self, captured_time):
        """Sets the captured_time of this PaymentAuthorizationResponse.

        The date on which the payment authorization is captured in UTC timestamp, with ISO8601 format. For e.g., 2019-08-13T09:21:34.359+0000..  # noqa: E501

        :param captured_time: The captured_time of this PaymentAuthorizationResponse.  # noqa: E501
        :type: str
        """
        self._captured_time = captured_time

    @property
    def comments(self):
        """Gets the comments of this PaymentAuthorizationResponse.  # noqa: E501

        Comments that can be used to recollect the operation performed on the resource object. API clients need to ensure that no sensitive information is passed in the memo. Alacriti (EBPP) is not responsible for the security of any sensitive information that may be passed as part of the memo.  # noqa: E501

        :return: The comments of this PaymentAuthorizationResponse.  # noqa: E501
        :rtype: str
        """
        return self._comments

    @comments.setter
    def comments(self, comments):
        """Sets the comments of this PaymentAuthorizationResponse.

        Comments that can be used to recollect the operation performed on the resource object. API clients need to ensure that no sensitive information is passed in the memo. Alacriti (EBPP) is not responsible for the security of any sensitive information that may be passed as part of the memo.  # noqa: E501

        :param comments: The comments of this PaymentAuthorizationResponse.  # noqa: E501
        :type: str
        """
        self._comments = comments

    @property
    def custom_fields(self):
        """Gets the custom_fields of this PaymentAuthorizationResponse.  # noqa: E501

        The additional information or meta-information that EBPP can accept, maintain and transmit back to the client. The custom fields need to be configured with EBPP before they can be accepted. EBPP would reject custom fields that are not pre-configured. Please contact <a href = \"mailto: support@billerpayments.com\">support@billerpayments.com</a> for more information on configuring and using custom fields. Only the custom fields enabled for the client, in EBPP, would be accepted in the requests.  # noqa: E501

        :return: The custom_fields of this PaymentAuthorizationResponse.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._custom_fields

    @custom_fields.setter
    def custom_fields(self, custom_fields):
        """Sets the custom_fields of this PaymentAuthorizationResponse.

        The additional information or meta-information that EBPP can accept, maintain and transmit back to the client. The custom fields need to be configured with EBPP before they can be accepted. EBPP would reject custom fields that are not pre-configured. Please contact <a href = \"mailto: support@billerpayments.com\">support@billerpayments.com</a> for more information on configuring and using custom fields. Only the custom fields enabled for the client, in EBPP, would be accepted in the requests.  # noqa: E501

        :param custom_fields: The custom_fields of this PaymentAuthorizationResponse.  # noqa: E501
        :type: dict(str, str)
        """
        self._custom_fields = custom_fields

    @property
    def customer(self):
        """Gets the customer of this PaymentAuthorizationResponse.  # noqa: E501


        :return: The customer of this PaymentAuthorizationResponse.  # noqa: E501
        :rtype: PaymentAuthCustomerResponse
        """
        return self._customer

    @customer.setter
    def customer(self, customer):
        """Sets the customer of this PaymentAuthorizationResponse.


        :param customer: The customer of this PaymentAuthorizationResponse.  # noqa: E501
        :type: PaymentAuthCustomerResponse
        """
        self._customer = customer

    @property
    def funding_account(self):
        """Gets the funding_account of this PaymentAuthorizationResponse.  # noqa: E501


        :return: The funding_account of this PaymentAuthorizationResponse.  # noqa: E501
        :rtype: PaymentAuthFundingAccountResponse
        """
        return self._funding_account

    @funding_account.setter
    def funding_account(self, funding_account):
        """Sets the funding_account of this PaymentAuthorizationResponse.


        :param funding_account: The funding_account of this PaymentAuthorizationResponse.  # noqa: E501
        :type: PaymentAuthFundingAccountResponse
        """
        self._funding_account = funding_account

    @property
    def customer_account(self):
        """Gets the customer_account of this PaymentAuthorizationResponse.  # noqa: E501


        :return: The customer_account of this PaymentAuthorizationResponse.  # noqa: E501
        :rtype: PaymentAuthCustomerAccountResponse
        """
        return self._customer_account

    @customer_account.setter
    def customer_account(self, customer_account):
        """Sets the customer_account of this PaymentAuthorizationResponse.


        :param customer_account: The customer_account of this PaymentAuthorizationResponse.  # noqa: E501
        :type: PaymentAuthCustomerAccountResponse
        """
        self._customer_account = customer_account

    @property
    def payment_network_response(self):
        """Gets the payment_network_response of this PaymentAuthorizationResponse.  # noqa: E501


        :return: The payment_network_response of this PaymentAuthorizationResponse.  # noqa: E501
        :rtype: PaymentNetworkResponseVo
        """
        return self._payment_network_response

    @payment_network_response.setter
    def payment_network_response(self, payment_network_response):
        """Sets the payment_network_response of this PaymentAuthorizationResponse.


        :param payment_network_response: The payment_network_response of this PaymentAuthorizationResponse.  # noqa: E501
        :type: PaymentNetworkResponseVo
        """
        self._payment_network_response = payment_network_response

    @property
    def audit_info(self):
        """Gets the audit_info of this PaymentAuthorizationResponse.  # noqa: E501


        :return: The audit_info of this PaymentAuthorizationResponse.  # noqa: E501
        :rtype: AuditInfoVo
        """
        return self._audit_info

    @audit_info.setter
    def audit_info(self, audit_info):
        """Sets the audit_info of this PaymentAuthorizationResponse.


        :param audit_info: The audit_info of this PaymentAuthorizationResponse.  # noqa: E501
        :type: AuditInfoVo
        """
        self._audit_info = audit_info

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PaymentAuthorizationResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PaymentAuthorizationResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
