# coding: utf-8

"""
    ############################################################################################
    ## This class subject to change without prior notice, Please dont use this class directly.##
    ############################################################################################
"""


import pprint
import re  # noqa: F401

import six


class PaymentNetworkResponseVo(object):
    """NOTE: 
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'payment_auth_code': 'str',
        'payment_response_code': 'str',
        'payment_response_msg': 'str'
    }

    attribute_map = {
        'payment_auth_code': 'payment_auth_code',
        'payment_response_code': 'payment_response_code',
        'payment_response_msg': 'payment_response_msg'
    }

    def __init__(self, payment_auth_code=None, payment_response_code=None, payment_response_msg=None):  # noqa: E501
        """PaymentNetworkResponseVo - a model defined in Swagger"""  # noqa: E501

        self._payment_auth_code = None
        self._payment_response_code = None
        self._payment_response_msg = None
        self.discriminator = None

        if payment_auth_code is not None:
            self.payment_auth_code = payment_auth_code
        if payment_response_code is not None:
            self.payment_response_code = payment_response_code
        if payment_response_msg is not None:
            self.payment_response_msg = payment_response_msg

    def __getitem__(self,key):
        return getattr(self,key)

    @property
    def payment_auth_code(self):
        """Gets the payment_auth_code of this PaymentNetworkResponseVo.  # noqa: E501

        The Auth Code returned by the card gateway. This is relevant only for card payments.  # noqa: E501

        :return: The payment_auth_code of this PaymentNetworkResponseVo.  # noqa: E501
        :rtype: str
        """
        return self._payment_auth_code

    @payment_auth_code.setter
    def payment_auth_code(self, payment_auth_code):
        """Sets the payment_auth_code of this PaymentNetworkResponseVo.

        The Auth Code returned by the card gateway. This is relevant only for card payments.  # noqa: E501

        :param payment_auth_code: The payment_auth_code of this PaymentNetworkResponseVo.  # noqa: E501
        :type: str
        """
        self._payment_auth_code = payment_auth_code

    @property
    def payment_response_code(self):
        """Gets the payment_response_code of this PaymentNetworkResponseVo.  # noqa: E501

        This is the ACH return code in the case of a returned payment over the NACHA ACH network. In the case of declined card payment, it's the decline code received from the card issuer or the card processor. In the case of a card chargeback, it's the chargeback code received from the card network.  # noqa: E501

        :return: The payment_response_code of this PaymentNetworkResponseVo.  # noqa: E501
        :rtype: str
        """
        return self._payment_response_code

    @payment_response_code.setter
    def payment_response_code(self, payment_response_code):
        """Sets the payment_response_code of this PaymentNetworkResponseVo.

        This is the ACH return code in the case of a returned payment over the NACHA ACH network. In the case of declined card payment, it's the decline code received from the card issuer or the card processor. In the case of a card chargeback, it's the chargeback code received from the card network.  # noqa: E501

        :param payment_response_code: The payment_response_code of this PaymentNetworkResponseVo.  # noqa: E501
        :type: str
        """
        self._payment_response_code = payment_response_code

    @property
    def payment_response_msg(self):
        """Gets the payment_response_msg of this PaymentNetworkResponseVo.  # noqa: E501

        The text describing the appropriate code captured in the payment_response_code as received from the corresponding payment network.  # noqa: E501

        :return: The payment_response_msg of this PaymentNetworkResponseVo.  # noqa: E501
        :rtype: str
        """
        return self._payment_response_msg

    @payment_response_msg.setter
    def payment_response_msg(self, payment_response_msg):
        """Sets the payment_response_msg of this PaymentNetworkResponseVo.

        The text describing the appropriate code captured in the payment_response_code as received from the corresponding payment network.  # noqa: E501

        :param payment_response_msg: The payment_response_msg of this PaymentNetworkResponseVo.  # noqa: E501
        :type: str
        """
        self._payment_response_msg = payment_response_msg

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PaymentNetworkResponseVo, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PaymentNetworkResponseVo):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
