# coding: utf-8

"""
    ############################################################################################
    ## This class subject to change without prior notice, Please dont use this class directly.##
    ############################################################################################
"""


import pprint
import re  # noqa: F401

import six


class PaymentScheduleVo(object):
    """NOTE: 
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'payment_recurring_type': 'str',
        'payment_recurring_count': 'str',
        'payment_amount_type': 'str',
        'payment_start_date': 'str',
        'payment_end_date': 'str',
        'payment_limit_amount': 'str',
        'payment_plan_id': 'str',
        'payment_defer_days': 'str'
    }

    attribute_map = {
        'payment_recurring_type': 'payment_recurring_type',
        'payment_recurring_count': 'payment_recurring_count',
        'payment_amount_type': 'payment_amount_type',
        'payment_start_date': 'payment_start_date',
        'payment_end_date': 'payment_end_date',
        'payment_limit_amount': 'payment_limit_amount',
        'payment_plan_id': 'payment_plan_id',
        'payment_defer_days': 'payment_defer_days'
    }

    def __init__(self, payment_recurring_type=None, payment_recurring_count=None, payment_amount_type=None, payment_start_date=None, payment_end_date=None, payment_limit_amount=None, payment_plan_id=None, payment_defer_days=None):  # noqa: E501
        """PaymentScheduleVo - a model defined in Swagger"""  # noqa: E501

        self._payment_recurring_type = None
        self._payment_recurring_count = None
        self._payment_amount_type = None
        self._payment_start_date = None
        self._payment_end_date = None
        self._payment_limit_amount = None
        self._payment_plan_id = None
        self._payment_defer_days = None
        self.discriminator = None

        if payment_recurring_type is not None:
            self.payment_recurring_type = payment_recurring_type
        if payment_recurring_count is not None:
            self.payment_recurring_count = payment_recurring_count
        if payment_amount_type is not None:
            self.payment_amount_type = payment_amount_type
        if payment_start_date is not None:
            self.payment_start_date = payment_start_date
        if payment_end_date is not None:
            self.payment_end_date = payment_end_date
        if payment_limit_amount is not None:
            self.payment_limit_amount = payment_limit_amount
        if payment_plan_id is not None:
            self.payment_plan_id = payment_plan_id
        if payment_defer_days is not None:
            self.payment_defer_days = payment_defer_days

    def __getitem__(self,key):
        return getattr(self,key)

    @property
    def payment_recurring_type(self):
        """Gets the payment_recurring_type of this PaymentScheduleVo.  # noqa: E501

        The frequency of the payments created as part of a payment setup.  # noqa: E501

        :return: The payment_recurring_type of this PaymentScheduleVo.  # noqa: E501
        :rtype: str
        """
        return self._payment_recurring_type

    @payment_recurring_type.setter
    def payment_recurring_type(self, payment_recurring_type):
        """Sets the payment_recurring_type of this PaymentScheduleVo.

        The frequency of the payments created as part of a payment setup.  # noqa: E501

        :param payment_recurring_type: The payment_recurring_type of this PaymentScheduleVo.  # noqa: E501
        :type: str
        """
        self._payment_recurring_type = payment_recurring_type

    @property
    def payment_recurring_count(self):
        """Gets the payment_recurring_count of this PaymentScheduleVo.  # noqa: E501

        The maximum number of payments that can be created as part of a recurring payment setup.  # noqa: E501

        :return: The payment_recurring_count of this PaymentScheduleVo.  # noqa: E501
        :rtype: str
        """
        return self._payment_recurring_count

    @payment_recurring_count.setter
    def payment_recurring_count(self, payment_recurring_count):
        """Sets the payment_recurring_count of this PaymentScheduleVo.

        The maximum number of payments that can be created as part of a recurring payment setup.  # noqa: E501

        :param payment_recurring_count: The payment_recurring_count of this PaymentScheduleVo.  # noqa: E501
        :type: str
        """
        self._payment_recurring_count = payment_recurring_count

    @property
    def payment_amount_type(self):
        """Gets the payment_amount_type of this PaymentScheduleVo.  # noqa: E501

        The amount type that is used to set the amount for payments created as part of a recurring payment or autopay setup.   # noqa: E501

        :return: The payment_amount_type of this PaymentScheduleVo.  # noqa: E501
        :rtype: str
        """
        return self._payment_amount_type

    @payment_amount_type.setter
    def payment_amount_type(self, payment_amount_type):
        """Sets the payment_amount_type of this PaymentScheduleVo.

        The amount type that is used to set the amount for payments created as part of a recurring payment or autopay setup.   # noqa: E501

        :param payment_amount_type: The payment_amount_type of this PaymentScheduleVo.  # noqa: E501
        :type: str
        """
        self._payment_amount_type = payment_amount_type

    @property
    def payment_start_date(self):
        """Gets the payment_start_date of this PaymentScheduleVo.  # noqa: E501

        The date on which the first payment will be drafted as part of a recurring payment setup. This is to be specified in the ISO8601 full-date format, namely, YYYY-MM-DD.  # noqa: E501

        :return: The payment_start_date of this PaymentScheduleVo.  # noqa: E501
        :rtype: str
        """
        return self._payment_start_date

    @payment_start_date.setter
    def payment_start_date(self, payment_start_date):
        """Sets the payment_start_date of this PaymentScheduleVo.

        The date on which the first payment will be drafted as part of a recurring payment setup. This is to be specified in the ISO8601 full-date format, namely, YYYY-MM-DD.  # noqa: E501

        :param payment_start_date: The payment_start_date of this PaymentScheduleVo.  # noqa: E501
        :type: str
        """
        self._payment_start_date = payment_start_date

    @property
    def payment_end_date(self):
        """Gets the payment_end_date of this PaymentScheduleVo.  # noqa: E501

        The date by which the last payment will be drafted as part of a recurring payment setup. This is to be specified in the ISO8601 full-date format, namely, YYYY-MM-DD.  # noqa: E501

        :return: The payment_end_date of this PaymentScheduleVo.  # noqa: E501
        :rtype: str
        """
        return self._payment_end_date

    @payment_end_date.setter
    def payment_end_date(self, payment_end_date):
        """Sets the payment_end_date of this PaymentScheduleVo.

        The date by which the last payment will be drafted as part of a recurring payment setup. This is to be specified in the ISO8601 full-date format, namely, YYYY-MM-DD.  # noqa: E501

        :param payment_end_date: The payment_end_date of this PaymentScheduleVo.  # noqa: E501
        :type: str
        """
        self._payment_end_date = payment_end_date

    @property
    def payment_limit_amount(self):
        """Gets the payment_limit_amount of this PaymentScheduleVo.  # noqa: E501

        The upper limit for the payment amount in the case of recurring or autopay payments.  # noqa: E501

        :return: The payment_limit_amount of this PaymentScheduleVo.  # noqa: E501
        :rtype: str
        """
        return self._payment_limit_amount

    @payment_limit_amount.setter
    def payment_limit_amount(self, payment_limit_amount):
        """Sets the payment_limit_amount of this PaymentScheduleVo.

        The upper limit for the payment amount in the case of recurring or autopay payments.  # noqa: E501

        :param payment_limit_amount: The payment_limit_amount of this PaymentScheduleVo.  # noqa: E501
        :type: str
        """
        self._payment_limit_amount = payment_limit_amount

    @property
    def payment_plan_id(self):
        """Gets the payment_plan_id of this PaymentScheduleVo.  # noqa: E501

        The reference to the payment plan, offered by the biller, that is used to set up the recurring payment. The list of payment plans offered is published as part of the biller set-up.  # noqa: E501

        :return: The payment_plan_id of this PaymentScheduleVo.  # noqa: E501
        :rtype: str
        """
        return self._payment_plan_id

    @payment_plan_id.setter
    def payment_plan_id(self, payment_plan_id):
        """Sets the payment_plan_id of this PaymentScheduleVo.

        The reference to the payment plan, offered by the biller, that is used to set up the recurring payment. The list of payment plans offered is published as part of the biller set-up.  # noqa: E501

        :param payment_plan_id: The payment_plan_id of this PaymentScheduleVo.  # noqa: E501
        :type: str
        """
        self._payment_plan_id = payment_plan_id

    @property
    def payment_defer_days(self):
        """Gets the payment_defer_days of this PaymentScheduleVo.  # noqa: E501

        The number of days from the bill due date that the customer wishes to delay the autopay payment by.  # noqa: E501

        :return: The payment_defer_days of this PaymentScheduleVo.  # noqa: E501
        :rtype: str
        """
        return self._payment_defer_days

    @payment_defer_days.setter
    def payment_defer_days(self, payment_defer_days):
        """Sets the payment_defer_days of this PaymentScheduleVo.

        The number of days from the bill due date that the customer wishes to delay the autopay payment by.  # noqa: E501

        :param payment_defer_days: The payment_defer_days of this PaymentScheduleVo.  # noqa: E501
        :type: str
        """
        self._payment_defer_days = payment_defer_days

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PaymentScheduleVo, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PaymentScheduleVo):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
