# coding: utf-8

"""
    ############################################################################################
    ## This class subject to change without prior notice, Please dont use this class directly.##
    ############################################################################################
"""


import pprint
import re  # noqa: F401

import six

from orbipay_paymentsapi_client.models.audit_info_vo import AuditInfoVo  # noqa: F401,E501
from orbipay_paymentsapi_client.models.customer_account_snapshot_response import CustomerAccountSnapshotResponse  # noqa: F401,E501
from orbipay_paymentsapi_client.models.customer_snapshot_response import CustomerSnapshotResponse  # noqa: F401,E501
from orbipay_paymentsapi_client.models.fee_response import FeeResponse  # noqa: F401,E501
from orbipay_paymentsapi_client.models.funding_account_snapshot_response import FundingAccountSnapshotResponse  # noqa: F401,E501
from orbipay_paymentsapi_client.models.payment_network_response_vo import PaymentNetworkResponseVo  # noqa: F401,E501
from orbipay_paymentsapi_client.models.payment_schedule_vo import PaymentScheduleVo  # noqa: F401,E501


class PaymentSetupResponse(object):
    """NOTE: 
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'url': 'str',
        'fee': 'FeeResponse',
        'status': 'str',
        'payment_method': 'str',
        'payment_setup_schedule_type': 'str',
        'confirmation_number': 'str',
        'custom_fields': 'dict(str, str)',
        'currency_code3d': 'str',
        'amount': 'str',
        'card_cvv_number': 'str',
        'next_payment_date': 'str',
        'payment_setup_reference': 'str',
        'payment_schedule': 'PaymentScheduleVo',
        'payment_setup_entry_date': 'str',
        'comments': 'str',
        'customer': 'CustomerSnapshotResponse',
        'funding_account': 'FundingAccountSnapshotResponse',
        'customer_account': 'CustomerAccountSnapshotResponse',
        'payment_network_response': 'PaymentNetworkResponseVo',
        'audit_info': 'AuditInfoVo'
    }

    attribute_map = {
        'id': 'id',
        'url': 'url',
        'fee': 'fee',
        'status': 'status',
        'payment_method': 'payment_method',
        'payment_setup_schedule_type': 'payment_setup_schedule_type',
        'confirmation_number': 'confirmation_number',
        'custom_fields': 'custom_fields',
        'currency_code3d': 'currency_code3d',
        'amount': 'amount',
        'card_cvv_number': 'card_cvv_number',
        'next_payment_date': 'next_payment_date',
        'payment_setup_reference': 'payment_setup_reference',
        'payment_schedule': 'payment_schedule',
        'payment_setup_entry_date': 'payment_setup_entry_date',
        'comments': 'comments',
        'customer': 'customer',
        'funding_account': 'funding_account',
        'customer_account': 'customer_account',
        'payment_network_response': 'payment_network_response',
        'audit_info': 'audit_info'
    }

    def __init__(self, id=None, url=None, fee=None, status=None, payment_method=None, payment_setup_schedule_type=None, confirmation_number=None, custom_fields=None, currency_code3d=None, amount=None, card_cvv_number=None, next_payment_date=None, payment_setup_reference=None, payment_schedule=None, payment_setup_entry_date=None, comments=None, customer=None, funding_account=None, customer_account=None, payment_network_response=None, audit_info=None):  # noqa: E501
        """PaymentSetupResponse - a model defined in Swagger"""  # noqa: E501

        self._id = None
        self._url = None
        self._fee = None
        self._status = None
        self._payment_method = None
        self._payment_setup_schedule_type = None
        self._confirmation_number = None
        self._custom_fields = None
        self._currency_code3d = None
        self._amount = None
        self._card_cvv_number = None
        self._next_payment_date = None
        self._payment_setup_reference = None
        self._payment_schedule = None
        self._payment_setup_entry_date = None
        self._comments = None
        self._customer = None
        self._funding_account = None
        self._customer_account = None
        self._payment_network_response = None
        self._audit_info = None
        self.discriminator = None

        if id is not None:
            self.id = id
        if url is not None:
            self.url = url
        if fee is not None:
            self.fee = fee
        if status is not None:
            self.status = status
        if payment_method is not None:
            self.payment_method = payment_method
        if payment_setup_schedule_type is not None:
            self.payment_setup_schedule_type = payment_setup_schedule_type
        if confirmation_number is not None:
            self.confirmation_number = confirmation_number
        if custom_fields is not None:
            self.custom_fields = custom_fields
        if currency_code3d is not None:
            self.currency_code3d = currency_code3d
        if amount is not None:
            self.amount = amount
        if card_cvv_number is not None:
            self.card_cvv_number = card_cvv_number
        if next_payment_date is not None:
            self.next_payment_date = next_payment_date
        if payment_setup_reference is not None:
            self.payment_setup_reference = payment_setup_reference
        if payment_schedule is not None:
            self.payment_schedule = payment_schedule
        if payment_setup_entry_date is not None:
            self.payment_setup_entry_date = payment_setup_entry_date
        if comments is not None:
            self.comments = comments
        if customer is not None:
            self.customer = customer
        if funding_account is not None:
            self.funding_account = funding_account
        if customer_account is not None:
            self.customer_account = customer_account
        if payment_network_response is not None:
            self.payment_network_response = payment_network_response
        if audit_info is not None:
            self.audit_info = audit_info

    def __getitem__(self,key):
        return getattr(self,key)

    @property
    def id(self):
        """Gets the id of this PaymentSetupResponse.  # noqa: E501

        The unique identifier assigned by EBPP to the payment setup.  # noqa: E501

        :return: The id of this PaymentSetupResponse.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this PaymentSetupResponse.

        The unique identifier assigned by EBPP to the payment setup.  # noqa: E501

        :param id: The id of this PaymentSetupResponse.  # noqa: E501
        :type: str
        """
        self._id = id

    @property
    def url(self):
        """Gets the url of this PaymentSetupResponse.  # noqa: E501

        This URL fetches the details of payment setup.  # noqa: E501

        :return: The url of this PaymentSetupResponse.  # noqa: E501
        :rtype: str
        """
        return self._url

    @url.setter
    def url(self, url):
        """Sets the url of this PaymentSetupResponse.

        This URL fetches the details of payment setup.  # noqa: E501

        :param url: The url of this PaymentSetupResponse.  # noqa: E501
        :type: str
        """
        self._url = url

    @property
    def fee(self):
        """Gets the fee of this PaymentSetupResponse.  # noqa: E501


        :return: The fee of this PaymentSetupResponse.  # noqa: E501
        :rtype: FeeResponse
        """
        return self._fee

    @fee.setter
    def fee(self, fee):
        """Sets the fee of this PaymentSetupResponse.


        :param fee: The fee of this PaymentSetupResponse.  # noqa: E501
        :type: FeeResponse
        """
        self._fee = fee

    @property
    def status(self):
        """Gets the status of this PaymentSetupResponse.  # noqa: E501

        The status of the payment.  # noqa: E501

        :return: The status of this PaymentSetupResponse.  # noqa: E501
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this PaymentSetupResponse.

        The status of the payment.  # noqa: E501

        :param status: The status of this PaymentSetupResponse.  # noqa: E501
        :type: str
        """
        self._status = status

    @property
    def payment_method(self):
        """Gets the payment_method of this PaymentSetupResponse.  # noqa: E501

        The fulfillment method for the payment.  # noqa: E501

        :return: The payment_method of this PaymentSetupResponse.  # noqa: E501
        :rtype: str
        """
        return self._payment_method

    @payment_method.setter
    def payment_method(self, payment_method):
        """Sets the payment_method of this PaymentSetupResponse.

        The fulfillment method for the payment.  # noqa: E501

        :param payment_method: The payment_method of this PaymentSetupResponse.  # noqa: E501
        :type: str
        """
        self._payment_method = payment_method

    @property
    def payment_setup_schedule_type(self):
        """Gets the payment_setup_schedule_type of this PaymentSetupResponse.  # noqa: E501

        The schedule type for the payment setup.  # noqa: E501

        :return: The payment_setup_schedule_type of this PaymentSetupResponse.  # noqa: E501
        :rtype: str
        """
        return self._payment_setup_schedule_type

    @payment_setup_schedule_type.setter
    def payment_setup_schedule_type(self, payment_setup_schedule_type):
        """Sets the payment_setup_schedule_type of this PaymentSetupResponse.

        The schedule type for the payment setup.  # noqa: E501

        :param payment_setup_schedule_type: The payment_setup_schedule_type of this PaymentSetupResponse.  # noqa: E501
        :type: str
        """
        self._payment_setup_schedule_type = payment_setup_schedule_type

    @property
    def confirmation_number(self):
        """Gets the confirmation_number of this PaymentSetupResponse.  # noqa: E501

        The confirmation number or reference provided to the customer for the payment setup.  # noqa: E501

        :return: The confirmation_number of this PaymentSetupResponse.  # noqa: E501
        :rtype: str
        """
        return self._confirmation_number

    @confirmation_number.setter
    def confirmation_number(self, confirmation_number):
        """Sets the confirmation_number of this PaymentSetupResponse.

        The confirmation number or reference provided to the customer for the payment setup.  # noqa: E501

        :param confirmation_number: The confirmation_number of this PaymentSetupResponse.  # noqa: E501
        :type: str
        """
        self._confirmation_number = confirmation_number

    @property
    def custom_fields(self):
        """Gets the custom_fields of this PaymentSetupResponse.  # noqa: E501

        The additional information or meta-information that EBPP can accept, maintain and transmit back to the client. The custom fields need to be configured with EBPP before they can be accepted. EBPP would reject custom fields that are not pre-configured. Please contact <a href = \"mailto: support@billerpayments.com\">support@billerpayments.com</a> for more information on configuring and using custom fields. Only the custom fields enabled for the client, in EBPP, would be accepted in the requests.  # noqa: E501

        :return: The custom_fields of this PaymentSetupResponse.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._custom_fields

    @custom_fields.setter
    def custom_fields(self, custom_fields):
        """Sets the custom_fields of this PaymentSetupResponse.

        The additional information or meta-information that EBPP can accept, maintain and transmit back to the client. The custom fields need to be configured with EBPP before they can be accepted. EBPP would reject custom fields that are not pre-configured. Please contact <a href = \"mailto: support@billerpayments.com\">support@billerpayments.com</a> for more information on configuring and using custom fields. Only the custom fields enabled for the client, in EBPP, would be accepted in the requests.  # noqa: E501

        :param custom_fields: The custom_fields of this PaymentSetupResponse.  # noqa: E501
        :type: dict(str, str)
        """
        self._custom_fields = custom_fields

    @property
    def currency_code3d(self):
        """Gets the currency_code3d of this PaymentSetupResponse.  # noqa: E501

        The three-letter currency code in the ISO4217 format, in uppercase, for the card account. It must be a currency supported by EBPP. This defaults to USD.  # noqa: E501

        :return: The currency_code3d of this PaymentSetupResponse.  # noqa: E501
        :rtype: str
        """
        return self._currency_code3d

    @currency_code3d.setter
    def currency_code3d(self, currency_code3d):
        """Sets the currency_code3d of this PaymentSetupResponse.

        The three-letter currency code in the ISO4217 format, in uppercase, for the card account. It must be a currency supported by EBPP. This defaults to USD.  # noqa: E501

        :param currency_code3d: The currency_code3d of this PaymentSetupResponse.  # noqa: E501
        :type: str
        """
        self._currency_code3d = currency_code3d

    @property
    def amount(self):
        """Gets the amount of this PaymentSetupResponse.  # noqa: E501

        The amount being paid. In case the payment_amount_type is 'discounted_amount', 'penalty_amount' or 'other', the amount needs to be specified. In other cases, this is derived from the payment_amount_type.  # noqa: E501

        :return: The amount of this PaymentSetupResponse.  # noqa: E501
        :rtype: str
        """
        return self._amount

    @amount.setter
    def amount(self, amount):
        """Sets the amount of this PaymentSetupResponse.

        The amount being paid. In case the payment_amount_type is 'discounted_amount', 'penalty_amount' or 'other', the amount needs to be specified. In other cases, this is derived from the payment_amount_type.  # noqa: E501

        :param amount: The amount of this PaymentSetupResponse.  # noqa: E501
        :type: str
        """
        self._amount = amount

    @property
    def card_cvv_number(self):
        """Gets the card_cvv_number of this PaymentSetupResponse.  # noqa: E501

        This is never returned by EBPP. This needs to be passed to EBPP when making or editing a payment setup with a card funding account.  # noqa: E501

        :return: The card_cvv_number of this PaymentSetupResponse.  # noqa: E501
        :rtype: str
        """
        return self._card_cvv_number

    @card_cvv_number.setter
    def card_cvv_number(self, card_cvv_number):
        """Sets the card_cvv_number of this PaymentSetupResponse.

        This is never returned by EBPP. This needs to be passed to EBPP when making or editing a payment setup with a card funding account.  # noqa: E501

        :param card_cvv_number: The card_cvv_number of this PaymentSetupResponse.  # noqa: E501
        :type: str
        """
        self._card_cvv_number = card_cvv_number

    @property
    def next_payment_date(self):
        """Gets the next_payment_date of this PaymentSetupResponse.  # noqa: E501

        The date on which the payment is scheduled to be made. It must be in ISO8601 full-date format, namely, YYYY-MM-DD.  # noqa: E501

        :return: The next_payment_date of this PaymentSetupResponse.  # noqa: E501
        :rtype: str
        """
        return self._next_payment_date

    @next_payment_date.setter
    def next_payment_date(self, next_payment_date):
        """Sets the next_payment_date of this PaymentSetupResponse.

        The date on which the payment is scheduled to be made. It must be in ISO8601 full-date format, namely, YYYY-MM-DD.  # noqa: E501

        :param next_payment_date: The next_payment_date of this PaymentSetupResponse.  # noqa: E501
        :type: str
        """
        self._next_payment_date = next_payment_date

    @property
    def payment_setup_reference(self):
        """Gets the payment_setup_reference of this PaymentSetupResponse.  # noqa: E501

        The unique identifier in the client system for the payment setup.  # noqa: E501

        :return: The payment_setup_reference of this PaymentSetupResponse.  # noqa: E501
        :rtype: str
        """
        return self._payment_setup_reference

    @payment_setup_reference.setter
    def payment_setup_reference(self, payment_setup_reference):
        """Sets the payment_setup_reference of this PaymentSetupResponse.

        The unique identifier in the client system for the payment setup.  # noqa: E501

        :param payment_setup_reference: The payment_setup_reference of this PaymentSetupResponse.  # noqa: E501
        :type: str
        """
        self._payment_setup_reference = payment_setup_reference

    @property
    def payment_schedule(self):
        """Gets the payment_schedule of this PaymentSetupResponse.  # noqa: E501


        :return: The payment_schedule of this PaymentSetupResponse.  # noqa: E501
        :rtype: PaymentScheduleVo
        """
        return self._payment_schedule

    @payment_schedule.setter
    def payment_schedule(self, payment_schedule):
        """Sets the payment_schedule of this PaymentSetupResponse.


        :param payment_schedule: The payment_schedule of this PaymentSetupResponse.  # noqa: E501
        :type: PaymentScheduleVo
        """
        self._payment_schedule = payment_schedule

    @property
    def payment_setup_entry_date(self):
        """Gets the payment_setup_entry_date of this PaymentSetupResponse.  # noqa: E501

        The date on which the payment setup is captured in EBPP. It must be in ISO8601 full-date format, namely, YYYY-MM-DD.  # noqa: E501

        :return: The payment_setup_entry_date of this PaymentSetupResponse.  # noqa: E501
        :rtype: str
        """
        return self._payment_setup_entry_date

    @payment_setup_entry_date.setter
    def payment_setup_entry_date(self, payment_setup_entry_date):
        """Sets the payment_setup_entry_date of this PaymentSetupResponse.

        The date on which the payment setup is captured in EBPP. It must be in ISO8601 full-date format, namely, YYYY-MM-DD.  # noqa: E501

        :param payment_setup_entry_date: The payment_setup_entry_date of this PaymentSetupResponse.  # noqa: E501
        :type: str
        """
        self._payment_setup_entry_date = payment_setup_entry_date

    @property
    def comments(self):
        """Gets the comments of this PaymentSetupResponse.  # noqa: E501

        Comments that can be used to recollect the operation performed on the resource object. API clients need to ensure that no sensitive information is passed in the memo. Alacriti (Orbipay) is not responsible for the security of any sensitive information that may be passed as part of the memo.  # noqa: E501

        :return: The comments of this PaymentSetupResponse.  # noqa: E501
        :rtype: str
        """
        return self._comments

    @comments.setter
    def comments(self, comments):
        """Sets the comments of this PaymentSetupResponse.

        Comments that can be used to recollect the operation performed on the resource object. API clients need to ensure that no sensitive information is passed in the memo. Alacriti (Orbipay) is not responsible for the security of any sensitive information that may be passed as part of the memo.  # noqa: E501

        :param comments: The comments of this PaymentSetupResponse.  # noqa: E501
        :type: str
        """
        self._comments = comments

    @property
    def customer(self):
        """Gets the customer of this PaymentSetupResponse.  # noqa: E501


        :return: The customer of this PaymentSetupResponse.  # noqa: E501
        :rtype: CustomerSnapshotResponse
        """
        return self._customer

    @customer.setter
    def customer(self, customer):
        """Sets the customer of this PaymentSetupResponse.


        :param customer: The customer of this PaymentSetupResponse.  # noqa: E501
        :type: CustomerSnapshotResponse
        """
        self._customer = customer

    @property
    def funding_account(self):
        """Gets the funding_account of this PaymentSetupResponse.  # noqa: E501


        :return: The funding_account of this PaymentSetupResponse.  # noqa: E501
        :rtype: FundingAccountSnapshotResponse
        """
        return self._funding_account

    @funding_account.setter
    def funding_account(self, funding_account):
        """Sets the funding_account of this PaymentSetupResponse.


        :param funding_account: The funding_account of this PaymentSetupResponse.  # noqa: E501
        :type: FundingAccountSnapshotResponse
        """
        self._funding_account = funding_account

    @property
    def customer_account(self):
        """Gets the customer_account of this PaymentSetupResponse.  # noqa: E501


        :return: The customer_account of this PaymentSetupResponse.  # noqa: E501
        :rtype: CustomerAccountSnapshotResponse
        """
        return self._customer_account

    @customer_account.setter
    def customer_account(self, customer_account):
        """Sets the customer_account of this PaymentSetupResponse.


        :param customer_account: The customer_account of this PaymentSetupResponse.  # noqa: E501
        :type: CustomerAccountSnapshotResponse
        """
        self._customer_account = customer_account

    @property
    def payment_network_response(self):
        """Gets the payment_network_response of this PaymentSetupResponse.  # noqa: E501


        :return: The payment_network_response of this PaymentSetupResponse.  # noqa: E501
        :rtype: PaymentNetworkResponseVo
        """
        return self._payment_network_response

    @payment_network_response.setter
    def payment_network_response(self, payment_network_response):
        """Sets the payment_network_response of this PaymentSetupResponse.


        :param payment_network_response: The payment_network_response of this PaymentSetupResponse.  # noqa: E501
        :type: PaymentNetworkResponseVo
        """
        self._payment_network_response = payment_network_response

    @property
    def audit_info(self):
        """Gets the audit_info of this PaymentSetupResponse.  # noqa: E501


        :return: The audit_info of this PaymentSetupResponse.  # noqa: E501
        :rtype: AuditInfoVo
        """
        return self._audit_info

    @audit_info.setter
    def audit_info(self, audit_info):
        """Sets the audit_info of this PaymentSetupResponse.


        :param audit_info: The audit_info of this PaymentSetupResponse.  # noqa: E501
        :type: AuditInfoVo
        """
        self._audit_info = audit_info

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PaymentSetupResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PaymentSetupResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
