# coding: utf-8

"""
    ############################################################################################
    ## This class subject to change without prior notice, Please dont use this class directly.##
    ############################################################################################
"""


import pprint
import re  # noqa: F401

import six

from orbipay_paymentsapi_client.models.payment_response import PaymentResponse  # noqa: F401,E501


class PaymentsResponse(object):
    """NOTE: 
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'list': 'list[PaymentResponse]',
        'total_results_count': 'str',
        'has_more_results': 'str',
        'url': 'str',
        'from_index': 'str',
        'to_index': 'str',
        'query_id': 'str'
    }

    attribute_map = {
        'list': 'list',
        'total_results_count': 'total_results_count',
        'has_more_results': 'has_more_results',
        'url': 'url',
        'from_index': 'from_index',
        'to_index': 'to_index',
        'query_id': 'query_id'
    }

    def __init__(self, list=None, total_results_count=None, has_more_results=None, url=None, from_index=None, to_index=None, query_id=None):  # noqa: E501
        """PaymentsResponse - a model defined in Swagger"""  # noqa: E501

        self._list = None
        self._total_results_count = None
        self._has_more_results = None
        self._url = None
        self._from_index = None
        self._to_index = None
        self._query_id = None
        self.discriminator = None

        if list is not None:
            self.list = list
        if total_results_count is not None:
            self.total_results_count = total_results_count
        if has_more_results is not None:
            self.has_more_results = has_more_results
        if url is not None:
            self.url = url
        if from_index is not None:
            self.from_index = from_index
        if to_index is not None:
            self.to_index = to_index
        if query_id is not None:
            self.query_id = query_id

    def __getitem__(self,key):
        return getattr(self,key)

    @property
    def list(self):
        """Gets the list of this PaymentsResponse.  # noqa: E501


        :return: The list of this PaymentsResponse.  # noqa: E501
        :rtype: list[PaymentResponse]
        """
        return self._list

    @list.setter
    def list(self, list):
        """Sets the list of this PaymentsResponse.


        :param list: The list of this PaymentsResponse.  # noqa: E501
        :type: list[PaymentResponse]
        """
        self._list = list

    @property
    def total_results_count(self):
        """Gets the total_results_count of this PaymentsResponse.  # noqa: E501

        total number of payments available with matching criteria  # noqa: E501

        :return: The total_results_count of this PaymentsResponse.  # noqa: E501
        :rtype: str
        """
        return self._total_results_count

    @total_results_count.setter
    def total_results_count(self, total_results_count):
        """Sets the total_results_count of this PaymentsResponse.

        total number of payments available with matching criteria  # noqa: E501

        :param total_results_count: The total_results_count of this PaymentsResponse.  # noqa: E501
        :type: str
        """
        self._total_results_count = total_results_count

    @property
    def has_more_results(self):
        """Gets the has_more_results of this PaymentsResponse.  # noqa: E501

        true if there are more results or pages  # noqa: E501

        :return: The has_more_results of this PaymentsResponse.  # noqa: E501
        :rtype: str
        """
        return self._has_more_results

    @has_more_results.setter
    def has_more_results(self, has_more_results):
        """Sets the has_more_results of this PaymentsResponse.

        true if there are more results or pages  # noqa: E501

        :param has_more_results: The has_more_results of this PaymentsResponse.  # noqa: E501
        :type: str
        """
        self._has_more_results = has_more_results

    @property
    def url(self):
        """Gets the url of this PaymentsResponse.  # noqa: E501

        This URL fetches the next or previous set of payments, based on the presence of after_object or before_object parameter.  # noqa: E501

        :return: The url of this PaymentsResponse.  # noqa: E501
        :rtype: str
        """
        return self._url

    @url.setter
    def url(self, url):
        """Sets the url of this PaymentsResponse.

        This URL fetches the next or previous set of payments, based on the presence of after_object or before_object parameter.  # noqa: E501

        :param url: The url of this PaymentsResponse.  # noqa: E501
        :type: str
        """
        self._url = url

    @property
    def from_index(self):
        """Gets the from_index of this PaymentsResponse.  # noqa: E501

        The id of the object before which the previous set of objects are to be retrieved.  # noqa: E501

        :return: The from_index of this PaymentsResponse.  # noqa: E501
        :rtype: str
        """
        return self._from_index

    @from_index.setter
    def from_index(self, from_index):
        """Sets the from_index of this PaymentsResponse.

        The id of the object before which the previous set of objects are to be retrieved.  # noqa: E501

        :param from_index: The from_index of this PaymentsResponse.  # noqa: E501
        :type: str
        """
        self._from_index = from_index

    @property
    def to_index(self):
        """Gets the to_index of this PaymentsResponse.  # noqa: E501

        The id of the object after which the next set of objects are to be retrieved.  # noqa: E501

        :return: The to_index of this PaymentsResponse.  # noqa: E501
        :rtype: str
        """
        return self._to_index

    @to_index.setter
    def to_index(self, to_index):
        """Sets the to_index of this PaymentsResponse.

        The id of the object after which the next set of objects are to be retrieved.  # noqa: E501

        :param to_index: The to_index of this PaymentsResponse.  # noqa: E501
        :type: str
        """
        self._to_index = to_index

    @property
    def query_id(self):
        """Gets the query_id of this PaymentsResponse.  # noqa: E501

        The query id of the object.  # noqa: E501

        :return: The query_id of this PaymentsResponse.  # noqa: E501
        :rtype: str
        """
        return self._query_id

    @query_id.setter
    def query_id(self, query_id):
        """Sets the query_id of this PaymentsResponse.

        The query id of the object.  # noqa: E501

        :param query_id: The query_id of this PaymentsResponse.  # noqa: E501
        :type: str
        """
        self._query_id = query_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PaymentsResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PaymentsResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
