# coding: utf-8

"""
    ############################################################################################
    ## This class subject to change without prior notice, Please dont use this class directly.##
    ############################################################################################
"""


import pprint
import re  # noqa: F401

import six

from orbipay_paymentsapi_client.models.fee_request import FeeRequest  # noqa: F401,E501
from orbipay_paymentsapi_client.models.record_payment_customer_account_request import RecordPaymentCustomerAccountRequest  # noqa: F401,E501
from orbipay_paymentsapi_client.models.record_payment_customer_request import RecordPaymentCustomerRequest  # noqa: F401,E501
from orbipay_paymentsapi_client.models.recorded_payment_funding_account import RecordedPaymentFundingAccount  # noqa: F401,E501


class RecordPaymentRequest(object):
    """NOTE: 
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'amount': 'str',
        'payment_date': 'str',
        'payment_amount_type': 'str',
        'payment_method': 'str',
        'token': 'str',
        'fee': 'FeeRequest',
        'customer': 'RecordPaymentCustomerRequest',
        'funding_account': 'RecordedPaymentFundingAccount',
        'customer_account': 'RecordPaymentCustomerAccountRequest',
        'payment_reference': 'str',
        'comments': 'str',
        'custom_fields': 'dict(str, str)'
    }

    attribute_map = {
        'amount': 'amount',
        'payment_date': 'payment_date',
        'payment_amount_type': 'payment_amount_type',
        'payment_method': 'payment_method',
        'token': 'token',
        'fee': 'fee',
        'customer': 'customer',
        'funding_account': 'funding_account',
        'customer_account': 'customer_account',
        'payment_reference': 'payment_reference',
        'comments': 'comments',
        'custom_fields': 'custom_fields'
    }

    def __init__(self, amount=None, payment_date=None, payment_amount_type=None, payment_method=None, token=None, fee=None, customer=None, funding_account=None, customer_account=None, payment_reference=None, comments=None, custom_fields=None):  # noqa: E501
        """RecordPaymentRequest - a model defined in Swagger"""  # noqa: E501

        self._amount = None
        self._payment_date = None
        self._payment_amount_type = None
        self._payment_method = None
        self._token = None
        self._fee = None
        self._customer = None
        self._funding_account = None
        self._customer_account = None
        self._payment_reference = None
        self._comments = None
        self._custom_fields = None
        self.discriminator = None

        if amount is not None:
            self.amount = amount
        self.payment_date = payment_date
        if payment_amount_type is not None:
            self.payment_amount_type = payment_amount_type
        self.payment_method = payment_method
        if token is not None:
            self.token = token
        if fee is not None:
            self.fee = fee
        self.customer = customer
        if funding_account is not None:
            self.funding_account = funding_account
        self.customer_account = customer_account
        if payment_reference is not None:
            self.payment_reference = payment_reference
        if comments is not None:
            self.comments = comments
        if custom_fields is not None:
            self.custom_fields = custom_fields

    def __getitem__(self,key):
        return getattr(self,key)

    @property
    def amount(self):
        """Gets the amount of this RecordPaymentRequest.  # noqa: E501

        The amount being paid.  # noqa: E501

        :return: The amount of this RecordPaymentRequest.  # noqa: E501
        :rtype: str
        """
        return self._amount

    @amount.setter
    def amount(self, amount):
        """Sets the amount of this RecordPaymentRequest.

        The amount being paid.  # noqa: E501

        :param amount: The amount of this RecordPaymentRequest.  # noqa: E501
        :type: str
        """
        self._amount = amount

    @property
    def payment_date(self):
        """Gets the payment_date of this RecordPaymentRequest.  # noqa: E501

        The date on which the payment is scheduled to be made. It must be in ISO8601 full-date format, namely, YYYY-MM-DD.  # noqa: E501

        :return: The payment_date of this RecordPaymentRequest.  # noqa: E501
        :rtype: str
        """
        return self._payment_date

    @payment_date.setter
    def payment_date(self, payment_date):
        """Sets the payment_date of this RecordPaymentRequest.

        The date on which the payment is scheduled to be made. It must be in ISO8601 full-date format, namely, YYYY-MM-DD.  # noqa: E501

        :param payment_date: The payment_date of this RecordPaymentRequest.  # noqa: E501
        :type: str
        """
        self._payment_date = payment_date

    @property
    def payment_amount_type(self):
        """Gets the payment_amount_type of this RecordPaymentRequest.  # noqa: E501

        The type of amount, as per the bill/statement, that is being paid. The payment amount is derived from the amount type selected for the payment. This defaults to other.  # noqa: E501

        :return: The payment_amount_type of this RecordPaymentRequest.  # noqa: E501
        :rtype: str
        """
        return self._payment_amount_type

    @payment_amount_type.setter
    def payment_amount_type(self, payment_amount_type):
        """Sets the payment_amount_type of this RecordPaymentRequest.

        The type of amount, as per the bill/statement, that is being paid. The payment amount is derived from the amount type selected for the payment. This defaults to other.  # noqa: E501

        :param payment_amount_type: The payment_amount_type of this RecordPaymentRequest.  # noqa: E501
        :type: str
        """
        self._payment_amount_type = payment_amount_type

    @property
    def payment_method(self):
        """Gets the payment_method of this RecordPaymentRequest.  # noqa: E501

        The non fulfillment method for the payment.  # noqa: E501

        :return: The payment_method of this RecordPaymentRequest.  # noqa: E501
        :rtype: str
        """
        return self._payment_method

    @payment_method.setter
    def payment_method(self, payment_method):
        """Sets the payment_method of this RecordPaymentRequest.

        The non fulfillment method for the payment.  # noqa: E501

        :param payment_method: The payment_method of this RecordPaymentRequest.  # noqa: E501
        :type: str
        """
        self._payment_method = payment_method

    @property
    def token(self):
        """Gets the token of this RecordPaymentRequest.  # noqa: E501

        The token is used to uniquely identify the payment, such as the POS token.  # noqa: E501

        :return: The token of this RecordPaymentRequest.  # noqa: E501
        :rtype: str
        """
        return self._token

    @token.setter
    def token(self, token):
        """Sets the token of this RecordPaymentRequest.

        The token is used to uniquely identify the payment, such as the POS token.  # noqa: E501

        :param token: The token of this RecordPaymentRequest.  # noqa: E501
        :type: str
        """
        self._token = token

    @property
    def fee(self):
        """Gets the fee of this RecordPaymentRequest.  # noqa: E501


        :return: The fee of this RecordPaymentRequest.  # noqa: E501
        :rtype: FeeRequest
        """
        return self._fee

    @fee.setter
    def fee(self, fee):
        """Sets the fee of this RecordPaymentRequest.


        :param fee: The fee of this RecordPaymentRequest.  # noqa: E501
        :type: FeeRequest
        """
        self._fee = fee

    @property
    def customer(self):
        """Gets the customer of this RecordPaymentRequest.  # noqa: E501


        :return: The customer of this RecordPaymentRequest.  # noqa: E501
        :rtype: RecordPaymentCustomerRequest
        """
        return self._customer

    @customer.setter
    def customer(self, customer):
        """Sets the customer of this RecordPaymentRequest.


        :param customer: The customer of this RecordPaymentRequest.  # noqa: E501
        :type: RecordPaymentCustomerRequest
        """
        self._customer = customer

    @property
    def funding_account(self):
        """Gets the funding_account of this RecordPaymentRequest.  # noqa: E501


        :return: The funding_account of this RecordPaymentRequest.  # noqa: E501
        :rtype: RecordedPaymentFundingAccount
        """
        return self._funding_account

    @funding_account.setter
    def funding_account(self, funding_account):
        """Sets the funding_account of this RecordPaymentRequest.


        :param funding_account: The funding_account of this RecordPaymentRequest.  # noqa: E501
        :type: RecordedPaymentFundingAccount
        """
        self._funding_account = funding_account

    @property
    def customer_account(self):
        """Gets the customer_account of this RecordPaymentRequest.  # noqa: E501


        :return: The customer_account of this RecordPaymentRequest.  # noqa: E501
        :rtype: RecordPaymentCustomerAccountRequest
        """
        return self._customer_account

    @customer_account.setter
    def customer_account(self, customer_account):
        """Sets the customer_account of this RecordPaymentRequest.


        :param customer_account: The customer_account of this RecordPaymentRequest.  # noqa: E501
        :type: RecordPaymentCustomerAccountRequest
        """
        self._customer_account = customer_account

    @property
    def payment_reference(self):
        """Gets the payment_reference of this RecordPaymentRequest.  # noqa: E501

        The unique identifier in the client system for the payment.  # noqa: E501

        :return: The payment_reference of this RecordPaymentRequest.  # noqa: E501
        :rtype: str
        """
        return self._payment_reference

    @payment_reference.setter
    def payment_reference(self, payment_reference):
        """Sets the payment_reference of this RecordPaymentRequest.

        The unique identifier in the client system for the payment.  # noqa: E501

        :param payment_reference: The payment_reference of this RecordPaymentRequest.  # noqa: E501
        :type: str
        """
        self._payment_reference = payment_reference

    @property
    def comments(self):
        """Gets the comments of this RecordPaymentRequest.  # noqa: E501


        :return: The comments of this RecordPaymentRequest.  # noqa: E501
        :rtype: str
        """
        return self._comments

    @comments.setter
    def comments(self, comments):
        """Sets the comments of this RecordPaymentRequest.


        :param comments: The comments of this RecordPaymentRequest.  # noqa: E501
        :type: str
        """
        self._comments = comments

    @property
    def custom_fields(self):
        """Gets the custom_fields of this RecordPaymentRequest.  # noqa: E501

        The additional information or meta-information that EBPP can accept, maintain and transmit back to the client.  # noqa: E501

        :return: The custom_fields of this RecordPaymentRequest.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._custom_fields

    @custom_fields.setter
    def custom_fields(self, custom_fields):
        """Sets the custom_fields of this RecordPaymentRequest.

        The additional information or meta-information that EBPP can accept, maintain and transmit back to the client.  # noqa: E501

        :param custom_fields: The custom_fields of this RecordPaymentRequest.  # noqa: E501
        :type: dict(str, str)
        """
        self._custom_fields = custom_fields

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(RecordPaymentRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RecordPaymentRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
