# coding: utf-8

"""
    ############################################################################################
    ## This class subject to change without prior notice, Please dont use this class directly.##
    ############################################################################################
"""


import pprint
import re  # noqa: F401

import six


class RecordedPaymentFundingAccount(object):
    """NOTE: 
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'account_number': 'str',
        'issuer_name': 'str'
    }

    attribute_map = {
        'account_number': 'account_number',
        'issuer_name': 'issuer_name'
    }

    def __init__(self, account_number=None, issuer_name=None):  # noqa: E501
        """RecordedPaymentFundingAccount - a model defined in Swagger"""  # noqa: E501

        self._account_number = None
        self._issuer_name = None
        self.discriminator = None

        if account_number is not None:
            self.account_number = account_number
        if issuer_name is not None:
            self.issuer_name = issuer_name

    def __getitem__(self,key):
        return getattr(self,key)

    @property
    def account_number(self):
        """Gets the account_number of this RecordedPaymentFundingAccount.  # noqa: E501

        The number or reference that a customer uses to identify the funding account. or last 4 digits of account number.  # noqa: E501

        :return: The account_number of this RecordedPaymentFundingAccount.  # noqa: E501
        :rtype: str
        """
        return self._account_number

    @account_number.setter
    def account_number(self, account_number):
        """Sets the account_number of this RecordedPaymentFundingAccount.

        The number or reference that a customer uses to identify the funding account. or last 4 digits of account number.  # noqa: E501

        :param account_number: The account_number of this RecordedPaymentFundingAccount.  # noqa: E501
        :type: str
        """
        self._account_number = account_number

    @property
    def issuer_name(self):
        """Gets the issuer_name of this RecordedPaymentFundingAccount.  # noqa: E501

        The name of the authority that has issued the account.  # noqa: E501

        :return: The issuer_name of this RecordedPaymentFundingAccount.  # noqa: E501
        :rtype: str
        """
        return self._issuer_name

    @issuer_name.setter
    def issuer_name(self, issuer_name):
        """Sets the issuer_name of this RecordedPaymentFundingAccount.

        The name of the authority that has issued the account.  # noqa: E501

        :param issuer_name: The issuer_name of this RecordedPaymentFundingAccount.  # noqa: E501
        :type: str
        """
        self._issuer_name = issuer_name

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(RecordedPaymentFundingAccount, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RecordedPaymentFundingAccount):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
