# coding: utf-8

"""
    ############################################################################################
    ## This class subject to change without prior notice, Please dont use this class directly.##
    ############################################################################################
"""


import pprint
import re  # noqa: F401

import six

from orbipay_paymentsapi_client.models.audit_info_vo import AuditInfoVo  # noqa: F401,E501
from orbipay_paymentsapi_client.models.fee_refund_response import FeeRefundResponse  # noqa: F401,E501
from orbipay_paymentsapi_client.models.payment_network_response_vo import PaymentNetworkResponseVo  # noqa: F401,E501
from orbipay_paymentsapi_client.models.source_payment import SourcePayment  # noqa: F401,E501


class RefundResponse(object):
    """NOTE: 
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'refund_reference': 'str',
        'id': 'str',
        'url': 'str',
        'refund_type': 'str',
        'refund_amount': 'str',
        'fee_refund': 'FeeRefundResponse',
        'status': 'str',
        'confirmation_number': 'str',
        'refund_date': 'str',
        'refund_entry_date': 'str',
        'expected_refund_settlement_date': 'str',
        'custom_fields': 'dict(str, str)',
        'comments': 'str',
        'source_payment': 'SourcePayment',
        'payment_network_response': 'PaymentNetworkResponseVo',
        'audit_info': 'AuditInfoVo'
    }

    attribute_map = {
        'refund_reference': 'refund_reference',
        'id': 'id',
        'url': 'url',
        'refund_type': 'refund_type',
        'refund_amount': 'refund_amount',
        'fee_refund': 'fee_refund',
        'status': 'status',
        'confirmation_number': 'confirmation_number',
        'refund_date': 'refund_date',
        'refund_entry_date': 'refund_entry_date',
        'expected_refund_settlement_date': 'expected_refund_settlement_date',
        'custom_fields': 'custom_fields',
        'comments': 'comments',
        'source_payment': 'source_payment',
        'payment_network_response': 'payment_network_response',
        'audit_info': 'audit_info'
    }

    def __init__(self, refund_reference=None, id=None, url=None, refund_type=None, refund_amount=None, fee_refund=None, status=None, confirmation_number=None, refund_date=None, refund_entry_date=None, expected_refund_settlement_date=None, custom_fields=None, comments=None, source_payment=None, payment_network_response=None, audit_info=None):  # noqa: E501
        """RefundResponse - a model defined in Swagger"""  # noqa: E501

        self._refund_reference = None
        self._id = None
        self._url = None
        self._refund_type = None
        self._refund_amount = None
        self._fee_refund = None
        self._status = None
        self._confirmation_number = None
        self._refund_date = None
        self._refund_entry_date = None
        self._expected_refund_settlement_date = None
        self._custom_fields = None
        self._comments = None
        self._source_payment = None
        self._payment_network_response = None
        self._audit_info = None
        self.discriminator = None

        if refund_reference is not None:
            self.refund_reference = refund_reference
        if id is not None:
            self.id = id
        if url is not None:
            self.url = url
        if refund_type is not None:
            self.refund_type = refund_type
        if refund_amount is not None:
            self.refund_amount = refund_amount
        if fee_refund is not None:
            self.fee_refund = fee_refund
        if status is not None:
            self.status = status
        if confirmation_number is not None:
            self.confirmation_number = confirmation_number
        if refund_date is not None:
            self.refund_date = refund_date
        if refund_entry_date is not None:
            self.refund_entry_date = refund_entry_date
        if expected_refund_settlement_date is not None:
            self.expected_refund_settlement_date = expected_refund_settlement_date
        if custom_fields is not None:
            self.custom_fields = custom_fields
        if comments is not None:
            self.comments = comments
        if source_payment is not None:
            self.source_payment = source_payment
        if payment_network_response is not None:
            self.payment_network_response = payment_network_response
        if audit_info is not None:
            self.audit_info = audit_info

    def __getitem__(self,key):
        return getattr(self,key)

    @property
    def refund_reference(self):
        """Gets the refund_reference of this RefundResponse.  # noqa: E501

        The unique identifier in the client system for the refund.  # noqa: E501

        :return: The refund_reference of this RefundResponse.  # noqa: E501
        :rtype: str
        """
        return self._refund_reference

    @refund_reference.setter
    def refund_reference(self, refund_reference):
        """Sets the refund_reference of this RefundResponse.

        The unique identifier in the client system for the refund.  # noqa: E501

        :param refund_reference: The refund_reference of this RefundResponse.  # noqa: E501
        :type: str
        """
        self._refund_reference = refund_reference

    @property
    def id(self):
        """Gets the id of this RefundResponse.  # noqa: E501

        The unique identifier assigned by EBPP to the refund.  # noqa: E501

        :return: The id of this RefundResponse.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this RefundResponse.

        The unique identifier assigned by EBPP to the refund.  # noqa: E501

        :param id: The id of this RefundResponse.  # noqa: E501
        :type: str
        """
        self._id = id

    @property
    def url(self):
        """Gets the url of this RefundResponse.  # noqa: E501

        This URL fetches the details of refund.  # noqa: E501

        :return: The url of this RefundResponse.  # noqa: E501
        :rtype: str
        """
        return self._url

    @url.setter
    def url(self, url):
        """Sets the url of this RefundResponse.

        This URL fetches the details of refund.  # noqa: E501

        :param url: The url of this RefundResponse.  # noqa: E501
        :type: str
        """
        self._url = url

    @property
    def refund_type(self):
        """Gets the refund_type of this RefundResponse.  # noqa: E501

        The portion of the payment amount that is to be or has been refunded. The original payment can be refunded fully including the amount and the fee components, or partially, for just the amount or the fee component. Refund can also be initiated for an arbitrary amount limited by the original payment amount.  # noqa: E501

        :return: The refund_type of this RefundResponse.  # noqa: E501
        :rtype: str
        """
        return self._refund_type

    @refund_type.setter
    def refund_type(self, refund_type):
        """Sets the refund_type of this RefundResponse.

        The portion of the payment amount that is to be or has been refunded. The original payment can be refunded fully including the amount and the fee components, or partially, for just the amount or the fee component. Refund can also be initiated for an arbitrary amount limited by the original payment amount.  # noqa: E501

        :param refund_type: The refund_type of this RefundResponse.  # noqa: E501
        :type: str
        """
        self._refund_type = refund_type

    @property
    def refund_amount(self):
        """Gets the refund_amount of this RefundResponse.  # noqa: E501

        The refund amount upto 2 decimal places.  # noqa: E501

        :return: The refund_amount of this RefundResponse.  # noqa: E501
        :rtype: str
        """
        return self._refund_amount

    @refund_amount.setter
    def refund_amount(self, refund_amount):
        """Sets the refund_amount of this RefundResponse.

        The refund amount upto 2 decimal places.  # noqa: E501

        :param refund_amount: The refund_amount of this RefundResponse.  # noqa: E501
        :type: str
        """
        self._refund_amount = refund_amount

    @property
    def fee_refund(self):
        """Gets the fee_refund of this RefundResponse.  # noqa: E501


        :return: The fee_refund of this RefundResponse.  # noqa: E501
        :rtype: FeeRefundResponse
        """
        return self._fee_refund

    @fee_refund.setter
    def fee_refund(self, fee_refund):
        """Sets the fee_refund of this RefundResponse.


        :param fee_refund: The fee_refund of this RefundResponse.  # noqa: E501
        :type: FeeRefundResponse
        """
        self._fee_refund = fee_refund

    @property
    def status(self):
        """Gets the status of this RefundResponse.  # noqa: E501

        The status of the refund.  # noqa: E501

        :return: The status of this RefundResponse.  # noqa: E501
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this RefundResponse.

        The status of the refund.  # noqa: E501

        :param status: The status of this RefundResponse.  # noqa: E501
        :type: str
        """
        self._status = status

    @property
    def confirmation_number(self):
        """Gets the confirmation_number of this RefundResponse.  # noqa: E501

        The confirmation number or reference provided to the customer for the refund.  # noqa: E501

        :return: The confirmation_number of this RefundResponse.  # noqa: E501
        :rtype: str
        """
        return self._confirmation_number

    @confirmation_number.setter
    def confirmation_number(self, confirmation_number):
        """Sets the confirmation_number of this RefundResponse.

        The confirmation number or reference provided to the customer for the refund.  # noqa: E501

        :param confirmation_number: The confirmation_number of this RefundResponse.  # noqa: E501
        :type: str
        """
        self._confirmation_number = confirmation_number

    @property
    def refund_date(self):
        """Gets the refund_date of this RefundResponse.  # noqa: E501

        The date on which the refund is scheduled to be made. It must be in ISO8601 full-date format, namely, YYYY-MM-DD.  # noqa: E501

        :return: The refund_date of this RefundResponse.  # noqa: E501
        :rtype: str
        """
        return self._refund_date

    @refund_date.setter
    def refund_date(self, refund_date):
        """Sets the refund_date of this RefundResponse.

        The date on which the refund is scheduled to be made. It must be in ISO8601 full-date format, namely, YYYY-MM-DD.  # noqa: E501

        :param refund_date: The refund_date of this RefundResponse.  # noqa: E501
        :type: str
        """
        self._refund_date = refund_date

    @property
    def refund_entry_date(self):
        """Gets the refund_entry_date of this RefundResponse.  # noqa: E501

        The date on which the refund captured in EBPP. It must be in ISO8601 full-date format, namely, YYYY-MM-DD.  # noqa: E501

        :return: The refund_entry_date of this RefundResponse.  # noqa: E501
        :rtype: str
        """
        return self._refund_entry_date

    @refund_entry_date.setter
    def refund_entry_date(self, refund_entry_date):
        """Sets the refund_entry_date of this RefundResponse.

        The date on which the refund captured in EBPP. It must be in ISO8601 full-date format, namely, YYYY-MM-DD.  # noqa: E501

        :param refund_entry_date: The refund_entry_date of this RefundResponse.  # noqa: E501
        :type: str
        """
        self._refund_entry_date = refund_entry_date

    @property
    def expected_refund_settlement_date(self):
        """Gets the expected_refund_settlement_date of this RefundResponse.  # noqa: E501

        The date by which the credits would be posted to the original funding account. ISO8601 full-date format, YYYY-MM-DD  # noqa: E501

        :return: The expected_refund_settlement_date of this RefundResponse.  # noqa: E501
        :rtype: str
        """
        return self._expected_refund_settlement_date

    @expected_refund_settlement_date.setter
    def expected_refund_settlement_date(self, expected_refund_settlement_date):
        """Sets the expected_refund_settlement_date of this RefundResponse.

        The date by which the credits would be posted to the original funding account. ISO8601 full-date format, YYYY-MM-DD  # noqa: E501

        :param expected_refund_settlement_date: The expected_refund_settlement_date of this RefundResponse.  # noqa: E501
        :type: str
        """
        self._expected_refund_settlement_date = expected_refund_settlement_date

    @property
    def custom_fields(self):
        """Gets the custom_fields of this RefundResponse.  # noqa: E501

        The additional information or meta-information that EBPP can accept, maintain and transmit back to the client. The custom fields need to be configured with EBPP before they can be accepted. EBPP would reject custom fields that are not pre-configured. Please contact <a href = \"mailto: support@billerpayments.com\">support@billerpayments.com</a> for more information on configuring and using custom fields.  # noqa: E501

        :return: The custom_fields of this RefundResponse.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._custom_fields

    @custom_fields.setter
    def custom_fields(self, custom_fields):
        """Sets the custom_fields of this RefundResponse.

        The additional information or meta-information that EBPP can accept, maintain and transmit back to the client. The custom fields need to be configured with EBPP before they can be accepted. EBPP would reject custom fields that are not pre-configured. Please contact <a href = \"mailto: support@billerpayments.com\">support@billerpayments.com</a> for more information on configuring and using custom fields.  # noqa: E501

        :param custom_fields: The custom_fields of this RefundResponse.  # noqa: E501
        :type: dict(str, str)
        """
        self._custom_fields = custom_fields

    @property
    def comments(self):
        """Gets the comments of this RefundResponse.  # noqa: E501

        Comments that can be used to recollect the operation performed on the resource object. API clients need to ensure that no sensitive information is passed in the memo. Alacriti (EBPP) is not responsible for the security of any sensitive information that may be passed as part of the memo.  # noqa: E501

        :return: The comments of this RefundResponse.  # noqa: E501
        :rtype: str
        """
        return self._comments

    @comments.setter
    def comments(self, comments):
        """Sets the comments of this RefundResponse.

        Comments that can be used to recollect the operation performed on the resource object. API clients need to ensure that no sensitive information is passed in the memo. Alacriti (EBPP) is not responsible for the security of any sensitive information that may be passed as part of the memo.  # noqa: E501

        :param comments: The comments of this RefundResponse.  # noqa: E501
        :type: str
        """
        self._comments = comments

    @property
    def source_payment(self):
        """Gets the source_payment of this RefundResponse.  # noqa: E501


        :return: The source_payment of this RefundResponse.  # noqa: E501
        :rtype: SourcePayment
        """
        return self._source_payment

    @source_payment.setter
    def source_payment(self, source_payment):
        """Sets the source_payment of this RefundResponse.


        :param source_payment: The source_payment of this RefundResponse.  # noqa: E501
        :type: SourcePayment
        """
        self._source_payment = source_payment

    @property
    def payment_network_response(self):
        """Gets the payment_network_response of this RefundResponse.  # noqa: E501


        :return: The payment_network_response of this RefundResponse.  # noqa: E501
        :rtype: PaymentNetworkResponseVo
        """
        return self._payment_network_response

    @payment_network_response.setter
    def payment_network_response(self, payment_network_response):
        """Sets the payment_network_response of this RefundResponse.


        :param payment_network_response: The payment_network_response of this RefundResponse.  # noqa: E501
        :type: PaymentNetworkResponseVo
        """
        self._payment_network_response = payment_network_response

    @property
    def audit_info(self):
        """Gets the audit_info of this RefundResponse.  # noqa: E501


        :return: The audit_info of this RefundResponse.  # noqa: E501
        :rtype: AuditInfoVo
        """
        return self._audit_info

    @audit_info.setter
    def audit_info(self, audit_info):
        """Sets the audit_info of this RefundResponse.


        :param audit_info: The audit_info of this RefundResponse.  # noqa: E501
        :type: AuditInfoVo
        """
        self._audit_info = audit_info

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(RefundResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RefundResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
