# coding: utf-8

"""
    ############################################################################################
    ## This class subject to change without prior notice, Please dont use this class directly.##
    ############################################################################################
"""


import pprint
import re  # noqa: F401

import six

from orbipay_paymentsapi_client.models.address_vo import AddressVo  # noqa: F401,E501


class RenewCustomerAccountRequest(object):
    """NOTE: 
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'account_holder_name': 'str',
        'nickname': 'str',
        'address': 'AddressVo',
        'customer_account_reference': 'str',
        'account_number': 'str',
        'current_balance': 'str',
        'current_statement_balance': 'str',
        'minimum_payment_due': 'str',
        'past_amount_due': 'str',
        'payment_due_date': 'str',
        'statement_date': 'str',
        'custom_fields': 'dict(str, str)',
        'comments': 'str'
    }

    attribute_map = {
        'account_holder_name': 'account_holder_name',
        'nickname': 'nickname',
        'address': 'address',
        'customer_account_reference': 'customer_account_reference',
        'account_number': 'account_number',
        'current_balance': 'current_balance',
        'current_statement_balance': 'current_statement_balance',
        'minimum_payment_due': 'minimum_payment_due',
        'past_amount_due': 'past_amount_due',
        'payment_due_date': 'payment_due_date',
        'statement_date': 'statement_date',
        'custom_fields': 'custom_fields',
        'comments': 'comments'
    }

    def __init__(self, account_holder_name=None, nickname=None, address=None, customer_account_reference=None, account_number=None, current_balance=None, current_statement_balance=None, minimum_payment_due=None, past_amount_due=None, payment_due_date=None, statement_date=None, custom_fields=None, comments=None):  # noqa: E501
        """RenewCustomerAccountRequest - a model defined in Swagger"""  # noqa: E501

        self._account_holder_name = None
        self._nickname = None
        self._address = None
        self._customer_account_reference = None
        self._account_number = None
        self._current_balance = None
        self._current_statement_balance = None
        self._minimum_payment_due = None
        self._past_amount_due = None
        self._payment_due_date = None
        self._statement_date = None
        self._custom_fields = None
        self._comments = None
        self.discriminator = None

        self.account_holder_name = account_holder_name
        if nickname is not None:
            self.nickname = nickname
        if address is not None:
            self.address = address
        if customer_account_reference is not None:
            self.customer_account_reference = customer_account_reference
        self.account_number = account_number
        if current_balance is not None:
            self.current_balance = current_balance
        if current_statement_balance is not None:
            self.current_statement_balance = current_statement_balance
        if minimum_payment_due is not None:
            self.minimum_payment_due = minimum_payment_due
        if past_amount_due is not None:
            self.past_amount_due = past_amount_due
        if payment_due_date is not None:
            self.payment_due_date = payment_due_date
        if statement_date is not None:
            self.statement_date = statement_date
        if custom_fields is not None:
            self.custom_fields = custom_fields
        if comments is not None:
            self.comments = comments

    def __getitem__(self,key):
        return getattr(self,key)

    @property
    def account_holder_name(self):
        """Gets the account_holder_name of this RenewCustomerAccountRequest.  # noqa: E501

        The name as specified on the account.  # noqa: E501

        :return: The account_holder_name of this RenewCustomerAccountRequest.  # noqa: E501
        :rtype: str
        """
        return self._account_holder_name

    @account_holder_name.setter
    def account_holder_name(self, account_holder_name):
        """Sets the account_holder_name of this RenewCustomerAccountRequest.

        The name as specified on the account.  # noqa: E501

        :param account_holder_name: The account_holder_name of this RenewCustomerAccountRequest.  # noqa: E501
        :type: str
        """
        self._account_holder_name = account_holder_name

    @property
    def nickname(self):
        """Gets the nickname of this RenewCustomerAccountRequest.  # noqa: E501

        The nickname by which a customer might want to identify the account.  # noqa: E501

        :return: The nickname of this RenewCustomerAccountRequest.  # noqa: E501
        :rtype: str
        """
        return self._nickname

    @nickname.setter
    def nickname(self, nickname):
        """Sets the nickname of this RenewCustomerAccountRequest.

        The nickname by which a customer might want to identify the account.  # noqa: E501

        :param nickname: The nickname of this RenewCustomerAccountRequest.  # noqa: E501
        :type: str
        """
        self._nickname = nickname

    @property
    def address(self):
        """Gets the address of this RenewCustomerAccountRequest.  # noqa: E501


        :return: The address of this RenewCustomerAccountRequest.  # noqa: E501
        :rtype: AddressVo
        """
        return self._address

    @address.setter
    def address(self, address):
        """Sets the address of this RenewCustomerAccountRequest.


        :param address: The address of this RenewCustomerAccountRequest.  # noqa: E501
        :type: AddressVo
        """
        self._address = address

    @property
    def customer_account_reference(self):
        """Gets the customer_account_reference of this RenewCustomerAccountRequest.  # noqa: E501

        The unique identifier in the client system for the customer account.  # noqa: E501

        :return: The customer_account_reference of this RenewCustomerAccountRequest.  # noqa: E501
        :rtype: str
        """
        return self._customer_account_reference

    @customer_account_reference.setter
    def customer_account_reference(self, customer_account_reference):
        """Sets the customer_account_reference of this RenewCustomerAccountRequest.

        The unique identifier in the client system for the customer account.  # noqa: E501

        :param customer_account_reference: The customer_account_reference of this RenewCustomerAccountRequest.  # noqa: E501
        :type: str
        """
        self._customer_account_reference = customer_account_reference

    @property
    def account_number(self):
        """Gets the account_number of this RenewCustomerAccountRequest.  # noqa: E501

        The number or reference that a customer uses to identify the customer's account.  # noqa: E501

        :return: The account_number of this RenewCustomerAccountRequest.  # noqa: E501
        :rtype: str
        """
        return self._account_number

    @account_number.setter
    def account_number(self, account_number):
        """Sets the account_number of this RenewCustomerAccountRequest.

        The number or reference that a customer uses to identify the customer's account.  # noqa: E501

        :param account_number: The account_number of this RenewCustomerAccountRequest.  # noqa: E501
        :type: str
        """
        self._account_number = account_number

    @property
    def current_balance(self):
        """Gets the current_balance of this RenewCustomerAccountRequest.  # noqa: E501

        The current balance on the customer's account with the biller.  # noqa: E501

        :return: The current_balance of this RenewCustomerAccountRequest.  # noqa: E501
        :rtype: str
        """
        return self._current_balance

    @current_balance.setter
    def current_balance(self, current_balance):
        """Sets the current_balance of this RenewCustomerAccountRequest.

        The current balance on the customer's account with the biller.  # noqa: E501

        :param current_balance: The current_balance of this RenewCustomerAccountRequest.  # noqa: E501
        :type: str
        """
        self._current_balance = current_balance

    @property
    def current_statement_balance(self):
        """Gets the current_statement_balance of this RenewCustomerAccountRequest.  # noqa: E501

        The balance on the customer’s account with the biller as reported on the last statement.  # noqa: E501

        :return: The current_statement_balance of this RenewCustomerAccountRequest.  # noqa: E501
        :rtype: str
        """
        return self._current_statement_balance

    @current_statement_balance.setter
    def current_statement_balance(self, current_statement_balance):
        """Sets the current_statement_balance of this RenewCustomerAccountRequest.

        The balance on the customer’s account with the biller as reported on the last statement.  # noqa: E501

        :param current_statement_balance: The current_statement_balance of this RenewCustomerAccountRequest.  # noqa: E501
        :type: str
        """
        self._current_statement_balance = current_statement_balance

    @property
    def minimum_payment_due(self):
        """Gets the minimum_payment_due of this RenewCustomerAccountRequest.  # noqa: E501

        The minimum payment amount, as specified by the biller, that needs to be made against the customer’s account.  # noqa: E501

        :return: The minimum_payment_due of this RenewCustomerAccountRequest.  # noqa: E501
        :rtype: str
        """
        return self._minimum_payment_due

    @minimum_payment_due.setter
    def minimum_payment_due(self, minimum_payment_due):
        """Sets the minimum_payment_due of this RenewCustomerAccountRequest.

        The minimum payment amount, as specified by the biller, that needs to be made against the customer’s account.  # noqa: E501

        :param minimum_payment_due: The minimum_payment_due of this RenewCustomerAccountRequest.  # noqa: E501
        :type: str
        """
        self._minimum_payment_due = minimum_payment_due

    @property
    def past_amount_due(self):
        """Gets the past_amount_due of this RenewCustomerAccountRequest.  # noqa: E501

        The amount that is due from the past bills/statements on the customer’s account with the biller.  # noqa: E501

        :return: The past_amount_due of this RenewCustomerAccountRequest.  # noqa: E501
        :rtype: str
        """
        return self._past_amount_due

    @past_amount_due.setter
    def past_amount_due(self, past_amount_due):
        """Sets the past_amount_due of this RenewCustomerAccountRequest.

        The amount that is due from the past bills/statements on the customer’s account with the biller.  # noqa: E501

        :param past_amount_due: The past_amount_due of this RenewCustomerAccountRequest.  # noqa: E501
        :type: str
        """
        self._past_amount_due = past_amount_due

    @property
    def payment_due_date(self):
        """Gets the payment_due_date of this RenewCustomerAccountRequest.  # noqa: E501

        The date by which the customer needs to clear the dues against the customer's account with the biller. It must be in ISO8601 full-date format, namely, YYYY-MM-DD.  # noqa: E501

        :return: The payment_due_date of this RenewCustomerAccountRequest.  # noqa: E501
        :rtype: str
        """
        return self._payment_due_date

    @payment_due_date.setter
    def payment_due_date(self, payment_due_date):
        """Sets the payment_due_date of this RenewCustomerAccountRequest.

        The date by which the customer needs to clear the dues against the customer's account with the biller. It must be in ISO8601 full-date format, namely, YYYY-MM-DD.  # noqa: E501

        :param payment_due_date: The payment_due_date of this RenewCustomerAccountRequest.  # noqa: E501
        :type: str
        """
        self._payment_due_date = payment_due_date

    @property
    def statement_date(self):
        """Gets the statement_date of this RenewCustomerAccountRequest.  # noqa: E501

        The date on which the biller generates the statement for the customer's account. It must be in ISO8601 full-date format, namely, YYYY-MM-DD.  # noqa: E501

        :return: The statement_date of this RenewCustomerAccountRequest.  # noqa: E501
        :rtype: str
        """
        return self._statement_date

    @statement_date.setter
    def statement_date(self, statement_date):
        """Sets the statement_date of this RenewCustomerAccountRequest.

        The date on which the biller generates the statement for the customer's account. It must be in ISO8601 full-date format, namely, YYYY-MM-DD.  # noqa: E501

        :param statement_date: The statement_date of this RenewCustomerAccountRequest.  # noqa: E501
        :type: str
        """
        self._statement_date = statement_date

    @property
    def custom_fields(self):
        """Gets the custom_fields of this RenewCustomerAccountRequest.  # noqa: E501

        The additional information or meta-information that EBPP can accept, maintain and transmit back to the client.   # noqa: E501

        :return: The custom_fields of this RenewCustomerAccountRequest.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._custom_fields

    @custom_fields.setter
    def custom_fields(self, custom_fields):
        """Sets the custom_fields of this RenewCustomerAccountRequest.

        The additional information or meta-information that EBPP can accept, maintain and transmit back to the client.   # noqa: E501

        :param custom_fields: The custom_fields of this RenewCustomerAccountRequest.  # noqa: E501
        :type: dict(str, str)
        """
        self._custom_fields = custom_fields

    @property
    def comments(self):
        """Gets the comments of this RenewCustomerAccountRequest.  # noqa: E501

        Comments that can be used to recollect the operation performed on the resource object.  # noqa: E501

        :return: The comments of this RenewCustomerAccountRequest.  # noqa: E501
        :rtype: str
        """
        return self._comments

    @comments.setter
    def comments(self, comments):
        """Sets the comments of this RenewCustomerAccountRequest.

        Comments that can be used to recollect the operation performed on the resource object.  # noqa: E501

        :param comments: The comments of this RenewCustomerAccountRequest.  # noqa: E501
        :type: str
        """
        self._comments = comments

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(RenewCustomerAccountRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RenewCustomerAccountRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
