# coding: utf-8

"""
    ############################################################################################
    ## This class subject to change without prior notice, Please dont use this class directly.##
    ############################################################################################
"""


import pprint
import re  # noqa: F401

import six


class ResourceAuditVo(object):
    """NOTE: 
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'channel': 'str',
        'requestor_type': 'str',
        'requestor': 'str',
        'timestamp': 'str'
    }

    attribute_map = {
        'channel': 'channel',
        'requestor_type': 'requestor_type',
        'requestor': 'requestor',
        'timestamp': 'timestamp'
    }

    def __init__(self, channel=None, requestor_type=None, requestor=None, timestamp=None):  # noqa: E501
        """ResourceAuditVo - a model defined in Swagger"""  # noqa: E501

        self._channel = None
        self._requestor_type = None
        self._requestor = None
        self._timestamp = None
        self.discriminator = None

        if channel is not None:
            self.channel = channel
        if requestor_type is not None:
            self.requestor_type = requestor_type
        if requestor is not None:
            self.requestor = requestor
        if timestamp is not None:
            self.timestamp = timestamp

    def __getitem__(self,key):
        return getattr(self,key)

    @property
    def channel(self):
        """Gets the channel of this ResourceAuditVo.  # noqa: E501

        The channel through which the API is invoked. Please contact <a href = \"mailto: support@billerpayments.com\">support@billerpayments.com</a> to configure channels.  # noqa: E501

        :return: The channel of this ResourceAuditVo.  # noqa: E501
        :rtype: str
        """
        return self._channel

    @channel.setter
    def channel(self, channel):
        """Sets the channel of this ResourceAuditVo.

        The channel through which the API is invoked. Please contact <a href = \"mailto: support@billerpayments.com\">support@billerpayments.com</a> to configure channels.  # noqa: E501

        :param channel: The channel of this ResourceAuditVo.  # noqa: E501
        :type: str
        """
        self._channel = channel

    @property
    def requestor_type(self):
        """Gets the requestor_type of this ResourceAuditVo.  # noqa: E501

        If an API is being requested from an application that is being used directly by a customer, like the customer portal and IVR, the requestor_type should be set to \"customer\".</br> If an API is being requested from an application that is being used by third party agents/brokers servicing a customer on behalf of a biller/client, then the requestor_type should be set to \"external_user\". It should be noted that these users would not have logins for the EBPP Portal or Payment Center.  # noqa: E501

        :return: The requestor_type of this ResourceAuditVo.  # noqa: E501
        :rtype: str
        """
        return self._requestor_type

    @requestor_type.setter
    def requestor_type(self, requestor_type):
        """Sets the requestor_type of this ResourceAuditVo.

        If an API is being requested from an application that is being used directly by a customer, like the customer portal and IVR, the requestor_type should be set to \"customer\".</br> If an API is being requested from an application that is being used by third party agents/brokers servicing a customer on behalf of a biller/client, then the requestor_type should be set to \"external_user\". It should be noted that these users would not have logins for the EBPP Portal or Payment Center.  # noqa: E501

        :param requestor_type: The requestor_type of this ResourceAuditVo.  # noqa: E501
        :type: str
        """
        self._requestor_type = requestor_type

    @property
    def requestor(self):
        """Gets the requestor of this ResourceAuditVo.  # noqa: E501

        The identifier for the requestor of the API, in EBPP. The value to be passed in the requestor field would depend on the requestor_type.</br> If the requestor_type is \"customer\", the requestor should be the EBPP generated customer id. In the case of self registration, where there is no EBPP generated customer id yet, the requestor should be set to 'guest'.</br> If the requestor_type is \"external_user\", the requestor can be any unique identifier that the client may have for the external agent.   # noqa: E501

        :return: The requestor of this ResourceAuditVo.  # noqa: E501
        :rtype: str
        """
        return self._requestor

    @requestor.setter
    def requestor(self, requestor):
        """Sets the requestor of this ResourceAuditVo.

        The identifier for the requestor of the API, in EBPP. The value to be passed in the requestor field would depend on the requestor_type.</br> If the requestor_type is \"customer\", the requestor should be the EBPP generated customer id. In the case of self registration, where there is no EBPP generated customer id yet, the requestor should be set to 'guest'.</br> If the requestor_type is \"external_user\", the requestor can be any unique identifier that the client may have for the external agent.   # noqa: E501

        :param requestor: The requestor of this ResourceAuditVo.  # noqa: E501
        :type: str
        """
        self._requestor = requestor

    @property
    def timestamp(self):
        """Gets the timestamp of this ResourceAuditVo.  # noqa: E501

        The UTC timestamp, in ISO8601 format, for the moment when the resource got created or modified in EBPP. For e.g., 2019-08-13T09:21:34.359+0000  # noqa: E501

        :return: The timestamp of this ResourceAuditVo.  # noqa: E501
        :rtype: str
        """
        return self._timestamp

    @timestamp.setter
    def timestamp(self, timestamp):
        """Sets the timestamp of this ResourceAuditVo.

        The UTC timestamp, in ISO8601 format, for the moment when the resource got created or modified in EBPP. For e.g., 2019-08-13T09:21:34.359+0000  # noqa: E501

        :param timestamp: The timestamp of this ResourceAuditVo.  # noqa: E501
        :type: str
        """
        self._timestamp = timestamp

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ResourceAuditVo, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ResourceAuditVo):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
