# coding: utf-8

"""
    ############################################################################################
    ## This class subject to change without prior notice, Please dont use this class directly.##
    ############################################################################################
"""


import pprint
import re  # noqa: F401

import six

from orbipay_paymentsapi_client.models.funding_account_address import FundingAccountAddress  # noqa: F401,E501


class SimplePaymentFundingAccountRequest(object):
    """NOTE: 
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'account_holder_name': 'str',
        'nickname': 'str',
        'address': 'FundingAccountAddress',
        'account_number': 'str',
        'aba_routing_number': 'str',
        'expiry_date': 'str',
        'account_holder_type': 'str',
        'custom_fields': 'dict(str, str)',
        'account_subtype': 'str',
        'card_cvv_number': 'str',
        'device_manufacturer_id': 'str',
        'display_text': 'str'
    }

    attribute_map = {
        'account_holder_name': 'account_holder_name',
        'nickname': 'nickname',
        'address': 'address',
        'account_number': 'account_number',
        'aba_routing_number': 'aba_routing_number',
        'expiry_date': 'expiry_date',
        'account_holder_type': 'account_holder_type',
        'custom_fields': 'custom_fields',
        'account_subtype': 'account_subtype',
        'card_cvv_number': 'card_cvv_number',
        'device_manufacturer_id': 'device_manufacturer_id',
        'display_text': 'display_text'
    }

    def __init__(self, account_holder_name=None, nickname=None, address=None, account_number=None, aba_routing_number=None, expiry_date=None, account_holder_type=None, custom_fields=None, account_subtype=None, card_cvv_number=None, device_manufacturer_id=None, display_text=None):  # noqa: E501
        """SimplePaymentFundingAccountRequest - a model defined in Swagger"""  # noqa: E501

        self._account_holder_name = None
        self._nickname = None
        self._address = None
        self._account_number = None
        self._aba_routing_number = None
        self._expiry_date = None
        self._account_holder_type = None
        self._custom_fields = None
        self._account_subtype = None
        self._card_cvv_number = None
        self._device_manufacturer_id = None
        self._display_text = None
        self.discriminator = None

        if account_holder_name is not None:
            self.account_holder_name = account_holder_name
        if nickname is not None:
            self.nickname = nickname
        if address is not None:
            self.address = address
        self.account_number = account_number
        if aba_routing_number is not None:
            self.aba_routing_number = aba_routing_number
        if expiry_date is not None:
            self.expiry_date = expiry_date
        if account_holder_type is not None:
            self.account_holder_type = account_holder_type
        if custom_fields is not None:
            self.custom_fields = custom_fields
        if account_subtype is not None:
            self.account_subtype = account_subtype
        if card_cvv_number is not None:
            self.card_cvv_number = card_cvv_number
        if device_manufacturer_id is not None:
            self.device_manufacturer_id = device_manufacturer_id
        if display_text is not None:
            self.display_text = display_text

    def __getitem__(self,key):
        return getattr(self,key)

    @property
    def account_holder_name(self):
        """Gets the account_holder_name of this SimplePaymentFundingAccountRequest.  # noqa: E501

        The name as specified on the account.  # noqa: E501

        :return: The account_holder_name of this SimplePaymentFundingAccountRequest.  # noqa: E501
        :rtype: str
        """
        return self._account_holder_name

    @account_holder_name.setter
    def account_holder_name(self, account_holder_name):
        """Sets the account_holder_name of this SimplePaymentFundingAccountRequest.

        The name as specified on the account.  # noqa: E501

        :param account_holder_name: The account_holder_name of this SimplePaymentFundingAccountRequest.  # noqa: E501
        :type: str
        """
        self._account_holder_name = account_holder_name

    @property
    def nickname(self):
        """Gets the nickname of this SimplePaymentFundingAccountRequest.  # noqa: E501

        The nickname by which a customer might want to identify the account.  # noqa: E501

        :return: The nickname of this SimplePaymentFundingAccountRequest.  # noqa: E501
        :rtype: str
        """
        return self._nickname

    @nickname.setter
    def nickname(self, nickname):
        """Sets the nickname of this SimplePaymentFundingAccountRequest.

        The nickname by which a customer might want to identify the account.  # noqa: E501

        :param nickname: The nickname of this SimplePaymentFundingAccountRequest.  # noqa: E501
        :type: str
        """
        self._nickname = nickname

    @property
    def address(self):
        """Gets the address of this SimplePaymentFundingAccountRequest.  # noqa: E501


        :return: The address of this SimplePaymentFundingAccountRequest.  # noqa: E501
        :rtype: FundingAccountAddress
        """
        return self._address

    @address.setter
    def address(self, address):
        """Sets the address of this SimplePaymentFundingAccountRequest.


        :param address: The address of this SimplePaymentFundingAccountRequest.  # noqa: E501
        :type: FundingAccountAddress
        """
        self._address = address

    @property
    def account_number(self):
        """Gets the account_number of this SimplePaymentFundingAccountRequest.  # noqa: E501

        The number or reference that a customer uses to identify the funding account.  # noqa: E501

        :return: The account_number of this SimplePaymentFundingAccountRequest.  # noqa: E501
        :rtype: str
        """
        return self._account_number

    @account_number.setter
    def account_number(self, account_number):
        """Sets the account_number of this SimplePaymentFundingAccountRequest.

        The number or reference that a customer uses to identify the funding account.  # noqa: E501

        :param account_number: The account_number of this SimplePaymentFundingAccountRequest.  # noqa: E501
        :type: str
        """
        self._account_number = account_number

    @property
    def aba_routing_number(self):
        """Gets the aba_routing_number of this SimplePaymentFundingAccountRequest.  # noqa: E501

        The ABA/Routing number for the bank account.  # noqa: E501

        :return: The aba_routing_number of this SimplePaymentFundingAccountRequest.  # noqa: E501
        :rtype: str
        """
        return self._aba_routing_number

    @aba_routing_number.setter
    def aba_routing_number(self, aba_routing_number):
        """Sets the aba_routing_number of this SimplePaymentFundingAccountRequest.

        The ABA/Routing number for the bank account.  # noqa: E501

        :param aba_routing_number: The aba_routing_number of this SimplePaymentFundingAccountRequest.  # noqa: E501
        :type: str
        """
        self._aba_routing_number = aba_routing_number

    @property
    def expiry_date(self):
        """Gets the expiry_date of this SimplePaymentFundingAccountRequest.  # noqa: E501

        The expiry date for the card. This is to be in the format MM/YY.  # noqa: E501

        :return: The expiry_date of this SimplePaymentFundingAccountRequest.  # noqa: E501
        :rtype: str
        """
        return self._expiry_date

    @expiry_date.setter
    def expiry_date(self, expiry_date):
        """Sets the expiry_date of this SimplePaymentFundingAccountRequest.

        The expiry date for the card. This is to be in the format MM/YY.  # noqa: E501

        :param expiry_date: The expiry_date of this SimplePaymentFundingAccountRequest.  # noqa: E501
        :type: str
        """
        self._expiry_date = expiry_date

    @property
    def account_holder_type(self):
        """Gets the account_holder_type of this SimplePaymentFundingAccountRequest.  # noqa: E501

        The type of ownership for the funding account.   # noqa: E501

        :return: The account_holder_type of this SimplePaymentFundingAccountRequest.  # noqa: E501
        :rtype: str
        """
        return self._account_holder_type

    @account_holder_type.setter
    def account_holder_type(self, account_holder_type):
        """Sets the account_holder_type of this SimplePaymentFundingAccountRequest.

        The type of ownership for the funding account.   # noqa: E501

        :param account_holder_type: The account_holder_type of this SimplePaymentFundingAccountRequest.  # noqa: E501
        :type: str
        """
        self._account_holder_type = account_holder_type

    @property
    def custom_fields(self):
        """Gets the custom_fields of this SimplePaymentFundingAccountRequest.  # noqa: E501

        The additional information or meta-information that EBPP can accept, maintain and transmit back to the client.  # noqa: E501

        :return: The custom_fields of this SimplePaymentFundingAccountRequest.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._custom_fields

    @custom_fields.setter
    def custom_fields(self, custom_fields):
        """Sets the custom_fields of this SimplePaymentFundingAccountRequest.

        The additional information or meta-information that EBPP can accept, maintain and transmit back to the client.  # noqa: E501

        :param custom_fields: The custom_fields of this SimplePaymentFundingAccountRequest.  # noqa: E501
        :type: dict(str, str)
        """
        self._custom_fields = custom_fields

    @property
    def account_subtype(self):
        """Gets the account_subtype of this SimplePaymentFundingAccountRequest.  # noqa: E501

        The sub type of the funding account.  # noqa: E501

        :return: The account_subtype of this SimplePaymentFundingAccountRequest.  # noqa: E501
        :rtype: str
        """
        return self._account_subtype

    @account_subtype.setter
    def account_subtype(self, account_subtype):
        """Sets the account_subtype of this SimplePaymentFundingAccountRequest.

        The sub type of the funding account.  # noqa: E501

        :param account_subtype: The account_subtype of this SimplePaymentFundingAccountRequest.  # noqa: E501
        :type: str
        """
        self._account_subtype = account_subtype

    @property
    def card_cvv_number(self):
        """Gets the card_cvv_number of this SimplePaymentFundingAccountRequest.  # noqa: E501


        :return: The card_cvv_number of this SimplePaymentFundingAccountRequest.  # noqa: E501
        :rtype: str
        """
        return self._card_cvv_number

    @card_cvv_number.setter
    def card_cvv_number(self, card_cvv_number):
        """Sets the card_cvv_number of this SimplePaymentFundingAccountRequest.


        :param card_cvv_number: The card_cvv_number of this SimplePaymentFundingAccountRequest.  # noqa: E501
        :type: str
        """
        self._card_cvv_number = card_cvv_number

    @property
    def device_manufacturer_id(self):
        """Gets the device_manufacturer_id of this SimplePaymentFundingAccountRequest.  # noqa: E501


        :return: The device_manufacturer_id of this SimplePaymentFundingAccountRequest.  # noqa: E501
        :rtype: str
        """
        return self._device_manufacturer_id

    @device_manufacturer_id.setter
    def device_manufacturer_id(self, device_manufacturer_id):
        """Sets the device_manufacturer_id of this SimplePaymentFundingAccountRequest.


        :param device_manufacturer_id: The device_manufacturer_id of this SimplePaymentFundingAccountRequest.  # noqa: E501
        :type: str
        """
        self._device_manufacturer_id = device_manufacturer_id

    @property
    def display_text(self):
        """Gets the display_text of this SimplePaymentFundingAccountRequest.  # noqa: E501

        UI representation of the account.  # noqa: E501

        :return: The display_text of this SimplePaymentFundingAccountRequest.  # noqa: E501
        :rtype: str
        """
        return self._display_text

    @display_text.setter
    def display_text(self, display_text):
        """Sets the display_text of this SimplePaymentFundingAccountRequest.

        UI representation of the account.  # noqa: E501

        :param display_text: The display_text of this SimplePaymentFundingAccountRequest.  # noqa: E501
        :type: str
        """
        self._display_text = display_text

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(SimplePaymentFundingAccountRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SimplePaymentFundingAccountRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
