# coding: utf-8

"""
    ############################################################################################
    ## This class subject to change without prior notice, Please dont use this class directly.##
    ############################################################################################
"""


import pprint
import re  # noqa: F401

import six

from orbipay_paymentsapi_client.models.fee_request import FeeRequest  # noqa: F401,E501
from orbipay_paymentsapi_client.models.simple_payment_customer_account_request import SimplePaymentCustomerAccountRequest  # noqa: F401,E501
from orbipay_paymentsapi_client.models.simple_payment_customer_request import SimplePaymentCustomerRequest  # noqa: F401,E501
from orbipay_paymentsapi_client.models.simple_payment_funding_account_request import SimplePaymentFundingAccountRequest  # noqa: F401,E501


class SimplePaymentRequest(object):
    """NOTE: 
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'amount': 'str',
        'card_cvv_number': 'str',
        'payment_date': 'str',
        'payment_request_date': 'str',
        'payment_amount_type': 'str',
        'fee': 'FeeRequest',
        'customer': 'SimplePaymentCustomerRequest',
        'funding_account': 'SimplePaymentFundingAccountRequest',
        'customer_account': 'SimplePaymentCustomerAccountRequest',
        'payment_reference': 'str',
        'payment_notification_email': 'str',
        'cryptogram': 'str',
        'eci': 'str',
        'comments': 'str',
        'custom_fields': 'dict(str, str)'
    }

    attribute_map = {
        'amount': 'amount',
        'card_cvv_number': 'card_cvv_number',
        'payment_date': 'payment_date',
        'payment_request_date': 'payment_request_date',
        'payment_amount_type': 'payment_amount_type',
        'fee': 'fee',
        'customer': 'customer',
        'funding_account': 'funding_account',
        'customer_account': 'customer_account',
        'payment_reference': 'payment_reference',
        'payment_notification_email': 'payment_notification_email',
        'cryptogram': 'cryptogram',
        'eci': 'eci',
        'comments': 'comments',
        'custom_fields': 'custom_fields'
    }

    def __init__(self, amount=None, card_cvv_number=None, payment_date=None, payment_request_date=None, payment_amount_type=None, fee=None, customer=None, funding_account=None, customer_account=None, payment_reference=None, payment_notification_email=None, cryptogram=None, eci=None, comments=None, custom_fields=None):  # noqa: E501
        """SimplePaymentRequest - a model defined in Swagger"""  # noqa: E501

        self._amount = None
        self._card_cvv_number = None
        self._payment_date = None
        self._payment_request_date = None
        self._payment_amount_type = None
        self._fee = None
        self._customer = None
        self._funding_account = None
        self._customer_account = None
        self._payment_reference = None
        self._payment_notification_email = None
        self._cryptogram = None
        self._eci = None
        self._comments = None
        self._custom_fields = None
        self.discriminator = None

        if amount is not None:
            self.amount = amount
        if card_cvv_number is not None:
            self.card_cvv_number = card_cvv_number
        if payment_date is not None:
            self.payment_date = payment_date
        if payment_request_date is not None:
            self.payment_request_date = payment_request_date
        self.payment_amount_type = payment_amount_type
        if fee is not None:
            self.fee = fee
        self.customer = customer
        self.funding_account = funding_account
        self.customer_account = customer_account
        if payment_reference is not None:
            self.payment_reference = payment_reference
        if payment_notification_email is not None:
            self.payment_notification_email = payment_notification_email
        if cryptogram is not None:
            self.cryptogram = cryptogram
        if eci is not None:
            self.eci = eci
        if comments is not None:
            self.comments = comments
        if custom_fields is not None:
            self.custom_fields = custom_fields

    def __getitem__(self,key):
        return getattr(self,key)

    @property
    def amount(self):
        """Gets the amount of this SimplePaymentRequest.  # noqa: E501

        The amount being paid.   # noqa: E501

        :return: The amount of this SimplePaymentRequest.  # noqa: E501
        :rtype: str
        """
        return self._amount

    @amount.setter
    def amount(self, amount):
        """Sets the amount of this SimplePaymentRequest.

        The amount being paid.   # noqa: E501

        :param amount: The amount of this SimplePaymentRequest.  # noqa: E501
        :type: str
        """
        self._amount = amount

    @property
    def card_cvv_number(self):
        """Gets the card_cvv_number of this SimplePaymentRequest.  # noqa: E501


        :return: The card_cvv_number of this SimplePaymentRequest.  # noqa: E501
        :rtype: str
        """
        return self._card_cvv_number

    @card_cvv_number.setter
    def card_cvv_number(self, card_cvv_number):
        """Sets the card_cvv_number of this SimplePaymentRequest.


        :param card_cvv_number: The card_cvv_number of this SimplePaymentRequest.  # noqa: E501
        :type: str
        """
        self._card_cvv_number = card_cvv_number

    @property
    def payment_date(self):
        """Gets the payment_date of this SimplePaymentRequest.  # noqa: E501

        The date on which the payment is scheduled to be made. It must be in ISO8601 full-date format, namely, YYYY-MM-DD.  # noqa: E501

        :return: The payment_date of this SimplePaymentRequest.  # noqa: E501
        :rtype: str
        """
        return self._payment_date

    @payment_date.setter
    def payment_date(self, payment_date):
        """Sets the payment_date of this SimplePaymentRequest.

        The date on which the payment is scheduled to be made. It must be in ISO8601 full-date format, namely, YYYY-MM-DD.  # noqa: E501

        :param payment_date: The payment_date of this SimplePaymentRequest.  # noqa: E501
        :type: str
        """
        self._payment_date = payment_date

    @property
    def payment_request_date(self):
        """Gets the payment_request_date of this SimplePaymentRequest.  # noqa: E501

        The date on which the biller wants the payment to be settled. It must be in ISO8601 full-date format, namely, YYYY-MM-DD.   # noqa: E501

        :return: The payment_request_date of this SimplePaymentRequest.  # noqa: E501
        :rtype: str
        """
        return self._payment_request_date

    @payment_request_date.setter
    def payment_request_date(self, payment_request_date):
        """Sets the payment_request_date of this SimplePaymentRequest.

        The date on which the biller wants the payment to be settled. It must be in ISO8601 full-date format, namely, YYYY-MM-DD.   # noqa: E501

        :param payment_request_date: The payment_request_date of this SimplePaymentRequest.  # noqa: E501
        :type: str
        """
        self._payment_request_date = payment_request_date

    @property
    def payment_amount_type(self):
        """Gets the payment_amount_type of this SimplePaymentRequest.  # noqa: E501

        The type of amount, as per the bill/statement, that is being paid. The payment amount is derived from the amount type selected for the payment.  # noqa: E501

        :return: The payment_amount_type of this SimplePaymentRequest.  # noqa: E501
        :rtype: str
        """
        return self._payment_amount_type

    @payment_amount_type.setter
    def payment_amount_type(self, payment_amount_type):
        """Sets the payment_amount_type of this SimplePaymentRequest.

        The type of amount, as per the bill/statement, that is being paid. The payment amount is derived from the amount type selected for the payment.  # noqa: E501

        :param payment_amount_type: The payment_amount_type of this SimplePaymentRequest.  # noqa: E501
        :type: str
        """
        self._payment_amount_type = payment_amount_type

    @property
    def fee(self):
        """Gets the fee of this SimplePaymentRequest.  # noqa: E501


        :return: The fee of this SimplePaymentRequest.  # noqa: E501
        :rtype: FeeRequest
        """
        return self._fee

    @fee.setter
    def fee(self, fee):
        """Sets the fee of this SimplePaymentRequest.


        :param fee: The fee of this SimplePaymentRequest.  # noqa: E501
        :type: FeeRequest
        """
        self._fee = fee

    @property
    def customer(self):
        """Gets the customer of this SimplePaymentRequest.  # noqa: E501


        :return: The customer of this SimplePaymentRequest.  # noqa: E501
        :rtype: SimplePaymentCustomerRequest
        """
        return self._customer

    @customer.setter
    def customer(self, customer):
        """Sets the customer of this SimplePaymentRequest.


        :param customer: The customer of this SimplePaymentRequest.  # noqa: E501
        :type: SimplePaymentCustomerRequest
        """
        self._customer = customer

    @property
    def funding_account(self):
        """Gets the funding_account of this SimplePaymentRequest.  # noqa: E501


        :return: The funding_account of this SimplePaymentRequest.  # noqa: E501
        :rtype: SimplePaymentFundingAccountRequest
        """
        return self._funding_account

    @funding_account.setter
    def funding_account(self, funding_account):
        """Sets the funding_account of this SimplePaymentRequest.


        :param funding_account: The funding_account of this SimplePaymentRequest.  # noqa: E501
        :type: SimplePaymentFundingAccountRequest
        """
        self._funding_account = funding_account

    @property
    def customer_account(self):
        """Gets the customer_account of this SimplePaymentRequest.  # noqa: E501


        :return: The customer_account of this SimplePaymentRequest.  # noqa: E501
        :rtype: SimplePaymentCustomerAccountRequest
        """
        return self._customer_account

    @customer_account.setter
    def customer_account(self, customer_account):
        """Sets the customer_account of this SimplePaymentRequest.


        :param customer_account: The customer_account of this SimplePaymentRequest.  # noqa: E501
        :type: SimplePaymentCustomerAccountRequest
        """
        self._customer_account = customer_account

    @property
    def payment_reference(self):
        """Gets the payment_reference of this SimplePaymentRequest.  # noqa: E501

        The unique identifier in the client system for the payment.  # noqa: E501

        :return: The payment_reference of this SimplePaymentRequest.  # noqa: E501
        :rtype: str
        """
        return self._payment_reference

    @payment_reference.setter
    def payment_reference(self, payment_reference):
        """Sets the payment_reference of this SimplePaymentRequest.

        The unique identifier in the client system for the payment.  # noqa: E501

        :param payment_reference: The payment_reference of this SimplePaymentRequest.  # noqa: E501
        :type: str
        """
        self._payment_reference = payment_reference

    @property
    def payment_notification_email(self):
        """Gets the payment_notification_email of this SimplePaymentRequest.  # noqa: E501

        The email address to which notifications for the payment will be sent.  # noqa: E501

        :return: The payment_notification_email of this SimplePaymentRequest.  # noqa: E501
        :rtype: str
        """
        return self._payment_notification_email

    @payment_notification_email.setter
    def payment_notification_email(self, payment_notification_email):
        """Sets the payment_notification_email of this SimplePaymentRequest.

        The email address to which notifications for the payment will be sent.  # noqa: E501

        :param payment_notification_email: The payment_notification_email of this SimplePaymentRequest.  # noqa: E501
        :type: str
        """
        self._payment_notification_email = payment_notification_email

    @property
    def cryptogram(self):
        """Gets the cryptogram of this SimplePaymentRequest.  # noqa: E501

        Online Payment Cryptogram, as defined by 3-D secure.  # noqa: E501

        :return: The cryptogram of this SimplePaymentRequest.  # noqa: E501
        :rtype: str
        """
        return self._cryptogram

    @cryptogram.setter
    def cryptogram(self, cryptogram):
        """Sets the cryptogram of this SimplePaymentRequest.

        Online Payment Cryptogram, as defined by 3-D secure.  # noqa: E501

        :param cryptogram: The cryptogram of this SimplePaymentRequest.  # noqa: E501
        :type: str
        """
        self._cryptogram = cryptogram

    @property
    def eci(self):
        """Gets the eci of this SimplePaymentRequest.  # noqa: E501

        ECI Indicator, as defined by 3-D secure. The card network may add an ECI indicator to the card data.  # noqa: E501

        :return: The eci of this SimplePaymentRequest.  # noqa: E501
        :rtype: str
        """
        return self._eci

    @eci.setter
    def eci(self, eci):
        """Sets the eci of this SimplePaymentRequest.

        ECI Indicator, as defined by 3-D secure. The card network may add an ECI indicator to the card data.  # noqa: E501

        :param eci: The eci of this SimplePaymentRequest.  # noqa: E501
        :type: str
        """
        self._eci = eci

    @property
    def comments(self):
        """Gets the comments of this SimplePaymentRequest.  # noqa: E501

        Comments that can be used to recollect the operation performed on the resource object.  # noqa: E501

        :return: The comments of this SimplePaymentRequest.  # noqa: E501
        :rtype: str
        """
        return self._comments

    @comments.setter
    def comments(self, comments):
        """Sets the comments of this SimplePaymentRequest.

        Comments that can be used to recollect the operation performed on the resource object.  # noqa: E501

        :param comments: The comments of this SimplePaymentRequest.  # noqa: E501
        :type: str
        """
        self._comments = comments

    @property
    def custom_fields(self):
        """Gets the custom_fields of this SimplePaymentRequest.  # noqa: E501

        The additional information or meta-information that EBPP can accept, maintain and transmit back to the client.  # noqa: E501

        :return: The custom_fields of this SimplePaymentRequest.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._custom_fields

    @custom_fields.setter
    def custom_fields(self, custom_fields):
        """Sets the custom_fields of this SimplePaymentRequest.

        The additional information or meta-information that EBPP can accept, maintain and transmit back to the client.  # noqa: E501

        :param custom_fields: The custom_fields of this SimplePaymentRequest.  # noqa: E501
        :type: dict(str, str)
        """
        self._custom_fields = custom_fields

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(SimplePaymentRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SimplePaymentRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
