# coding: utf-8

"""
    ############################################################################################
    ## This class subject to change without prior notice, Please dont use this class directly.##
    ############################################################################################
"""


import pprint
import re  # noqa: F401

import six

from orbipay_paymentsapi_client.models.audit_info_vo import AuditInfoVo  # noqa: F401,E501
from orbipay_paymentsapi_client.models.customer_account_response import CustomerAccountResponse  # noqa: F401,E501
from orbipay_paymentsapi_client.models.fee_response import FeeResponse  # noqa: F401,E501
from orbipay_paymentsapi_client.models.funding_account_response import FundingAccountResponse  # noqa: F401,E501
from orbipay_paymentsapi_client.models.payment_network_response_vo import PaymentNetworkResponseVo  # noqa: F401,E501
from orbipay_paymentsapi_client.models.simple_payment_customer_response import SimplePaymentCustomerResponse  # noqa: F401,E501


class SimplePaymentResponse(object):
    """NOTE: 
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'url': 'str',
        'fee': 'FeeResponse',
        'status': 'str',
        'payment_method': 'str',
        'confirmation_number': 'str',
        'custom_fields': 'dict(str, str)',
        'currency_code3d': 'str',
        'amount': 'str',
        'card_cvv_number': 'str',
        'payment_date': 'str',
        'payment_schedule_type': 'str',
        'payment_request_date': 'str',
        'payment_amount_type': 'str',
        'payment_reference': 'str',
        'expected_payment_settlement_date': 'str',
        'payment_entry_date': 'str',
        'payment_return_date': 'str',
        'return_code': 'str',
        'payment_notification_email': 'str',
        'comments': 'str',
        'customer': 'SimplePaymentCustomerResponse',
        'funding_account': 'FundingAccountResponse',
        'customer_account': 'CustomerAccountResponse',
        'payment_network_response': 'PaymentNetworkResponseVo',
        'audit_info': 'AuditInfoVo'
    }

    attribute_map = {
        'id': 'id',
        'url': 'url',
        'fee': 'fee',
        'status': 'status',
        'payment_method': 'payment_method',
        'confirmation_number': 'confirmation_number',
        'custom_fields': 'custom_fields',
        'currency_code3d': 'currency_code3d',
        'amount': 'amount',
        'card_cvv_number': 'card_cvv_number',
        'payment_date': 'payment_date',
        'payment_schedule_type': 'payment_schedule_type',
        'payment_request_date': 'payment_request_date',
        'payment_amount_type': 'payment_amount_type',
        'payment_reference': 'payment_reference',
        'expected_payment_settlement_date': 'expected_payment_settlement_date',
        'payment_entry_date': 'payment_entry_date',
        'payment_return_date': 'payment_return_date',
        'return_code': 'return_code',
        'payment_notification_email': 'payment_notification_email',
        'comments': 'comments',
        'customer': 'customer',
        'funding_account': 'funding_account',
        'customer_account': 'customer_account',
        'payment_network_response': 'payment_network_response',
        'audit_info': 'audit_info'
    }

    def __init__(self, id=None, url=None, fee=None, status=None, payment_method=None, confirmation_number=None, custom_fields=None, currency_code3d=None, amount=None, card_cvv_number=None, payment_date=None, payment_schedule_type=None, payment_request_date=None, payment_amount_type=None, payment_reference=None, expected_payment_settlement_date=None, payment_entry_date=None, payment_return_date=None, return_code=None, payment_notification_email=None, comments=None, customer=None, funding_account=None, customer_account=None, payment_network_response=None, audit_info=None):  # noqa: E501
        """SimplePaymentResponse - a model defined in Swagger"""  # noqa: E501

        self._id = None
        self._url = None
        self._fee = None
        self._status = None
        self._payment_method = None
        self._confirmation_number = None
        self._custom_fields = None
        self._currency_code3d = None
        self._amount = None
        self._card_cvv_number = None
        self._payment_date = None
        self._payment_schedule_type = None
        self._payment_request_date = None
        self._payment_amount_type = None
        self._payment_reference = None
        self._expected_payment_settlement_date = None
        self._payment_entry_date = None
        self._payment_return_date = None
        self._return_code = None
        self._payment_notification_email = None
        self._comments = None
        self._customer = None
        self._funding_account = None
        self._customer_account = None
        self._payment_network_response = None
        self._audit_info = None
        self.discriminator = None

        if id is not None:
            self.id = id
        if url is not None:
            self.url = url
        if fee is not None:
            self.fee = fee
        if status is not None:
            self.status = status
        if payment_method is not None:
            self.payment_method = payment_method
        if confirmation_number is not None:
            self.confirmation_number = confirmation_number
        if custom_fields is not None:
            self.custom_fields = custom_fields
        if currency_code3d is not None:
            self.currency_code3d = currency_code3d
        if amount is not None:
            self.amount = amount
        if card_cvv_number is not None:
            self.card_cvv_number = card_cvv_number
        if payment_date is not None:
            self.payment_date = payment_date
        if payment_schedule_type is not None:
            self.payment_schedule_type = payment_schedule_type
        if payment_request_date is not None:
            self.payment_request_date = payment_request_date
        if payment_amount_type is not None:
            self.payment_amount_type = payment_amount_type
        if payment_reference is not None:
            self.payment_reference = payment_reference
        if expected_payment_settlement_date is not None:
            self.expected_payment_settlement_date = expected_payment_settlement_date
        if payment_entry_date is not None:
            self.payment_entry_date = payment_entry_date
        if payment_return_date is not None:
            self.payment_return_date = payment_return_date
        if return_code is not None:
            self.return_code = return_code
        if payment_notification_email is not None:
            self.payment_notification_email = payment_notification_email
        if comments is not None:
            self.comments = comments
        if customer is not None:
            self.customer = customer
        if funding_account is not None:
            self.funding_account = funding_account
        if customer_account is not None:
            self.customer_account = customer_account
        if payment_network_response is not None:
            self.payment_network_response = payment_network_response
        if audit_info is not None:
            self.audit_info = audit_info

    def __getitem__(self,key):
        return getattr(self,key)

    @property
    def id(self):
        """Gets the id of this SimplePaymentResponse.  # noqa: E501

        The unique identifier assigned by EBPP to the payment.  # noqa: E501

        :return: The id of this SimplePaymentResponse.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this SimplePaymentResponse.

        The unique identifier assigned by EBPP to the payment.  # noqa: E501

        :param id: The id of this SimplePaymentResponse.  # noqa: E501
        :type: str
        """
        self._id = id

    @property
    def url(self):
        """Gets the url of this SimplePaymentResponse.  # noqa: E501

        This URL fetches the details of payment.  # noqa: E501

        :return: The url of this SimplePaymentResponse.  # noqa: E501
        :rtype: str
        """
        return self._url

    @url.setter
    def url(self, url):
        """Sets the url of this SimplePaymentResponse.

        This URL fetches the details of payment.  # noqa: E501

        :param url: The url of this SimplePaymentResponse.  # noqa: E501
        :type: str
        """
        self._url = url

    @property
    def fee(self):
        """Gets the fee of this SimplePaymentResponse.  # noqa: E501


        :return: The fee of this SimplePaymentResponse.  # noqa: E501
        :rtype: FeeResponse
        """
        return self._fee

    @fee.setter
    def fee(self, fee):
        """Sets the fee of this SimplePaymentResponse.


        :param fee: The fee of this SimplePaymentResponse.  # noqa: E501
        :type: FeeResponse
        """
        self._fee = fee

    @property
    def status(self):
        """Gets the status of this SimplePaymentResponse.  # noqa: E501

        The status of the payment.  # noqa: E501

        :return: The status of this SimplePaymentResponse.  # noqa: E501
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this SimplePaymentResponse.

        The status of the payment.  # noqa: E501

        :param status: The status of this SimplePaymentResponse.  # noqa: E501
        :type: str
        """
        self._status = status

    @property
    def payment_method(self):
        """Gets the payment_method of this SimplePaymentResponse.  # noqa: E501

        The fulfillment method for the payment.  # noqa: E501

        :return: The payment_method of this SimplePaymentResponse.  # noqa: E501
        :rtype: str
        """
        return self._payment_method

    @payment_method.setter
    def payment_method(self, payment_method):
        """Sets the payment_method of this SimplePaymentResponse.

        The fulfillment method for the payment.  # noqa: E501

        :param payment_method: The payment_method of this SimplePaymentResponse.  # noqa: E501
        :type: str
        """
        self._payment_method = payment_method

    @property
    def confirmation_number(self):
        """Gets the confirmation_number of this SimplePaymentResponse.  # noqa: E501

        The confirmation number or reference provided to the customer for the payment.  # noqa: E501

        :return: The confirmation_number of this SimplePaymentResponse.  # noqa: E501
        :rtype: str
        """
        return self._confirmation_number

    @confirmation_number.setter
    def confirmation_number(self, confirmation_number):
        """Sets the confirmation_number of this SimplePaymentResponse.

        The confirmation number or reference provided to the customer for the payment.  # noqa: E501

        :param confirmation_number: The confirmation_number of this SimplePaymentResponse.  # noqa: E501
        :type: str
        """
        self._confirmation_number = confirmation_number

    @property
    def custom_fields(self):
        """Gets the custom_fields of this SimplePaymentResponse.  # noqa: E501

        The additional information or meta-information that EBPP can accept, maintain and transmit back to the client. The custom fields need to be configured with EBPP before they can be accepted. EBPP would reject custom fields that are not pre-configured. Please contact <a href = \"mailto: support@billerpayments.com\">support@billerpayments.com</a> for more information on configuring and using custom fields.  # noqa: E501

        :return: The custom_fields of this SimplePaymentResponse.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._custom_fields

    @custom_fields.setter
    def custom_fields(self, custom_fields):
        """Sets the custom_fields of this SimplePaymentResponse.

        The additional information or meta-information that EBPP can accept, maintain and transmit back to the client. The custom fields need to be configured with EBPP before they can be accepted. EBPP would reject custom fields that are not pre-configured. Please contact <a href = \"mailto: support@billerpayments.com\">support@billerpayments.com</a> for more information on configuring and using custom fields.  # noqa: E501

        :param custom_fields: The custom_fields of this SimplePaymentResponse.  # noqa: E501
        :type: dict(str, str)
        """
        self._custom_fields = custom_fields

    @property
    def currency_code3d(self):
        """Gets the currency_code3d of this SimplePaymentResponse.  # noqa: E501

        The three-letter currency code in the ISO4217 format, in uppercase, for the card account. It must be a currency supported by EBPP. This defaults to USD.  # noqa: E501

        :return: The currency_code3d of this SimplePaymentResponse.  # noqa: E501
        :rtype: str
        """
        return self._currency_code3d

    @currency_code3d.setter
    def currency_code3d(self, currency_code3d):
        """Sets the currency_code3d of this SimplePaymentResponse.

        The three-letter currency code in the ISO4217 format, in uppercase, for the card account. It must be a currency supported by EBPP. This defaults to USD.  # noqa: E501

        :param currency_code3d: The currency_code3d of this SimplePaymentResponse.  # noqa: E501
        :type: str
        """
        self._currency_code3d = currency_code3d

    @property
    def amount(self):
        """Gets the amount of this SimplePaymentResponse.  # noqa: E501

        The amount being paid. In case the payment_amount_type is 'discounted_amount', 'penalty_amount' or 'other', the amount needs to be specified. In other cases, this is derived from the payment_amount_type.  # noqa: E501

        :return: The amount of this SimplePaymentResponse.  # noqa: E501
        :rtype: str
        """
        return self._amount

    @amount.setter
    def amount(self, amount):
        """Sets the amount of this SimplePaymentResponse.

        The amount being paid. In case the payment_amount_type is 'discounted_amount', 'penalty_amount' or 'other', the amount needs to be specified. In other cases, this is derived from the payment_amount_type.  # noqa: E501

        :param amount: The amount of this SimplePaymentResponse.  # noqa: E501
        :type: str
        """
        self._amount = amount

    @property
    def card_cvv_number(self):
        """Gets the card_cvv_number of this SimplePaymentResponse.  # noqa: E501

        This is never returned by EBPP. This needs to be passed to EBPP when making or editing a payment with a card funding account.  # noqa: E501

        :return: The card_cvv_number of this SimplePaymentResponse.  # noqa: E501
        :rtype: str
        """
        return self._card_cvv_number

    @card_cvv_number.setter
    def card_cvv_number(self, card_cvv_number):
        """Sets the card_cvv_number of this SimplePaymentResponse.

        This is never returned by EBPP. This needs to be passed to EBPP when making or editing a payment with a card funding account.  # noqa: E501

        :param card_cvv_number: The card_cvv_number of this SimplePaymentResponse.  # noqa: E501
        :type: str
        """
        self._card_cvv_number = card_cvv_number

    @property
    def payment_date(self):
        """Gets the payment_date of this SimplePaymentResponse.  # noqa: E501

        The date on which the payment is scheduled to be made. It must be in ISO8601 full-date format, namely, YYYY-MM-DD.  # noqa: E501

        :return: The payment_date of this SimplePaymentResponse.  # noqa: E501
        :rtype: str
        """
        return self._payment_date

    @payment_date.setter
    def payment_date(self, payment_date):
        """Sets the payment_date of this SimplePaymentResponse.

        The date on which the payment is scheduled to be made. It must be in ISO8601 full-date format, namely, YYYY-MM-DD.  # noqa: E501

        :param payment_date: The payment_date of this SimplePaymentResponse.  # noqa: E501
        :type: str
        """
        self._payment_date = payment_date

    @property
    def payment_schedule_type(self):
        """Gets the payment_schedule_type of this SimplePaymentResponse.  # noqa: E501

        The schedule type for the payment. This defaults to one_time_payment.  # noqa: E501

        :return: The payment_schedule_type of this SimplePaymentResponse.  # noqa: E501
        :rtype: str
        """
        return self._payment_schedule_type

    @payment_schedule_type.setter
    def payment_schedule_type(self, payment_schedule_type):
        """Sets the payment_schedule_type of this SimplePaymentResponse.

        The schedule type for the payment. This defaults to one_time_payment.  # noqa: E501

        :param payment_schedule_type: The payment_schedule_type of this SimplePaymentResponse.  # noqa: E501
        :type: str
        """
        self._payment_schedule_type = payment_schedule_type

    @property
    def payment_request_date(self):
        """Gets the payment_request_date of this SimplePaymentResponse.  # noqa: E501

        The date on which the biller wants the payment to be settled. It must be in ISO8601 full-date format, namely, YYYY-MM-DD. This is applicable only if the client has opted for it.  # noqa: E501

        :return: The payment_request_date of this SimplePaymentResponse.  # noqa: E501
        :rtype: str
        """
        return self._payment_request_date

    @payment_request_date.setter
    def payment_request_date(self, payment_request_date):
        """Sets the payment_request_date of this SimplePaymentResponse.

        The date on which the biller wants the payment to be settled. It must be in ISO8601 full-date format, namely, YYYY-MM-DD. This is applicable only if the client has opted for it.  # noqa: E501

        :param payment_request_date: The payment_request_date of this SimplePaymentResponse.  # noqa: E501
        :type: str
        """
        self._payment_request_date = payment_request_date

    @property
    def payment_amount_type(self):
        """Gets the payment_amount_type of this SimplePaymentResponse.  # noqa: E501

        The type of amount, as per the bill/statement, that is being paid. The payment amount is derived from the amount type selected for the payment. This defaults to other.  # noqa: E501

        :return: The payment_amount_type of this SimplePaymentResponse.  # noqa: E501
        :rtype: str
        """
        return self._payment_amount_type

    @payment_amount_type.setter
    def payment_amount_type(self, payment_amount_type):
        """Sets the payment_amount_type of this SimplePaymentResponse.

        The type of amount, as per the bill/statement, that is being paid. The payment amount is derived from the amount type selected for the payment. This defaults to other.  # noqa: E501

        :param payment_amount_type: The payment_amount_type of this SimplePaymentResponse.  # noqa: E501
        :type: str
        """
        self._payment_amount_type = payment_amount_type

    @property
    def payment_reference(self):
        """Gets the payment_reference of this SimplePaymentResponse.  # noqa: E501

        The unique identifier in the client system for the payment.  # noqa: E501

        :return: The payment_reference of this SimplePaymentResponse.  # noqa: E501
        :rtype: str
        """
        return self._payment_reference

    @payment_reference.setter
    def payment_reference(self, payment_reference):
        """Sets the payment_reference of this SimplePaymentResponse.

        The unique identifier in the client system for the payment.  # noqa: E501

        :param payment_reference: The payment_reference of this SimplePaymentResponse.  # noqa: E501
        :type: str
        """
        self._payment_reference = payment_reference

    @property
    def expected_payment_settlement_date(self):
        """Gets the expected_payment_settlement_date of this SimplePaymentResponse.  # noqa: E501

        The date on which the payment is expected to be settled with the biller. It must be in ISO8601 full-date format, namely, YYYY-MM-DD.  # noqa: E501

        :return: The expected_payment_settlement_date of this SimplePaymentResponse.  # noqa: E501
        :rtype: str
        """
        return self._expected_payment_settlement_date

    @expected_payment_settlement_date.setter
    def expected_payment_settlement_date(self, expected_payment_settlement_date):
        """Sets the expected_payment_settlement_date of this SimplePaymentResponse.

        The date on which the payment is expected to be settled with the biller. It must be in ISO8601 full-date format, namely, YYYY-MM-DD.  # noqa: E501

        :param expected_payment_settlement_date: The expected_payment_settlement_date of this SimplePaymentResponse.  # noqa: E501
        :type: str
        """
        self._expected_payment_settlement_date = expected_payment_settlement_date

    @property
    def payment_entry_date(self):
        """Gets the payment_entry_date of this SimplePaymentResponse.  # noqa: E501

        The date on which the payment is captured in EBPP. It must be in ISO8601 full-date format, namely, YYYY-MM-DD.  # noqa: E501

        :return: The payment_entry_date of this SimplePaymentResponse.  # noqa: E501
        :rtype: str
        """
        return self._payment_entry_date

    @payment_entry_date.setter
    def payment_entry_date(self, payment_entry_date):
        """Sets the payment_entry_date of this SimplePaymentResponse.

        The date on which the payment is captured in EBPP. It must be in ISO8601 full-date format, namely, YYYY-MM-DD.  # noqa: E501

        :param payment_entry_date: The payment_entry_date of this SimplePaymentResponse.  # noqa: E501
        :type: str
        """
        self._payment_entry_date = payment_entry_date

    @property
    def payment_return_date(self):
        """Gets the payment_return_date of this SimplePaymentResponse.  # noqa: E501

        The date on which the ACH returns is received by EBPP.  # noqa: E501

        :return: The payment_return_date of this SimplePaymentResponse.  # noqa: E501
        :rtype: str
        """
        return self._payment_return_date

    @payment_return_date.setter
    def payment_return_date(self, payment_return_date):
        """Sets the payment_return_date of this SimplePaymentResponse.

        The date on which the ACH returns is received by EBPP.  # noqa: E501

        :param payment_return_date: The payment_return_date of this SimplePaymentResponse.  # noqa: E501
        :type: str
        """
        self._payment_return_date = payment_return_date

    @property
    def return_code(self):
        """Gets the return_code of this SimplePaymentResponse.  # noqa: E501

        The ACH return code or the chargeback code received from Visa/Mastercard, in the event of returned payments.  # noqa: E501

        :return: The return_code of this SimplePaymentResponse.  # noqa: E501
        :rtype: str
        """
        return self._return_code

    @return_code.setter
    def return_code(self, return_code):
        """Sets the return_code of this SimplePaymentResponse.

        The ACH return code or the chargeback code received from Visa/Mastercard, in the event of returned payments.  # noqa: E501

        :param return_code: The return_code of this SimplePaymentResponse.  # noqa: E501
        :type: str
        """
        self._return_code = return_code

    @property
    def payment_notification_email(self):
        """Gets the payment_notification_email of this SimplePaymentResponse.  # noqa: E501

        The email address to which notifications for the payment will be sent. The notifications will be sent to the customer's email in case this is not provided.  # noqa: E501

        :return: The payment_notification_email of this SimplePaymentResponse.  # noqa: E501
        :rtype: str
        """
        return self._payment_notification_email

    @payment_notification_email.setter
    def payment_notification_email(self, payment_notification_email):
        """Sets the payment_notification_email of this SimplePaymentResponse.

        The email address to which notifications for the payment will be sent. The notifications will be sent to the customer's email in case this is not provided.  # noqa: E501

        :param payment_notification_email: The payment_notification_email of this SimplePaymentResponse.  # noqa: E501
        :type: str
        """
        self._payment_notification_email = payment_notification_email

    @property
    def comments(self):
        """Gets the comments of this SimplePaymentResponse.  # noqa: E501

        Comments that can be used to recollect the operation performed on the resource object. API clients need to ensure that no sensitive information is passed in the memo. Alacriti (EBPP) is not responsible for the security of any sensitive information that may be passed as part of the memo.  # noqa: E501

        :return: The comments of this SimplePaymentResponse.  # noqa: E501
        :rtype: str
        """
        return self._comments

    @comments.setter
    def comments(self, comments):
        """Sets the comments of this SimplePaymentResponse.

        Comments that can be used to recollect the operation performed on the resource object. API clients need to ensure that no sensitive information is passed in the memo. Alacriti (EBPP) is not responsible for the security of any sensitive information that may be passed as part of the memo.  # noqa: E501

        :param comments: The comments of this SimplePaymentResponse.  # noqa: E501
        :type: str
        """
        self._comments = comments

    @property
    def customer(self):
        """Gets the customer of this SimplePaymentResponse.  # noqa: E501


        :return: The customer of this SimplePaymentResponse.  # noqa: E501
        :rtype: SimplePaymentCustomerResponse
        """
        return self._customer

    @customer.setter
    def customer(self, customer):
        """Sets the customer of this SimplePaymentResponse.


        :param customer: The customer of this SimplePaymentResponse.  # noqa: E501
        :type: SimplePaymentCustomerResponse
        """
        self._customer = customer

    @property
    def funding_account(self):
        """Gets the funding_account of this SimplePaymentResponse.  # noqa: E501


        :return: The funding_account of this SimplePaymentResponse.  # noqa: E501
        :rtype: FundingAccountResponse
        """
        return self._funding_account

    @funding_account.setter
    def funding_account(self, funding_account):
        """Sets the funding_account of this SimplePaymentResponse.


        :param funding_account: The funding_account of this SimplePaymentResponse.  # noqa: E501
        :type: FundingAccountResponse
        """
        self._funding_account = funding_account

    @property
    def customer_account(self):
        """Gets the customer_account of this SimplePaymentResponse.  # noqa: E501


        :return: The customer_account of this SimplePaymentResponse.  # noqa: E501
        :rtype: CustomerAccountResponse
        """
        return self._customer_account

    @customer_account.setter
    def customer_account(self, customer_account):
        """Sets the customer_account of this SimplePaymentResponse.


        :param customer_account: The customer_account of this SimplePaymentResponse.  # noqa: E501
        :type: CustomerAccountResponse
        """
        self._customer_account = customer_account

    @property
    def payment_network_response(self):
        """Gets the payment_network_response of this SimplePaymentResponse.  # noqa: E501


        :return: The payment_network_response of this SimplePaymentResponse.  # noqa: E501
        :rtype: PaymentNetworkResponseVo
        """
        return self._payment_network_response

    @payment_network_response.setter
    def payment_network_response(self, payment_network_response):
        """Sets the payment_network_response of this SimplePaymentResponse.


        :param payment_network_response: The payment_network_response of this SimplePaymentResponse.  # noqa: E501
        :type: PaymentNetworkResponseVo
        """
        self._payment_network_response = payment_network_response

    @property
    def audit_info(self):
        """Gets the audit_info of this SimplePaymentResponse.  # noqa: E501


        :return: The audit_info of this SimplePaymentResponse.  # noqa: E501
        :rtype: AuditInfoVo
        """
        return self._audit_info

    @audit_info.setter
    def audit_info(self, audit_info):
        """Sets the audit_info of this SimplePaymentResponse.


        :param audit_info: The audit_info of this SimplePaymentResponse.  # noqa: E501
        :type: AuditInfoVo
        """
        self._audit_info = audit_info

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(SimplePaymentResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SimplePaymentResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
