# coding: utf-8

"""
    ############################################################################################
    ## This class subject to change without prior notice, Please dont use this class directly.##
    ############################################################################################
"""


import pprint
import re  # noqa: F401

import six

from orbipay_paymentsapi_client.models.funding_account_snapshot_response import FundingAccountSnapshotResponse  # noqa: F401,E501
from orbipay_paymentsapi_client.models.source_payment_customer import SourcePaymentCustomer  # noqa: F401,E501
from orbipay_paymentsapi_client.models.source_payment_customer_account import SourcePaymentCustomerAccount  # noqa: F401,E501


class SourcePayment(object):
    """NOTE: 
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'url': 'str',
        'customer': 'SourcePaymentCustomer',
        'customer_account': 'SourcePaymentCustomerAccount',
        'funding_account': 'FundingAccountSnapshotResponse'
    }

    attribute_map = {
        'id': 'id',
        'url': 'url',
        'customer': 'customer',
        'customer_account': 'customer_account',
        'funding_account': 'funding_account'
    }

    def __init__(self, id=None, url=None, customer=None, customer_account=None, funding_account=None):  # noqa: E501
        """SourcePayment - a model defined in Swagger"""  # noqa: E501

        self._id = None
        self._url = None
        self._customer = None
        self._customer_account = None
        self._funding_account = None
        self.discriminator = None

        if id is not None:
            self.id = id
        if url is not None:
            self.url = url
        if customer is not None:
            self.customer = customer
        if customer_account is not None:
            self.customer_account = customer_account
        if funding_account is not None:
            self.funding_account = funding_account

    def __getitem__(self,key):
        return getattr(self,key)

    @property
    def id(self):
        """Gets the id of this SourcePayment.  # noqa: E501


        :return: The id of this SourcePayment.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this SourcePayment.


        :param id: The id of this SourcePayment.  # noqa: E501
        :type: str
        """
        self._id = id

    @property
    def url(self):
        """Gets the url of this SourcePayment.  # noqa: E501

        This URL fetches the details of source payment.  # noqa: E501

        :return: The url of this SourcePayment.  # noqa: E501
        :rtype: str
        """
        return self._url

    @url.setter
    def url(self, url):
        """Sets the url of this SourcePayment.

        This URL fetches the details of source payment.  # noqa: E501

        :param url: The url of this SourcePayment.  # noqa: E501
        :type: str
        """
        self._url = url

    @property
    def customer(self):
        """Gets the customer of this SourcePayment.  # noqa: E501


        :return: The customer of this SourcePayment.  # noqa: E501
        :rtype: SourcePaymentCustomer
        """
        return self._customer

    @customer.setter
    def customer(self, customer):
        """Sets the customer of this SourcePayment.


        :param customer: The customer of this SourcePayment.  # noqa: E501
        :type: SourcePaymentCustomer
        """
        self._customer = customer

    @property
    def customer_account(self):
        """Gets the customer_account of this SourcePayment.  # noqa: E501


        :return: The customer_account of this SourcePayment.  # noqa: E501
        :rtype: SourcePaymentCustomerAccount
        """
        return self._customer_account

    @customer_account.setter
    def customer_account(self, customer_account):
        """Sets the customer_account of this SourcePayment.


        :param customer_account: The customer_account of this SourcePayment.  # noqa: E501
        :type: SourcePaymentCustomerAccount
        """
        self._customer_account = customer_account

    @property
    def funding_account(self):
        """Gets the funding_account of this SourcePayment.  # noqa: E501


        :return: The funding_account of this SourcePayment.  # noqa: E501
        :rtype: FundingAccountSnapshotResponse
        """
        return self._funding_account

    @funding_account.setter
    def funding_account(self, funding_account):
        """Sets the funding_account of this SourcePayment.


        :param funding_account: The funding_account of this SourcePayment.  # noqa: E501
        :type: FundingAccountSnapshotResponse
        """
        self._funding_account = funding_account

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(SourcePayment, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SourcePayment):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
