# coding: utf-8

"""
    ############################################################################################
    ## This class subject to change without prior notice, Please dont use this class directly.##
    ############################################################################################
"""


import pprint
import re  # noqa: F401

import six

from orbipay_paymentsapi_client.models.fee_request import FeeRequest  # noqa: F401,E501
from orbipay_paymentsapi_client.models.update_payment_funding_account_minimal_request import UpdatePaymentFundingAccountMinimalRequest  # noqa: F401,E501


class UpdatePaymentRequest(object):
    """NOTE: 
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'comments': 'str',
        'custom_fields': 'dict(str, str)',
        'fee': 'FeeRequest',
        'amount': 'str',
        'card_cvv_number': 'str',
        'payment_date': 'str',
        'payment_request_date': 'str',
        'payment_amount_type': 'str',
        'funding_account': 'UpdatePaymentFundingAccountMinimalRequest'
    }

    attribute_map = {
        'comments': 'comments',
        'custom_fields': 'custom_fields',
        'fee': 'fee',
        'amount': 'amount',
        'card_cvv_number': 'card_cvv_number',
        'payment_date': 'payment_date',
        'payment_request_date': 'payment_request_date',
        'payment_amount_type': 'payment_amount_type',
        'funding_account': 'funding_account'
    }

    def __init__(self, comments=None, custom_fields=None, fee=None, amount=None, card_cvv_number=None, payment_date=None, payment_request_date=None, payment_amount_type=None, funding_account=None):  # noqa: E501
        """UpdatePaymentRequest - a model defined in Swagger"""  # noqa: E501

        self._comments = None
        self._custom_fields = None
        self._fee = None
        self._amount = None
        self._card_cvv_number = None
        self._payment_date = None
        self._payment_request_date = None
        self._payment_amount_type = None
        self._funding_account = None
        self.discriminator = None

        if comments is not None:
            self.comments = comments
        if custom_fields is not None:
            self.custom_fields = custom_fields
        if fee is not None:
            self.fee = fee
        if amount is not None:
            self.amount = amount
        if card_cvv_number is not None:
            self.card_cvv_number = card_cvv_number
        if payment_date is not None:
            self.payment_date = payment_date
        if payment_request_date is not None:
            self.payment_request_date = payment_request_date
        if payment_amount_type is not None:
            self.payment_amount_type = payment_amount_type
        if funding_account is not None:
            self.funding_account = funding_account

    def __getitem__(self,key):
        return getattr(self,key)

    @property
    def comments(self):
        """Gets the comments of this UpdatePaymentRequest.  # noqa: E501

        Comments that can be used to recollect the operation performed on the resource object.  # noqa: E501

        :return: The comments of this UpdatePaymentRequest.  # noqa: E501
        :rtype: str
        """
        return self._comments

    @comments.setter
    def comments(self, comments):
        """Sets the comments of this UpdatePaymentRequest.

        Comments that can be used to recollect the operation performed on the resource object.  # noqa: E501

        :param comments: The comments of this UpdatePaymentRequest.  # noqa: E501
        :type: str
        """
        self._comments = comments

    @property
    def custom_fields(self):
        """Gets the custom_fields of this UpdatePaymentRequest.  # noqa: E501

        The additional information or meta-information that EBPP can accept, maintain and transmit back to the client.   # noqa: E501

        :return: The custom_fields of this UpdatePaymentRequest.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._custom_fields

    @custom_fields.setter
    def custom_fields(self, custom_fields):
        """Sets the custom_fields of this UpdatePaymentRequest.

        The additional information or meta-information that EBPP can accept, maintain and transmit back to the client.   # noqa: E501

        :param custom_fields: The custom_fields of this UpdatePaymentRequest.  # noqa: E501
        :type: dict(str, str)
        """
        self._custom_fields = custom_fields

    @property
    def fee(self):
        """Gets the fee of this UpdatePaymentRequest.  # noqa: E501


        :return: The fee of this UpdatePaymentRequest.  # noqa: E501
        :rtype: FeeRequest
        """
        return self._fee

    @fee.setter
    def fee(self, fee):
        """Sets the fee of this UpdatePaymentRequest.


        :param fee: The fee of this UpdatePaymentRequest.  # noqa: E501
        :type: FeeRequest
        """
        self._fee = fee

    @property
    def amount(self):
        """Gets the amount of this UpdatePaymentRequest.  # noqa: E501

        The amount being paid.   # noqa: E501

        :return: The amount of this UpdatePaymentRequest.  # noqa: E501
        :rtype: str
        """
        return self._amount

    @amount.setter
    def amount(self, amount):
        """Sets the amount of this UpdatePaymentRequest.

        The amount being paid.   # noqa: E501

        :param amount: The amount of this UpdatePaymentRequest.  # noqa: E501
        :type: str
        """
        self._amount = amount

    @property
    def card_cvv_number(self):
        """Gets the card_cvv_number of this UpdatePaymentRequest.  # noqa: E501


        :return: The card_cvv_number of this UpdatePaymentRequest.  # noqa: E501
        :rtype: str
        """
        return self._card_cvv_number

    @card_cvv_number.setter
    def card_cvv_number(self, card_cvv_number):
        """Sets the card_cvv_number of this UpdatePaymentRequest.


        :param card_cvv_number: The card_cvv_number of this UpdatePaymentRequest.  # noqa: E501
        :type: str
        """
        self._card_cvv_number = card_cvv_number

    @property
    def payment_date(self):
        """Gets the payment_date of this UpdatePaymentRequest.  # noqa: E501

        The date on which the payment is scheduled to be made. It must be in ISO8601 full-date format, namely, YYYY-MM-DD.  # noqa: E501

        :return: The payment_date of this UpdatePaymentRequest.  # noqa: E501
        :rtype: str
        """
        return self._payment_date

    @payment_date.setter
    def payment_date(self, payment_date):
        """Sets the payment_date of this UpdatePaymentRequest.

        The date on which the payment is scheduled to be made. It must be in ISO8601 full-date format, namely, YYYY-MM-DD.  # noqa: E501

        :param payment_date: The payment_date of this UpdatePaymentRequest.  # noqa: E501
        :type: str
        """
        self._payment_date = payment_date

    @property
    def payment_request_date(self):
        """Gets the payment_request_date of this UpdatePaymentRequest.  # noqa: E501

        The date on which the biller wants the payment to be settled. It must be in ISO8601 full-date format, namely, YYYY-MM-DD.  # noqa: E501

        :return: The payment_request_date of this UpdatePaymentRequest.  # noqa: E501
        :rtype: str
        """
        return self._payment_request_date

    @payment_request_date.setter
    def payment_request_date(self, payment_request_date):
        """Sets the payment_request_date of this UpdatePaymentRequest.

        The date on which the biller wants the payment to be settled. It must be in ISO8601 full-date format, namely, YYYY-MM-DD.  # noqa: E501

        :param payment_request_date: The payment_request_date of this UpdatePaymentRequest.  # noqa: E501
        :type: str
        """
        self._payment_request_date = payment_request_date

    @property
    def payment_amount_type(self):
        """Gets the payment_amount_type of this UpdatePaymentRequest.  # noqa: E501

        The type of amount, as per the bill/statement, that is being paid. The payment amount is derived from the amount type selected for the payment. This defaults to other.  # noqa: E501

        :return: The payment_amount_type of this UpdatePaymentRequest.  # noqa: E501
        :rtype: str
        """
        return self._payment_amount_type

    @payment_amount_type.setter
    def payment_amount_type(self, payment_amount_type):
        """Sets the payment_amount_type of this UpdatePaymentRequest.

        The type of amount, as per the bill/statement, that is being paid. The payment amount is derived from the amount type selected for the payment. This defaults to other.  # noqa: E501

        :param payment_amount_type: The payment_amount_type of this UpdatePaymentRequest.  # noqa: E501
        :type: str
        """
        self._payment_amount_type = payment_amount_type

    @property
    def funding_account(self):
        """Gets the funding_account of this UpdatePaymentRequest.  # noqa: E501


        :return: The funding_account of this UpdatePaymentRequest.  # noqa: E501
        :rtype: UpdatePaymentFundingAccountMinimalRequest
        """
        return self._funding_account

    @funding_account.setter
    def funding_account(self, funding_account):
        """Sets the funding_account of this UpdatePaymentRequest.


        :param funding_account: The funding_account of this UpdatePaymentRequest.  # noqa: E501
        :type: UpdatePaymentFundingAccountMinimalRequest
        """
        self._funding_account = funding_account

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(UpdatePaymentRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UpdatePaymentRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
