# coding: utf-8

"""
    ############################################################################################
    ## This class subject to change without prior notice, Please dont use this class directly.##
    ############################################################################################
"""


import pprint
import re  # noqa: F401

import six

from orbipay_paymentsapi_client.models.funding_account_minimal_request import FundingAccountMinimalRequest  # noqa: F401,E501
from orbipay_paymentsapi_client.models.payment_schedule_minimal_request import PaymentScheduleMinimalRequest  # noqa: F401,E501


class UpdatePaymentSetupRequest(object):
    """NOTE: 
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'funding_account': 'FundingAccountMinimalRequest',
        'payment_schedule': 'PaymentScheduleMinimalRequest',
        'comments': 'str'
    }

    attribute_map = {
        'funding_account': 'funding_account',
        'payment_schedule': 'payment_schedule',
        'comments': 'comments'
    }

    def __init__(self, funding_account=None, payment_schedule=None, comments=None):  # noqa: E501
        """UpdatePaymentSetupRequest - a model defined in Swagger"""  # noqa: E501

        self._funding_account = None
        self._payment_schedule = None
        self._comments = None
        self.discriminator = None

        if funding_account is not None:
            self.funding_account = funding_account
        if payment_schedule is not None:
            self.payment_schedule = payment_schedule
        if comments is not None:
            self.comments = comments

    def __getitem__(self,key):
        return getattr(self,key)

    @property
    def funding_account(self):
        """Gets the funding_account of this UpdatePaymentSetupRequest.  # noqa: E501


        :return: The funding_account of this UpdatePaymentSetupRequest.  # noqa: E501
        :rtype: FundingAccountMinimalRequest
        """
        return self._funding_account

    @funding_account.setter
    def funding_account(self, funding_account):
        """Sets the funding_account of this UpdatePaymentSetupRequest.


        :param funding_account: The funding_account of this UpdatePaymentSetupRequest.  # noqa: E501
        :type: FundingAccountMinimalRequest
        """
        self._funding_account = funding_account

    @property
    def payment_schedule(self):
        """Gets the payment_schedule of this UpdatePaymentSetupRequest.  # noqa: E501


        :return: The payment_schedule of this UpdatePaymentSetupRequest.  # noqa: E501
        :rtype: PaymentScheduleMinimalRequest
        """
        return self._payment_schedule

    @payment_schedule.setter
    def payment_schedule(self, payment_schedule):
        """Sets the payment_schedule of this UpdatePaymentSetupRequest.


        :param payment_schedule: The payment_schedule of this UpdatePaymentSetupRequest.  # noqa: E501
        :type: PaymentScheduleMinimalRequest
        """
        self._payment_schedule = payment_schedule

    @property
    def comments(self):
        """Gets the comments of this UpdatePaymentSetupRequest.  # noqa: E501

        Comments that can be used to recollect the operation performed on the resource object.  # noqa: E501

        :return: The comments of this UpdatePaymentSetupRequest.  # noqa: E501
        :rtype: str
        """
        return self._comments

    @comments.setter
    def comments(self, comments):
        """Sets the comments of this UpdatePaymentSetupRequest.

        Comments that can be used to recollect the operation performed on the resource object.  # noqa: E501

        :param comments: The comments of this UpdatePaymentSetupRequest.  # noqa: E501
        :type: str
        """
        self._comments = comments

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(UpdatePaymentSetupRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UpdatePaymentSetupRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
