# coding: utf-8

from orbipay_paymentsapi_client.wrappers.base import Base
import six
import pprint
from orbipay_paymentsapi_client.orbipay_api_exception import OrbipayApiException

class FinalClass(type):
    def __new__(cls, name, bases, classdict):
        for b in bases:
            if isinstance(b, FinalClass):
                raise TypeError("type '{0}' is not an acceptable base type".format(b.__name__))
        return type.__new__(cls, name, bases, dict(classdict))
        

class Address(object):

    __metaclass__ = FinalClass
    
    swagger_types = {
        'address_line1': 'str',	
        'address_line2': 'str',	
        'address_city': 'str',	
        'address_state': 'str',	
        'address_country': 'str',	
        'address_zip1': 'str',	
        'address_zip2': 'str'	
    }    

    attribute_map = {
        'address_line1': 'address_line1', 
        'address_line2': 'address_line2', 
        'address_city': 'address_city', 
        'address_state': 'address_state', 
        'address_country': 'address_country', 
        'address_zip1': 'address_zip1', 
        'address_zip2': 'address_zip2' 
    }
    
    def __init__(self, address_line1=None, address_line2=None, address_city=None, address_state=None, address_country=None, address_zip1=None, address_zip2=None):
        super(Address, self).__init__()
        
        self._address_line1 = None
        self._address_line2 = None
        self._address_city = None
        self._address_state = None
        self._address_country = None
        self._address_zip1 = None
        self._address_zip2 = None
        
        self._address_line1 = address_line1
        self._address_line2 = address_line2
        self._address_city = address_city
        self._address_state = address_state
        self._address_country = address_country
        self._address_zip1 = address_zip1
        self._address_zip2 = address_zip2

    @property
    def address_line1(self):
        """Gets the address_line1 of this Address.  # noqa: E501
        Line one of the address.  # noqa: E501

        :return: The address_line1 of this Address. 
        :rtype: str
        """
        return self._address_line1

    @property
    def address_line2(self):
        """Gets the address_line2 of this Address.  # noqa: E501
        Line two of the address.  # noqa: E501

        :return: The address_line2 of this Address. 
        :rtype: str
        """
        return self._address_line2

    @property
    def address_city(self):
        """Gets the address_city of this Address.  # noqa: E501
        City of the address.  # noqa: E501

        :return: The address_city of this Address. 
        :rtype: str
        """
        return self._address_city

    @property
    def address_state(self):
        """Gets the address_state of this Address.  # noqa: E501
        The state or province code as per ISO_3166-2.  # noqa: E501

        :return: The address_state of this Address. 
        :rtype: str
        """
        return self._address_state

    @property
    def address_country(self):
        """Gets the address_country of this Address.  # noqa: E501
        The 3 letter country code as per ISO 3166-1 (alpha-3).  # noqa: E501

        :return: The address_country of this Address. 
        :rtype: str
        """
        return self._address_country

    @property
    def address_zip1(self):
        """Gets the address_zip1 of this Address.  # noqa: E501
        The first part of the postal code for the address as per the system followed in the appropriate country where it belongs.   # noqa: E501

        :return: The address_zip1 of this Address. 
        :rtype: str
        """
        return self._address_zip1

    @property
    def address_zip2(self):
        """Gets the address_zip2 of this Address.  # noqa: E501
        The 4 digit add-on code used, in addition to the 5 digit postal code, by the US Postal Service.  # noqa: E501

        :return: The address_zip2 of this Address. 
        :rtype: str
        """
        return self._address_zip2

    @staticmethod
    def __init_object(obj=None, invocation_context=None, live_mode=None, api_end_point=None, http_status_code=None, address_line1=None, address_line2=None, address_city=None, address_state=None, address_country=None, address_zip1=None, address_zip2=None):
        if obj is None:
            obj = Address()

        method = getattr(Base, '_' + 'Base' + '__init_object')
        if method is not None:
            obj = method(obj, invocation_context=invocation_context, live_mode=live_mode, api_end_point=api_end_point, http_status_code=http_status_code)

        if address_line1 is not None:
            obj._address_line1 = address_line1
        if address_line2 is not None:
            obj._address_line2 = address_line2
        if address_city is not None:
            obj._address_city = address_city
        if address_state is not None:
            obj._address_state = address_state
        if address_country is not None:
            obj._address_country = address_country
        if address_zip1 is not None:
            obj._address_zip1 = address_zip1
        if address_zip2 is not None:
            obj._address_zip2 = address_zip2
        return obj
    
    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}
        for attr, _ in six.iteritems(Address.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Address, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())
