# coding: utf-8

from orbipay_paymentsapi_client.wrappers.base import Base
import six
import pprint
from orbipay_paymentsapi_client.orbipay_api_exception import OrbipayApiException

class FinalClass(type):
    def __new__(cls, name, bases, classdict):
        for b in bases:
            if isinstance(b, FinalClass):
                raise TypeError("type '{0}' is not an acceptable base type".format(b.__name__))
        return type.__new__(cls, name, bases, dict(classdict))
        

class AuditInfo(object):

    __metaclass__ = FinalClass
    
    swagger_types = {
        'created': 'ResourceAudit',	
        'last_modified': 'ResourceAudit'	
    }    

    attribute_map = {
        'created': 'created', 
        'last_modified': 'last_modified' 
    }
    
    def __init__(self):
        super(AuditInfo, self).__init__()
        self._created = None
        self._last_modified = None

    @property
    def created(self):
        """Gets the created of this AuditInfo.  # noqa: E501

        :return: The created of this AuditInfo. 
        :rtype: ResourceAudit
        """
        return self._created

    @property
    def last_modified(self):
        """Gets the last_modified of this AuditInfo.  # noqa: E501

        :return: The last_modified of this AuditInfo. 
        :rtype: ResourceAudit
        """
        return self._last_modified

    @staticmethod
    def __init_object(obj=None, invocation_context=None, live_mode=None, api_end_point=None, http_status_code=None, created=None, last_modified=None):
        if obj is None:
            obj = AuditInfo()

        method = getattr(Base, '_' + 'Base' + '__init_object')
        if method is not None:
            obj = method(obj, invocation_context=invocation_context, live_mode=live_mode, api_end_point=api_end_point, http_status_code=http_status_code)

        if created is not None:
            obj._created = created
        if last_modified is not None:
            obj._last_modified = last_modified
        return obj
    
    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}
        for attr, _ in six.iteritems(AuditInfo.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(AuditInfo, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())
