# coding: utf-8

from orbipay_paymentsapi_client.wrappers.base import Base
import six
import pprint
from orbipay_paymentsapi_client.orbipay_api_exception import OrbipayApiException

class FinalClass(type):
    def __new__(cls, name, bases, classdict):
        for b in bases:
            if isinstance(b, FinalClass):
                raise TypeError("type '{0}' is not an acceptable base type".format(b.__name__))
        return type.__new__(cls, name, bases, dict(classdict))
        

class Customers(Base):

    __metaclass__ = FinalClass
    
    swagger_types = {
        'list': 'list[Customer]',	
        'total_results_count': 'str',	
        'has_more_results': 'str',	
        'url': 'str',	
        'from_index': 'str',	
        'to_index': 'str',	
        'query_id': 'str',	
        'page_size': 'str',	
        'customer_reference': 'str',	
        'ssn': 'str',	
        'email': 'str',	
        'account_number': 'str'	
    }    

    attribute_map = {
        'list': 'list', 
        'total_results_count': 'total_results_count', 
        'has_more_results': 'has_more_results', 
        'url': 'url', 
        'from_index': 'from_index', 
        'to_index': 'to_index', 
        'query_id': 'query_id', 
        'page_size': 'page_size', 
        'customer_reference': 'customer_reference', 
        'ssn': 'ssn', 
        'email': 'email', 
        'account_number': 'account_number' 
    }
    
    def __init__(self):
        super(Customers, self).__init__()
        self._list = None
        self._total_results_count = None
        self._has_more_results = None
        self._url = None
        self._from_index = None
        self._to_index = None
        self._query_id = None
        self._page_size = None
        self._customer_reference = None
        self._ssn = None
        self._email = None
        self._account_number = None

    @property
    def list(self):
        """Gets the list of this Customers.  # noqa: E501

        :return: The list of this Customers. 
        :rtype: list[Customer]
        """
        return self._list

    @property
    def total_results_count(self):
        """Gets the total_results_count of this Customers.  # noqa: E501
        The total number of customers available matching the search criteria.  # noqa: E501

        :return: The total_results_count of this Customers. 
        :rtype: str
        """
        return self._total_results_count

    @property
    def has_more_results(self):
        """Gets the has_more_results of this Customers.  # noqa: E501
        true if there are more results or pages  # noqa: E501

        :return: The has_more_results of this Customers. 
        :rtype: str
        """
        return self._has_more_results

    @property
    def url(self):
        """Gets the url of this Customers.  # noqa: E501
        This URL fetches the next or previous set of payments, based on the presence of after_object or before_object parameter.  # noqa: E501

        :return: The url of this Customers. 
        :rtype: str
        """
        return self._url

    @property
    def from_index(self):
        """Gets the from_index of this Customers.  # noqa: E501
        The id of the object before which the previous set of objects are to be retrieved.  # noqa: E501

        :return: The from_index of this Customers. 
        :rtype: str
        """
        return self._from_index

    @property
    def to_index(self):
        """Gets the to_index of this Customers.  # noqa: E501
        The id of the object after which the next set of objects are to be retrieved.  # noqa: E501

        :return: The to_index of this Customers. 
        :rtype: str
        """
        return self._to_index

    @property
    def query_id(self):
        """Gets the query_id of this Customers.  # noqa: E501
        The query id of the object.  # noqa: E501

        :return: The query_id of this Customers. 
        :rtype: str
        """
        return self._query_id

    @property
    def page_size(self):
        """Gets the page_size of this Customers.  # noqa: E501
        The maximum number of objects returned in the query.  # noqa: E501

        :return: The page_size of this Customers. 
        :rtype: str
        """
        return self._page_size

    @property
    def customer_reference(self):
        """Gets the customer_reference of this Customers.  # noqa: E501
        Unique ID assigned by the biller/client system for a given customer.  # noqa: E501

        :return: The customer_reference of this Customers. 
        :rtype: str
        """
        return self._customer_reference

    @property
    def ssn(self):
        """Gets the ssn of this Customers.  # noqa: E501
        The SSN of the customer if the account holder is an individual or the tax ID, if the customer is a business.  # noqa: E501

        :return: The ssn of this Customers. 
        :rtype: str
        """
        return self._ssn

    @property
    def email(self):
        """Gets the email of this Customers.  # noqa: E501
        This field contains the customer’s email address within EBPP.  # noqa: E501

        :return: The email of this Customers. 
        :rtype: str
        """
        return self._email

    @property
    def account_number(self):
        """Gets the account_number of this Customers.  # noqa: E501
        Customer Account Number of the customer to get details of.  # noqa: E501

        :return: The account_number of this Customers. 
        :rtype: str
        """
        return self._account_number

    def for_client(self, client_key=None):
        """
        :param client_key: The client_key is of type str.
        
        :return: The Instance of Customers. 
        :rtype: Customers
        """
        super(Customers, self).for_client(client_key)
        return self
    def vide_channel(self, channel=None):
        """
        :param channel: The channel is of type str.
        
        :return: The Instance of Customers. 
        :rtype: Customers
        """
        super(Customers, self).vide_channel(channel)
        return self
    def find_by(self, filter_parameters=None):
        if(filter_parameters):

            if(len(filter_parameters['customer_reference'])>0):
                self._customer_reference = filter_parameters['customer_reference'][0]

            if(len(filter_parameters['ssn'])>0):
                self._ssn = filter_parameters['ssn'][0]

            if(len(filter_parameters['email'])>0):
                self._email = filter_parameters['email'][0]

            if(len(filter_parameters['account_number'])>0):
                self._account_number = filter_parameters['account_number'][0]

            if(len(filter_parameters['page_size'])>0):
                self._page_size = filter_parameters['page_size'][0]

            if(len(filter_parameters['query_id'])>0):
                self._query_id = filter_parameters['query_id'][0]

            if(len(filter_parameters['from_index'])>0):
                self._from_index = filter_parameters['from_index'][0]

            if(len(filter_parameters['to_index'])>0):
                self._to_index = filter_parameters['to_index'][0]
        return self
    ## support methods
    def retrieved_by(self, requestor=None, requestor_type=None):
        """
        :param requestor: The requestor is of type str.
        :param requestor_type: The requestor_type is of type str.
        
        :return: The Instance of Customers. 
        :rtype: Customers
        """
        super(Customers, self).requested_by(requestor, requestor_type)
        return self
    ## support methods end
    def get(self, invocation_context=None, live_mode=None, api_end_point=None):
        """
        :param invocation_context: The invocation_context is of type str.
        :param live_mode: The live_mode is of type bool.
        :param api_end_point: The api_end_point is of type str.
        
        :return: The Instance of Customers. 
        :rtype: Customers
        """
        try:
            super(Customers, self)._with_context(invocation_context, live_mode, api_end_point)
            from orbipay_paymentsapi_client.handlers.retrieve_customers_handler import RetrieveCustomersHandler
            return RetrieveCustomersHandler().process(self)
        except OrbipayApiException as e:
            raise e
        except Exception as e:
            six.raise_from(OrbipayApiException(reason=e.message if hasattr(e, 'message') else None, args=e.args, http_status_code= "0"), e)

    def get_page(self, invocation_context=None, live_mode=None, api_end_point=None):
        """
        :param invocation_context: The invocation_context is of type str.
        :param live_mode: The live_mode is of type bool.
        :param api_end_point: The api_end_point is of type str.
        
        :return: The Instance of Customers. 
        :rtype: Customers
        """
        try:
            super(Customers, self)._with_context(invocation_context, live_mode, api_end_point)
            from orbipay_paymentsapi_client.handlers.retrieve_customers_page_handler import RetrieveCustomersPageHandler
            return RetrieveCustomersPageHandler().process(self)
        except OrbipayApiException as e:
            raise e
        except Exception as e:
            six.raise_from(OrbipayApiException(reason=e.message if hasattr(e, 'message') else None, args=e.args, http_status_code= "0"), e)

    @staticmethod
    def __init_object(obj=None, invocation_context=None, live_mode=None, api_end_point=None, http_status_code=None, list=None, total_results_count=None, has_more_results=None, url=None, from_index=None, to_index=None, query_id=None, page_size=None, customer_reference=None, ssn=None, email=None, account_number=None):
        if obj is None:
            obj = Customers()

        method = getattr(Base, '_' + 'Base' + '__init_object')
        if method is not None:
            obj = method(obj, invocation_context=invocation_context, live_mode=live_mode, api_end_point=api_end_point, http_status_code=http_status_code)

        if list is not None:
            obj._list = list
        if total_results_count is not None:
            obj._total_results_count = total_results_count
        if has_more_results is not None:
            obj._has_more_results = has_more_results
        if url is not None:
            obj._url = url
        if from_index is not None:
            obj._from_index = from_index
        if to_index is not None:
            obj._to_index = to_index
        if query_id is not None:
            obj._query_id = query_id
        if page_size is not None:
            obj._page_size = page_size
        if customer_reference is not None:
            obj._customer_reference = customer_reference
        if ssn is not None:
            obj._ssn = ssn
        if email is not None:
            obj._email = email
        if account_number is not None:
            obj._account_number = account_number
        return obj
    
    def to_dict(self):
        """Returns the model properties as a dict"""
        result = super(Customers, self).to_dict()
        for attr, _ in six.iteritems(Customers.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Customers, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())
