# coding: utf-8

from orbipay_paymentsapi_client.wrappers.base import Base
import six
import pprint
from orbipay_paymentsapi_client.orbipay_api_exception import OrbipayApiException

class FinalClass(type):
    def __new__(cls, name, bases, classdict):
        for b in bases:
            if isinstance(b, FinalClass):
                raise TypeError("type '{0}' is not an acceptable base type".format(b.__name__))
        return type.__new__(cls, name, bases, dict(classdict))
        

class Error(object):

    __metaclass__ = FinalClass
    
    swagger_types = {
        'code': 'str',	
        'message': 'str',	
        'field': 'str'	
    }    

    attribute_map = {
        'code': 'code', 
        'message': 'message', 
        'field': 'field' 
    }
    
    def __init__(self):
        super(Error, self).__init__()
        self._code = None
        self._message = None
        self._field = None

    @property
    def code(self):
        """Gets the code of this Error.  # noqa: E501
        A string indicating error  # noqa: E501

        :return: The code of this Error. 
        :rtype: str
        """
        return self._code

    @property
    def message(self):
        """Gets the message of this Error.  # noqa: E501
        A human-readable message providing more details about the error.  # noqa: E501

        :return: The message of this Error. 
        :rtype: str
        """
        return self._message

    @property
    def field(self):
        """Gets the field of this Error.  # noqa: E501
        Refers to the field in the request, if the error is specific to it.  # noqa: E501

        :return: The field of this Error. 
        :rtype: str
        """
        return self._field

    @staticmethod
    def __init_object(obj=None, invocation_context=None, live_mode=None, api_end_point=None, http_status_code=None, code=None, message=None, field=None):
        if obj is None:
            obj = Error()

        method = getattr(Base, '_' + 'Base' + '__init_object')
        if method is not None:
            obj = method(obj, invocation_context=invocation_context, live_mode=live_mode, api_end_point=api_end_point, http_status_code=http_status_code)

        if code is not None:
            obj._code = code
        if message is not None:
            obj._message = message
        if field is not None:
            obj._field = field
        return obj
    
    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}
        for attr, _ in six.iteritems(Error.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Error, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())
