# coding: utf-8

from orbipay_paymentsapi_client.wrappers.base import Base
import six
import pprint
from orbipay_paymentsapi_client.orbipay_api_exception import OrbipayApiException

class FinalClass(type):
    def __new__(cls, name, bases, classdict):
        for b in bases:
            if isinstance(b, FinalClass):
                raise TypeError("type '{0}' is not an acceptable base type".format(b.__name__))
        return type.__new__(cls, name, bases, dict(classdict))
        

class FeeRefund(object):

    __metaclass__ = FinalClass
    
    swagger_types = {
        'fee_refund_amount': 'str',	
        'fee_type': 'str'	
    }    

    attribute_map = {
        'fee_refund_amount': 'fee_refund_amount', 
        'fee_type': 'fee_type' 
    }
    
    def __init__(self, fee_refund_amount=None):
        super(FeeRefund, self).__init__()
        
        self._fee_refund_amount = None
        self._fee_type = None
        
        self._fee_refund_amount = fee_refund_amount

    @property
    def fee_refund_amount(self):
        """Gets the fee_refund_amount of this FeeRefund.  # noqa: E501
        The refunded fee amount upto 2 decimal places.  # noqa: E501

        :return: The fee_refund_amount of this FeeRefund. 
        :rtype: str
        """
        return self._fee_refund_amount

    @property
    def fee_type(self):
        """Gets the fee_type of this FeeRefund.  # noqa: E501
        The way the fee is being charged to the customer. Fee could be added to the amount being paid, or, it could be charged separately by the biller. The fee_type would default to add_to_principal if the fee is not configured for the client in EBPP.  # noqa: E501

        :return: The fee_type of this FeeRefund. 
        :rtype: str
        """
        return self._fee_type

    @staticmethod
    def __init_object(obj=None, invocation_context=None, live_mode=None, api_end_point=None, http_status_code=None, fee_refund_amount=None, fee_type=None):
        if obj is None:
            obj = FeeRefund()

        method = getattr(Base, '_' + 'Base' + '__init_object')
        if method is not None:
            obj = method(obj, invocation_context=invocation_context, live_mode=live_mode, api_end_point=api_end_point, http_status_code=http_status_code)

        if fee_refund_amount is not None:
            obj._fee_refund_amount = fee_refund_amount
        if fee_type is not None:
            obj._fee_type = fee_type
        return obj
    
    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}
        for attr, _ in six.iteritems(FeeRefund.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(FeeRefund, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())
