# coding: utf-8

import six
import pprint


class InvocationContext(object):

    swagger_types = {
        'client_key': 'str',    
        'product': 'str',    
        'trace_id': 'str',    
        'x_opay_headers': 'str',    
        'requestor_type': 'str',    
        'idempotent_request_key': 'str',    
        'request_uuid': 'str',    
        'channel': 'str',    
        'response_codes': 'str',    
        'response_text': 'str',    
        'requestor': 'str',    
        'timestamp': 'str',    
        'secret': 'String',    
        'api_key': 'String',    
        'auth_scheme': 'String'    
    }

    attribute_map = {
        'client_key': 'client_key', 
        'product': 'product', 
        'trace_id': 'trace_id', 
        'x_opay_headers': 'x_opay_headers', 
        'requestor_type': 'requestor_type', 
        'idempotent_request_key': 'idempotent_request_key', 
        'request_uuid': 'request_uuid', 
        'channel': 'channel', 
        'response_codes': 'response_codes', 
        'response_text': 'response_text', 
        'requestor': 'requestor', 
        'timestamp': 'timestamp', 
        'secret': 'secret', 
        'api_key': 'api_key', 
        'auth_scheme': 'auth_scheme' 
    }

    def __init__(self, secret=None, idempotent_request_key=None, x_opay_headers=None, api_key=None, auth_scheme=None, trace_id=None):
        self._client_key = None
        self._product = None
        self._trace_id = None
        self._x_opay_headers = None
        self._requestor_type = None
        self._idempotent_request_key = None
        self._request_uuid = None
        self._channel = None
        self._response_codes = None
        self._response_text = None
        self._requestor = None
        self._timestamp = None
        self._secret = None
        self._api_key = None
        self._auth_scheme = None

        self._product = "orbipay_payments"
        self._secret = secret
        self._idempotent_request_key = idempotent_request_key
        self._x_opay_headers = x_opay_headers
        self._api_key = api_key
        self._auth_scheme = auth_scheme
        self._trace_id = trace_id

    @property
    def client_key(self):
        return self._client_key
    
    @property
    def product(self):
        return self._product
    
    @property
    def trace_id(self):
        return self._trace_id
    
    @property
    def x_opay_headers(self):
        return self._x_opay_headers
    
    @property
    def requestor_type(self):
        return self._requestor_type
    
    @property
    def idempotent_request_key(self):
        return self._idempotent_request_key
    
    @property
    def request_uuid(self):
        return self._request_uuid
    
    @property
    def channel(self):
        return self._channel
    
    @property
    def response_codes(self):
        return self._response_codes
    
    @property
    def response_text(self):
        return self._response_text
    
    @property
    def requestor(self):
        return self._requestor
    
    @property
    def timestamp(self):
        return self._timestamp
    
    @property
    def secret(self):
        return self._secret
    
    @property
    def api_key(self):
        return self._api_key
    
    @property
    def auth_scheme(self):
        return self._auth_scheme
    
    @staticmethod
    def __init_object(obj=None, client_key=None, product=None, trace_id=None, x_opay_headers=None, requestor_type=None, idempotent_request_key=None, request_uuid=None, channel=None, response_codes=None, response_text=None, requestor=None, timestamp=None, secret=None, api_key=None, auth_scheme=None):
        if obj is None:
            obj = InvocationContext()

        if client_key is not None:
            obj._client_key = client_key
        if product is not None:
            obj._product = product
        if trace_id is not None:
            obj._trace_id = trace_id
        if x_opay_headers is not None:
            obj._x_opay_headers = x_opay_headers
        if requestor_type is not None:
            obj._requestor_type = requestor_type
        if idempotent_request_key is not None:
            obj._idempotent_request_key = idempotent_request_key
        if request_uuid is not None:
            obj._request_uuid = request_uuid
        if channel is not None:
            obj._channel = channel
        if response_codes is not None:
            obj._response_codes = response_codes
        if response_text is not None:
            obj._response_text = response_text
        if requestor is not None:
            obj._requestor = requestor
        if timestamp is not None:
            obj._timestamp = timestamp
        if secret is not None:
            obj._secret = secret
        if api_key is not None:
            obj._api_key = api_key
        if auth_scheme is not None:
            obj._auth_scheme = auth_scheme
        return obj
    
    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(InvocationContext, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())
