# coding: utf-8

from orbipay_paymentsapi_client.wrappers.base import Base
import six
import pprint
from orbipay_paymentsapi_client.orbipay_api_exception import OrbipayApiException

class FinalClass(type):
    def __new__(cls, name, bases, classdict):
        for b in bases:
            if isinstance(b, FinalClass):
                raise TypeError("type '{0}' is not an acceptable base type".format(b.__name__))
        return type.__new__(cls, name, bases, dict(classdict))
        

class PaymentNetworkResponse(object):

    __metaclass__ = FinalClass
    
    swagger_types = {
        'payment_auth_code': 'str',	
        'payment_response_code': 'str',	
        'payment_response_msg': 'str'	
    }    

    attribute_map = {
        'payment_auth_code': 'payment_auth_code', 
        'payment_response_code': 'payment_response_code', 
        'payment_response_msg': 'payment_response_msg' 
    }
    
    def __init__(self):
        super(PaymentNetworkResponse, self).__init__()
        self._payment_auth_code = None
        self._payment_response_code = None
        self._payment_response_msg = None

    @property
    def payment_auth_code(self):
        """Gets the payment_auth_code of this PaymentNetworkResponse.  # noqa: E501
        The Auth Code returned by the card gateway. This is relevant only for card payments.  # noqa: E501

        :return: The payment_auth_code of this PaymentNetworkResponse. 
        :rtype: str
        """
        return self._payment_auth_code

    @property
    def payment_response_code(self):
        """Gets the payment_response_code of this PaymentNetworkResponse.  # noqa: E501
        This is the ACH return code in the case of a returned payment over the NACHA ACH network. In the case of declined card payment, it's the decline code received from the card issuer or the card processor. In the case of a card chargeback, it's the chargeback code received from the card network.  # noqa: E501

        :return: The payment_response_code of this PaymentNetworkResponse. 
        :rtype: str
        """
        return self._payment_response_code

    @property
    def payment_response_msg(self):
        """Gets the payment_response_msg of this PaymentNetworkResponse.  # noqa: E501
        The text describing the appropriate code captured in the payment_response_code as received from the corresponding payment network.  # noqa: E501

        :return: The payment_response_msg of this PaymentNetworkResponse. 
        :rtype: str
        """
        return self._payment_response_msg

    @staticmethod
    def __init_object(obj=None, invocation_context=None, live_mode=None, api_end_point=None, http_status_code=None, payment_auth_code=None, payment_response_code=None, payment_response_msg=None):
        if obj is None:
            obj = PaymentNetworkResponse()

        method = getattr(Base, '_' + 'Base' + '__init_object')
        if method is not None:
            obj = method(obj, invocation_context=invocation_context, live_mode=live_mode, api_end_point=api_end_point, http_status_code=http_status_code)

        if payment_auth_code is not None:
            obj._payment_auth_code = payment_auth_code
        if payment_response_code is not None:
            obj._payment_response_code = payment_response_code
        if payment_response_msg is not None:
            obj._payment_response_msg = payment_response_msg
        return obj
    
    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}
        for attr, _ in six.iteritems(PaymentNetworkResponse.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PaymentNetworkResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())
