# coding: utf-8

from orbipay_paymentsapi_client.wrappers.base import Base
import six
import pprint
from orbipay_paymentsapi_client.orbipay_api_exception import OrbipayApiException

class FinalClass(type):
    def __new__(cls, name, bases, classdict):
        for b in bases:
            if isinstance(b, FinalClass):
                raise TypeError("type '{0}' is not an acceptable base type".format(b.__name__))
        return type.__new__(cls, name, bases, dict(classdict))
        

class ResourceAudit(object):

    __metaclass__ = FinalClass
    
    swagger_types = {
        'channel': 'str',	
        'requestor_type': 'str',	
        'requestor': 'str',	
        'timestamp': 'str'	
    }    

    attribute_map = {
        'channel': 'channel', 
        'requestor_type': 'requestor_type', 
        'requestor': 'requestor', 
        'timestamp': 'timestamp' 
    }
    
    def __init__(self):
        super(ResourceAudit, self).__init__()
        self._channel = None
        self._requestor_type = None
        self._requestor = None
        self._timestamp = None

    @property
    def channel(self):
        """Gets the channel of this ResourceAudit.  # noqa: E501
        The channel through which the API is invoked. Please contact <a href = \"mailto: support@billerpayments.com\">support@billerpayments.com</a> to configure channels.  # noqa: E501

        :return: The channel of this ResourceAudit. 
        :rtype: str
        """
        return self._channel

    @property
    def requestor_type(self):
        """Gets the requestor_type of this ResourceAudit.  # noqa: E501
        If an API is being requested from an application that is being used directly by a customer, like the customer portal and IVR, the requestor_type should be set to \"customer\".</br> If an API is being requested from an application that is being used by third party agents/brokers servicing a customer on behalf of a biller/client, then the requestor_type should be set to \"external_user\". It should be noted that these users would not have logins for the EBPP Portal or Payment Center.  # noqa: E501

        :return: The requestor_type of this ResourceAudit. 
        :rtype: str
        """
        return self._requestor_type

    @property
    def requestor(self):
        """Gets the requestor of this ResourceAudit.  # noqa: E501
        The identifier for the requestor of the API, in EBPP. The value to be passed in the requestor field would depend on the requestor_type.</br> If the requestor_type is \"customer\", the requestor should be the EBPP generated customer id. In the case of self registration, where there is no EBPP generated customer id yet, the requestor should be set to 'guest'.</br> If the requestor_type is \"external_user\", the requestor can be any unique identifier that the client may have for the external agent.   # noqa: E501

        :return: The requestor of this ResourceAudit. 
        :rtype: str
        """
        return self._requestor

    @property
    def timestamp(self):
        """Gets the timestamp of this ResourceAudit.  # noqa: E501
        The UTC timestamp, in ISO8601 format, for the moment when the resource got created or modified in EBPP. For e.g., 2019-08-13T09:21:34.359+0000  # noqa: E501

        :return: The timestamp of this ResourceAudit. 
        :rtype: str
        """
        return self._timestamp

    @staticmethod
    def __init_object(obj=None, invocation_context=None, live_mode=None, api_end_point=None, http_status_code=None, channel=None, requestor_type=None, requestor=None, timestamp=None):
        if obj is None:
            obj = ResourceAudit()

        method = getattr(Base, '_' + 'Base' + '__init_object')
        if method is not None:
            obj = method(obj, invocation_context=invocation_context, live_mode=live_mode, api_end_point=api_end_point, http_status_code=http_status_code)

        if channel is not None:
            obj._channel = channel
        if requestor_type is not None:
            obj._requestor_type = requestor_type
        if requestor is not None:
            obj._requestor = requestor
        if timestamp is not None:
            obj._timestamp = timestamp
        return obj
    
    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}
        for attr, _ in six.iteritems(ResourceAudit.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ResourceAudit, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())
