# coding: utf-8

from orbipay_paymentsapi_client.wrappers.base import Base
import six
import pprint
from orbipay_paymentsapi_client.orbipay_api_exception import OrbipayApiException

class FinalClass(type):
    def __new__(cls, name, bases, classdict):
        for b in bases:
            if isinstance(b, FinalClass):
                raise TypeError("type '{0}' is not an acceptable base type".format(b.__name__))
        return type.__new__(cls, name, bases, dict(classdict))
        

class SourcePayment(object):

    __metaclass__ = FinalClass
    
    swagger_types = {
        'id': 'str',	
        'url': 'str',	
        'customer': 'Customer',	
        'customer_account': 'CustomerAccount',	
        'funding_account': 'FundingAccount'	
    }    

    attribute_map = {
        'id': 'id', 
        'url': 'url', 
        'customer': 'customer', 
        'customer_account': 'customer_account', 
        'funding_account': 'funding_account' 
    }
    
    def __init__(self):
        super(SourcePayment, self).__init__()
        self._id = None
        self._url = None
        self._customer = None
        self._customer_account = None
        self._funding_account = None

    @property
    def id(self):
        """Gets the id of this SourcePayment.  # noqa: E501

        :return: The id of this SourcePayment. 
        :rtype: str
        """
        return self._id

    @property
    def url(self):
        """Gets the url of this SourcePayment.  # noqa: E501
        This URL fetches the details of source payment.  # noqa: E501

        :return: The url of this SourcePayment. 
        :rtype: str
        """
        return self._url

    @property
    def customer(self):
        """Gets the customer of this SourcePayment.  # noqa: E501

        :return: The customer of this SourcePayment. 
        :rtype: Customer
        """
        return self._customer

    @property
    def customer_account(self):
        """Gets the customer_account of this SourcePayment.  # noqa: E501

        :return: The customer_account of this SourcePayment. 
        :rtype: CustomerAccount
        """
        return self._customer_account

    @property
    def funding_account(self):
        """Gets the funding_account of this SourcePayment.  # noqa: E501

        :return: The funding_account of this SourcePayment. 
        :rtype: FundingAccount
        """
        return self._funding_account

    @staticmethod
    def __init_object(obj=None, invocation_context=None, live_mode=None, api_end_point=None, http_status_code=None, id=None, url=None, customer=None, customer_account=None, funding_account=None):
        if obj is None:
            obj = SourcePayment()

        method = getattr(Base, '_' + 'Base' + '__init_object')
        if method is not None:
            obj = method(obj, invocation_context=invocation_context, live_mode=live_mode, api_end_point=api_end_point, http_status_code=http_status_code)

        if id is not None:
            obj._id = id
        if url is not None:
            obj._url = url
        if customer is not None:
            obj._customer = customer
        if customer_account is not None:
            obj._customer_account = customer_account
        if funding_account is not None:
            obj._funding_account = funding_account
        return obj
    
    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}
        for attr, _ in six.iteritems(SourcePayment.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(SourcePayment, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())
